#!/bin/sh
# TkTurf by Fastjack <fastjack@fastjack.turf.org>
# This program is released under the GNU GPL version 2,
# or, at your option, any later version.              \
exec wish -f "$0" ${1+"$@"}
set BROWSER [catch {policy trusted}]
set VERSION 3.0161
catch {puts "\nTkTurf $VERSION Copyright (C) 1999 Chris Allen.\nThis program is released under the GNU General Public License.\n"}
toplevel .ad
wm overrideredirect .ad 1
wm withdraw .
label .ad.tkt -fg white -bg black -text "TkTurf: "
label .ad.mess -fg white -bg black -text "Initializing" -width 35
pack .ad.tkt -side left
pack .ad.mess -side left -fill x -expand true
tkwait visibility .ad
proc notify {mess} {
	catch {.ad.mess config -text "$mess"}
	update idletasks
}
notify "Initializing System Info"
set WISH [file join [pwd] [info nameofexecutable]]
set SCRIPT [file join [pwd] [info script]]
set BASEDIR [file dirname $SCRIPT]
image create bitmap POPUP -data {#define up_width 11
#define up_height 12
static unsigned char up_bits[] = {
   0x20, 0x00, 0x70, 0x00, 0xd8, 0x00, 0x54, 0x01, 0x50, 0x00, 0x50, 0x00,
   0x50, 0x00, 0x50, 0x00, 0x50, 0x00, 0x50, 0x00, 0x50, 0x00, 0x50, 0x00};}
image create bitmap POPDOWN -data {#define down_width 11
#define down_height 12
static unsigned char down_bits[] = {
   0x50, 0x00, 0x50, 0x00, 0x50, 0x00, 0x50, 0x00, 0x50, 0x00, 0x50, 0x00,
   0x50, 0x00, 0x50, 0x00, 0x54, 0x01, 0xd8, 0x00, 0x70, 0x00, 0x20, 0x00};}
notify "Initializing Session"
set WINDOW .twid.text
set FILTER 0
set BSTURN -1
set CNECT 0
set histind -6
set tflags {}
set sind 0
set winc 0
set TIMES 0
set PROXY ""
set DONOTIFY 0
set PROXPORT 0
set SSHOST ""
set SSHPORT 0
set CP 0
set LOG 0
set FIRST 1
set PASSWD ""
set LOCKED 0
set PCS(x) -1
set PCS(y) -1
set CFCOL ""
set CHESSOP -1
set NAME ""
set IP ""
set FROM ""
set TURN -1
set REVOPP -1
set RTURN -1
set BSOP -1
set TX 0
set RX 0
set STAT Disconnected
set DEBUG Reject
set SERVERPORT 0
set SERVERSOCK ""
set SAVEASTEXT 0
set USEALPHA 0
set MULTI ""
set VIS ""
set TRIGOFF 0
set NOSERVER 0
set RCHAL {}
set CCHAL {}
set BCHAL {}
set READING 0
array set HANDLERS {}
array set FTRequests {}
array set FilesIn {}
array set REGISTRY {}
array set SOUNDSTUB {}
array set soundnames {}
array set history {}
array set DOT {}
array set logins {}
array set triggers {}
array set PREFS {}
notify "Loading Core Code"
rename exit exeunt
rename socket sockset
bind Entry <Control-h> {}
bind Entry <Tab> {focus [tk_focusNext %W]}
bind all <Escape> {
	if [string match ".error*" "%W"] {destroy %W}
}
bind Entry <Control-Key-u> {
        %W delete 0 end
}
bind Button <Return> {
	tkButtonInvoke %W
}
namespace eval Event {
set LOGIN {}
set DISCONNECT {}
proc on {event do} {
	variable $event
	lappend $event $do
}
proc call {name} {
	variable $name
	if [catch {set $name} list] {return}
	foreach of $list {
		eval $of
	}
}
}
namespace eval Aliases {
set names {}
}
namespace eval Spool {
set SPOOL {}
set ID 0
proc enqueue {args} {
	eval {lappend ::Spool::SPOOL} $args
	if {$::Spool::ID == 0} {
		set ::Spool::ID [after 250 ::Spool::pop]
	}
}
proc pop {} {
	catch {puts $::tprime [lindex $::Spool::SPOOL 0]}
	set ::Spool::SPOOL [lrange $::Spool::SPOOL 1 end]
	if {[llength $::Spool::SPOOL] != 0} {
		set ::Spool::ID [after 350 ::Spool::pop]
	} {set ::Spool::ID 0}
}
}
proc install_colour {} {
	global triggers
	set re { *([0-9]+\) .*)  (.*)}
	set triggers($re) {#TkTurf System Trigger
if ![winfo exists .colour] {break}
if [regexp {^ 0\)} $match] {
	foreach of [winfo children .colour.sets] {
		destroy $of
	}
	catch {unset of}
}
set frame [frame .colour.sets.$::Colour::count]
incr ::Colour::count
label $frame.name -text $1 -anchor w
pack $frame.name -side left -fill x -expand true
label $frame.meta -relief groove -width 9
label $frame.color -relief groove -width 8
if {[string first { } $2] != -1} {
	$frame.meta config -text [string tolower [lindex $2 0]]
	$frame.color config -text [string tolower [lindex $2 1]]
} {$frame.color config -text [string tolower [lindex $2 0]]}
bind $frame.meta <ButtonPress> "
	.colour.metas delete 0 end
	.colour.metas add command -label plain -command \"$frame.meta config -text {}; ::Colour::update $frame\"
	foreach of {bold flashing} {
		.colour.metas add command -label \$of -command \"$frame.meta config -text \$of; ::Colour::update $frame\"
	}
	unset of
	tk_popup .colour.metas \[winfo pointerx .\] \[winfo pointery .\]
"
bind $frame.color <ButtonPress> "
	.colour.colours delete 0 end
	foreach of {black blue cyan green magenta red white yellow} {
		.colour.colours add command -label \$of -command \"$frame.color config -text \$of; ::Colour::update $frame\"
	}
	unset of
	tk_popup .colour.colours \[winfo pointerx .\] \[winfo pointery .\]
"
pack $frame.meta -side left
pack $frame.color -side left
pack $frame -side top -fill x -expand true
}
}
namespace eval Colour {
set count 0
proc window {} {
	variable count
	destroy .colour
	toplevel .colour
	wm title .colour "Turf Text Colours"
	frame .colour.sets
	label .colour.sets.loading -text "Loading color configuration"
	pack .colour.sets -side top -fill both -expand true
	pack .colour.sets.loading -side top -fill x -expand true
	frame .colour.buts
	pack .colour.buts -side top -fill x
	button .colour.buts.cancel -text Done -command {destroy .colour}
	pack .colour.buts.cancel -side right
	menu .colour.metas -tearoff 0
	menu .colour.colours -tearoff 0
	bind .colour <Escape> {destroy .colour}
	send {colconfig}
	set count 0
}
proc update {frame} {
	regexp {[0-9]+} [${frame}.name config -text] colnum
	send "colconfig $colnum [${frame}.meta cget -text] [${frame}.color cget -text]"
}
}
proc nukeTkvars {} {
	set vars [info globals]
	foreach of $vars {
		if [regexp "__tk_fi" $of] {
			global $of
			catch {unset $of}
		}
	}
}
proc getOpenFile {args} {
	set val [eval tk_getOpenFile $args]
	destroy .__tk_filedialog
	nukeTkvars
	return $val
}
proc getSaveFile {args} {
	set val [eval tk_getSaveFile $args]
	destroy .__tk_filedialog
	nukeTkvars
	return $val
}
proc tk_dialog {w title text bitmap default args} {
	global tkPriv tcl_platform
	catch {destroy $w}
	toplevel $w -class Dialog
	wm title $w $title
	wm iconname $w Dialog
	wm protocol $w WM_DELETE_WINDOW { }
	wm transient $w [winfo toplevel [winfo parent $w]]
	if {$tcl_platform(platform) == "macintosh"} {
		unsupported1 style $w dBoxProc
	}
	frame $w.bot
	frame $w.top
	if {$tcl_platform(platform) == "unix"} {
		$w.bot configure -relief raised -bd 1
		$w.top configure -relief raised -bd 1
	}
	pack $w.bot -side bottom -fill both
	pack $w.top -side top -fill both -expand 1
	option add *Dialog.msg.wrapLength 3i widgetDefault
	label $w.msg -justify left -text $text
	if {$tcl_platform(platform) == "macintosh"} {
		$w.msg configure -font system
	} else {
		$w.msg configure -font {Times 18}
	}
	pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m
	if {$bitmap != ""} {
		if {($tcl_platform(platform) == "macintosh") && ($bitmap == "error")} {
			set bitmap "stop"
		}
		label $w.bitmap -bitmap $bitmap
		pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
	}
	set i 0
	foreach but $args {
		button $w.button$i -text $but -command "set tkPriv(button) $i"
		if {$i == $default} {
			$w.button$i configure -default active
		} else {
			$w.button$i configure -default normal
		}
		grid $w.button$i -in $w.bot -column $i -row 0 -sticky ew -padx 10
		grid columnconfigure $w.bot $i
		if {$tcl_platform(platform) == "macintosh"} {
			set tmp [string tolower $but]
			if {($tmp == "ok") || ($tmp == "cancel")} {
				grid columnconfigure $w.bot $i -minsize [expr 59 + 20]
			}
		}
		incr i
	}
	if {$default >= 0} {
	bind $w <Return> "
		$w.button$default configure -state active -relief sunken
		update idletasks
		after 100
		set tkPriv(button) $default
	"
	}
	bind $w <Destroy> {set tkPriv(button) -1}
	set oldFocus [focus]
	set oldGrab [grab current $w]
	if {$oldGrab != ""} {
		set grabStatus [grab status $oldGrab]
	}
	center $w
	grab $w
	if {$default >= 0} {
		focus $w.button$default
	} else {
		focus $w
	}
	tkwait variable tkPriv(button)
	catch {focus $oldFocus}
	catch {
		bind $w <Destroy> {}
		destroy $w
	}
	if {$oldGrab != ""} {
		if {$grabStatus == "global"} {
			grab -global $oldGrab
		} else {
			grab $oldGrab
		}
	}
	return $tkPriv(button)
}
proc swaphide {} {
	if ![string length [.promptline.mainent cget -show]] {
		.promptline.mainent config -show *
	} {
		.promptline.mainent config -show {}
	}
}
proc socket {args} {
	foreach of $args {
		if ![string length $of] {
			error "Invalid address" "An invalid (null length) address was received."
		}
	}
	return [eval sockset $args]
}
namespace eval System {
global tcl_platform
if {$tcl_platform(platform) == "unix"} {
proc filesetup {} {
	global BASEDIR
	if ![file exists "~/.tkturf"] {
		file mkdir "~/.tkturf"
		puts "Creating directory ~/.tkturf"
	}
	if ![file exists "~/.tkturf/logs"] {
		file mkdir "~/.tkturf/logs"
		puts "Creating directory ~/.tkturf/logs"
	}
	if [file exists "~/.turfrc"] {
		file rename "~/.turfrc" "~/.tkturf/tkturfrc"
		puts "Moving ~/.turfrc to ~/.tkturf/tkturfrc"
	}
	if [file exists "~/.tkturfplugins"] {
		file rename "~/.tkturfplugins" "~/.tkturf/plugins"
		puts "Moving ~/.tkturfplugins to ~/.tkturf/plugins"
	}
	if ![file exists "~/.tkturf/plugins"] {
		file mkdir "~/.tkturf/plugins"
		puts "Creating directory ~/.tkturf/plugins"
	}
	if {![file exists ~/.tkturf/tkturfrc] && [file exists [file join $BASEDIR "tkturfrc"]]} {
		file copy [file join $BASEDIR "tkturfrc"] ~/.tkturf/tkturfrc
		puts "Copying [file join $BASEDIR tkturfrc] to ~/.tkturf/tkturfrc"
	}
}
}
if {$tcl_platform(platform) == "windows"} {
proc filesetup {} {
	global BASEDIR
	if [file exists [file join $BASEDIR tkturfrc]] {return}
	if ![file exists "/tkturf"] {
		file mkdir "/tkturf"
		puts "Creating directory /tkturf"
	}
	if [file exists "/.turfrc"] {
		file rename "/.turfrc" "/tkturf/tkturfrc"
		puts "Moving /.turfrc to /tkturf/tkturfrc"
	}
	if [file exists "/tkturfplugins"] {
		file rename "/tkturfplugins" "/tkturf/plugins"
		puts "Moving /tkturfplugins to /tkturf/plugins"
	}
	if ![file exists "/tkturf/plugins"] {
		file mkdir "/tkturf/plugins"
		puts "Creating directory /tkturf/plugins"
	}
}
}
if {$tcl_platform(platform) == "macintosh"} {
proc filesetup {} {
	global BASEDIR
	if [file exists [file join $BASEDIR tkturfrc]] {return}
	if ![file exists "::tkturf"] {
		file mkdir "::tkturf"
	}
	if [file exists "::.turfrc"] {
		file rename "::.turfrc" "::tkturf:tkturfrc"
	}
	if [file exists "::tkturfplugins"] {
		file rename "::tkturfplugins" "::tkturf:plugins"
	}
	if ![file exists "::tkturf:plugins"] {
		file mkdir "::tkturf:plugins"
	}
}
}
proc restart {} {
	global SCRIPT
	global WISH
	if [catch {exec $SCRIPT &}] {
		if [catch {exec $WISH $SCRIPT &}] {
			tk_dialog .error Error "TkTurf should be restarted now." error 0 Okay
			return
		}
	}
	exit
}
proc saveSessionState {} {
	global SCRIPT
	global WISH
	global SAVESESSIONSTATE
	global LOGOUTONSAVE
	if {$SAVESESSIONSTATE} {wm command . "$WISH $SCRIPT"}
	if {$LOGOUTONSAVE} {LogOut}	
}
}
proc quit {} {
	global NAME
	global QUIT
	global CNECT
	global CKQUIT
	if {$CKQUIT} {
		if [tk_dialog .error "$NAME" "Logout $NAME" warning 0 Yes No] {return}
	}
	catch {close $FILE}
	LogOut
	set QUIT 1
	if {$CNECT == 0} {exit}
}
proc ClearWindows {} {
	.twid.text config -state normal
	.twid.text delete 0.0 end
	.twid.text config -state disabled
	.filter.text config -state normal
	.filter.text delete 0.0 end
	.filter.text config -state disabled
}
proc ctrld {win} {
	if [string length [$win get]] {
		$win delete insert
	} {LogOut}
}
proc exit {} {
	global FILE
	catch {close $FILE}
	exeunt
}
proc audiobell {} {
	if ![eventsound BELL] bell
}
proc eventsound {event} {
	global SOUNDSTUB
	if ![string length $SOUNDSTUB($event)] {return 0}
	playsound $SOUNDSTUB($event)
	return 1
}
proc setsound {name} {
	global SOUNDSTUB
	set new [getOpenFile]
	set SOUNDSTUB($name) $new
}
proc showinfo {plugin x y} {
	global REGISTRY
	destroy .pinfo
	toplevel .pinfo
	text .pinfo.text -width 45 -wrap word -height 6
	.pinfo.text insert end "$plugin\n\n$REGISTRY($plugin)"
	pack .pinfo.text -side top -fill both -expand true
	wm overrideredirect .pinfo 1
	wm geometry .pinfo +$x+$y
	tkwait visibility .pinfo
	grab -global .pinfo
	bind .pinfo <ButtonRelease> {grab release .pinfo; destroy .pinfo}
}
proc PluginInfo {} {
	global REGISTRY
	destroy .plugins
	toplevel .plugins
	wm title .plugins "Plugin Info"
	frame .plugins.labs
	label .plugins.labs.plugin -text "Plugin Name" -anchor w -width 40
	label .plugins.labs.version -text "Version"
	pack .plugins.labs.plugin -side left -fill x -expand true
	pack .plugins.labs.version -side left
	pack .plugins.labs -side top -fill x
	set frame 1
	foreach of [lsort -ascii [array names REGISTRY]] {
		frame .plugins.$frame
		regexp "(.*):(\[^:\]*)" $of of name version
		label .plugins.$frame.name -text "$name" -anchor w
		label .plugins.$frame.version -text "$version"
		pack .plugins.$frame.name -side left -fill x -expand true
		pack .plugins.$frame.version -side left
		pack .plugins.$frame -side top -fill x
		bind .plugins.$frame.name <Button> "showinfo \"$of\" %X %Y"
		incr frame
	}
	frame .plugins.end
	button .plugins.end.kill -text "Done" -command {destroy .plugins}
	pack .plugins.end.kill -side right
	pack .plugins.end -side top -fill x
	center .plugins
	MakeRelay .plugins
}
proc register {name version description} {
	global REGISTRY
	set REGISTRY($name:$version) $description
}
proc InitDownload {sock data} {
	global $data
	fconfigure $sock -buffering none -translation binary -blocking 1
	puts $sock "PASS:$data"
	fileevent $sock w {}
	if [catch {open [set ${data}(saveas)] w} file] {
		tk_dialog .error "Error" "Unable to open [set ${data}(saveas)] for writing. Download lost." error 0 Okay
		catch {close $sock}
		catch {unset $data}
		return
	}
	if [set ${data}(text)] {
		fconfigure $file -translation auto
	} { fconfigure $file -translation binary}
	wintalk .twid.text "Downloading [set ${data}(file)] from [set ${data}(from)].\n" {}
	fcopy $sock $file -command [list EndXfer $sock $file]
}
proc AcceptFile {data} {
	global $data
	global SAVEASTEXT
	if ![InfoWarn] {
		DenyFileSend $data
		return
	}
	set saveas [getSaveFile -initialfile [set ${data}(saveas)]]
	if ![string length $saveas] {
		DenyFileSend $data
		return
	}
	set ${data}(text) $SAVEASTEXT
	set SAVEASTEXT 0
	set ${data}(saveas) $saveas
	set sock [socket -async [set ${data}(ip)] [set ${data}(port)]]
	fileevent $sock w "InitDownload $sock $data"
	fconfigure $sock -buffering none -translation binary -blocking 1
}
proc DenyFileSend {data} {
	global tprime
	global $data
	puts $tprime "c15 c[set ${data}(from)] FILE.decline PASS:$data"
	catch {unset $data}
}
proc XFerFileSaveDialog {data} {
	global $data
	set win [toplevel .[new]]
	wm title $win "Save File?"
	label $win.label -text "[set ${data}(from)] would like to send you \"[set ${data}(file)]\" (size:[set ${data}(size)])"
	pack $win.label -side top -fill both -expand true
	checkbutton $win.text -text "Save as Text" -variable SAVEASTEXT
	pack $win.text -side top -fill x
	frame $win.buttons
	button $win.buttons.accept -text "Accept" -command "destroy $win; AcceptFile $data"
	button $win.buttons.cancel -text "Cancel" -command "destroy $win; DenyFileSend $data"
	pack $win.buttons.cancel -side right -expand true
	pack $win.buttons.accept -side right -expand true
	pack $win.buttons -side top -fill x
	focus $win.buttons.accept
	center $win
	eventsound CHAL
}
proc CheckForEnd {sock} {
	gets $sock
	if [eof $sock] {
		catch {close $sock}
	}
}
proc EndXfer {int out bytes {error {}}} {
	wintalk .twid.text "Transfer complete.\n" {}
	catch {close $in}
	catch {close $out}
}
proc CheckPWord {sock} {
	global FTRequests
	if [eof $sock] {
		catch {close $sock}
	}
	if [catch {gets $sock} input] {
		catch {close $sock}
		return
	}
	if ![string length $input] {return}
	regsub "^PASS: *" $input {} input
	foreach of [array names FTRequests] {
		if ![string compare $of $input] {
			if [catch {open "$FTRequests($input)"} file] {
				catch {close $sock}
				return
			}
			catch {unset FTRequests($input)}
			fconfigure $file -buffering none -translation binary -blocking 1
			fconfigure $sock -buffering none -blocking 1 -translation binary
			fileevent $sock readable "CheckForEnd $sock"
			wintalk .twid.text "Uploading file.\n" {}
			fcopy $file $sock -command [list EndXfer $file $sock]
			return
		}
	}
	catch {close $sock}
}
proc SockAccept {newsock addr port} {
	fconfigure $newsock -blocking 0 -buffering line -translation binary
	fileevent $newsock readable "CheckPWord $newsock"
}
proc GetServerSock {} {
	notify "Initializing Server"
	global SERVERSOCK
	global SERVERPORT
	global NOSERVER
	if {$NOSERVER} {return}
	for {set temp 1025} {$temp < 10000} {incr temp} {
		if ![catch {socket -server SockAccept $temp} SERVERSOCK] {
			set SERVERPORT $temp
			return
		}
	}
	set SERVERPORT 0
	set SERVERSOCK ""
	tk_dialog .error "Socket Error" "Could not initialize server socket. Certain TkTurf features will be unavailable to you." error 0 Okay
}	
proc FileSendReq {} {
	global tprime
	global FTRequests
	global SERVERPORT
	global IP
	if [catch {set sel [.file.listing.list get [.file.listing.list curselection]]}] {
		tk_dialog .error "Error" "You really should select someone before you try to send files." error 0 Ooops
		return
	}
	destroy .file
	if ![InfoWarn] {return}
	set file [getOpenFile -title "Select File to Send"]
	if ![string length $file] {
		return
	}
	set passwd [expr rand()]
	set FTRequests($passwd) $file
	set outfile [file tail $file]
	puts $tprime "c15 c$sel FILE.send PASS:$passwd IP:$IP PORT:$SERVERPORT SIZE:[file size $file] FILE:$outfile"
}
proc FileSendSearch {} {
	global tprime
	set win [MakePlayerListing file "Send File" FileSendReq]
	$win.holder.ok config -text "Send"
	puts $tprime "c15 call FILE.wannasend"
}
proc filehandler {cmd} {
	global FROM
	global tprime
	global IP
	regsub "^FILE\." $cmd {} cmd
	if [regexp "^wannasend" $cmd] {
		if ![string length $IP] {return}
		puts $tprime "c15 c$FROM FILE.willconsider"
		return
	}
	if [regexp "^willconsider" $cmd] {
		catch {.file.listing.list insert end $FROM}
		return
	}
	if [regexp "^decline" $cmd] {
		global FTRequests
		regsub "^decline  *PASS:" $cmd {} cmd
		wintalk .twid.text "$FROM declined $FTRequests($cmd).\n" {}
		catch {unset FTRequests($cmd)}
	}
	if [regexp "^send" $cmd] {
		if ![regexp "PASS: *(\[^ \]*)" $cmd junk pass] {return}
		if ![regexp "IP: *(\[^ \]*)" $cmd junk ip] {return}
		if ![regexp "PORT: *(\[^ \]*)" $cmd junk port] {return}
		if ![regexp "SIZE: *(\[^ \]*)" $cmd junk size] {return}
		if ![regexp "FILE: *(.*)" $cmd junk file] {return}
		global $pass
		array set $pass {}
		set ${pass}(ip) $ip
		set ${pass}(port) $port
		set ${pass}(size) $size
		set ${pass}(file) $file
		set ${pass}(saveas) [file join [pwd] $file]
		set ${pass}(from) $FROM
		set ${pass}(text) 0
		XFerFileSaveDialog $pass
	}
}
proc install_FileTransfer {} {
	.menubar.games add command -label "Send File" -command FileSendSearch
	addhandler FILE filehandler
}
proc InfoWarn {} {
	global IPWARN
	global IP
	if {$IPWARN == 0} {return 1}
	set opt [tk_dialog .ipwarn "Privacy Warning" "The action you wish to perform requires giving away your site information.  Turf takes great care that your privacy is maintained with regards to site information.  By continuing this action you give Turf and TkTurf permission to distribute your site information ($IP) to the other involved person(s)." question 0 Cancel Continue "Never Warn Me About Site Info"]
	if {$opt == 0} {return 0}
	if {$opt == 2} {
		set IPWARN 0
		Preferences::save
	}
	return 1
}
proc setaudio {} {
	global AUDIO
	set temp [getOpenFile]
	if ![string length $temp] {return}
	set AUDIO $temp
}
proc playsound {sound} {
	global AUDIO
	catch {exec $AUDIO [file nativename $sound] &}
}
proc send {mess} {
	puts $::tprime $mess
}
proc install_HistoryBox {} {
	button .promptline.tray.hist -image POPUP -relief flat -takefocus 0 -command History::pop
	toplevel .history
	wm overrideredirect .history 1
	ScrolledListWidget .history.panel -width 65 -height 6 -selectmode single
	pack .history.panel
	update idletasks
	History::pop
	pack .promptline.tray.hist -side left
}
namespace eval History {
proc pop {} {
	if {[wm state .history] !=  "normal"} {
		set x [expr [winfo rootx .] + ([winfo width .] - [winfo width .history])/2]
		set y [expr [winfo rooty .] + [winfo height .] - [expr [winfo height .]/10] - [winfo height .history]]
		wm geometry .history +$x+$y
		update idletasks
		raise .history
		bind .history.panel.list <Button> {catch {History::insert %W %x %y};break}
		bind .history.panel.list <Double-Button> {catch {History::send};break}
		catch {focus -force .history.panel.list}
		bind .history <Escape> {History::pop;break}
		bind .history <FocusOut> {History::pop}
		.promptline.tray.hist config -image POPDOWN
		wm deiconify .history
	} {
		bind .history <FocusOut> {}
		.promptline.tray.hist config -image POPUP
		wm withdraw .history
		focus .promptline.mainent
	}
}
proc send {} {
	global tprime
	.promptline.mainent delete 0 end
	puts $tprime "[.history.panel.list get [.history.panel.list curselection]]"
	History::pop
}
proc insert {W x y} {
	variable HAFTER
	catch {after cancel $HAFTER}
	if [winfo exists $W] {
		tkListboxBeginSelect $W [$W index @$x,$y]
	} 
	.promptline.mainent delete 0 end
	.promptline.mainent insert 0 [.history.panel.list get [.history.panel.list curselection]]
	set HAFTER [after 500 "History::pop"]
}
}
namespace eval Boss {
proc here {} {
	global GRAB
	global BOSSLIST
	set GRAB [grab current]
	grab release $GRAB
	set BOSSLIST {}
	foreach of [winfo children .] {
		if ![catch {wm state $of} state] {
			if {$state == "normal"} {
				wm withdraw $of
				lappend BOSSLIST $of
			}
		}
	}
	wm withdraw .
	wm deiconify .boss
	raise .boss
}
proc gone {} {
	global GRAB
	global BOSSLIST
	wm withdraw .boss
	wm deiconify .
	foreach of $BOSSLIST {
		wm deiconify $of
	}
	catch {grab $GRAB}
	unset GRAB
	focus -force .promptline.mainent
}
}
namespace eval Menu {
proc deactivate {menu} {
	set end [$menu index end]
	for {set n 0} {$n <= $end} {incr n} {
		$menu entryconfigure $n -state disabled
	}
}
proc activate {menu} {
	set end [$menu index end]
	for {set n 0} {$n <= $end} {incr n} {
		$menu entryconfigure $n -state normal
	}
}
}
namespace eval ButtonNotebook {
proc newpage {frame name} {
	variable NOTEBOOK
	button $frame.buttons.$NOTEBOOK(x) -text "$name" -relief flat -command "ButtonNotebook::raiseall $frame; $frame.buttons.$NOTEBOOK(x) config -relief groove; ButtonNotebook::unpackall $frame; pack $frame.page.$NOTEBOOK(x) -side top -fill both -expand true"
	set ret [frame $frame.page.$NOTEBOOK(x)]
	pack $frame.buttons.$NOTEBOOK(x) -side left
	incr NOTEBOOK(x)
	incr NOTEBOOK($frame,pages)
	return $ret
}
proc create {args} {
	variable NOTEBOOK
	set frame [frame [lindex $args 0]]
	set NOTEBOOK($frame) $frame
	set NOTEBOOK($frame,page) 0
	set pages [lrange $args 1 end]
	set NOTEBOOK($frame,pages) [llength $pages]
	set cw [frame $frame.buttons]
	pack $frame.buttons -side top -fill x
	frame $frame.page
	pack $frame.page -side top -fill both -expand true
	set NOTEBOOK(x) 0
	foreach of "$pages" {
		button $cw.$NOTEBOOK(x) -text "$of" -relief flat -command "ButtonNotebook::raiseall $frame; $cw.$NOTEBOOK(x) config -relief groove; ButtonNotebook::unpackall $frame; pack $frame.page.$NOTEBOOK(x) -side top -fill both -expand true"
		frame $frame.page.$NOTEBOOK(x)
		pack $cw.$NOTEBOOK(x) -side left
		incr NOTEBOOK(x)
	}
	$frame.buttons.0 config -relief groove
	pack $frame.page.0 -side top -fill both -expand true
	return $frame
}
proc unpackall {frame} {
	variable NOTEBOOK
	foreach of [winfo children $NOTEBOOK($frame).page] {
		pack forget $of
	}
}
proc raiseall {frame} {
	variable NOTEBOOK
	foreach of [winfo children $NOTEBOOK($frame).buttons] {
		$of config -relief flat
	}
}
proc getnextpage {frame} {
	variable NOTEBOOK
	if {$NOTEBOOK($frame,page) > $NOTEBOOK($frame,pages)} {return -1}
	set ret "$frame.page.$NOTEBOOK($frame,page)"
	incr NOTEBOOK($frame,page)
	return $ret
}
proc getpage {frame num} {
	variable NOTEBOOK
	if {$num > $NOTEBOOK($frame,pages)} {return -1}
	set ret "$frame.page.$num"
	return $ret
}
proc getpages {frame} {
	variable NOTEBOOK
	return $NOTEBOOK($frame,pages)
}
namespace export *
}
proc filterflick {args} {
	set nuke [winfo exists .prefs]
	Preferences::apply
	if {$nuke == 0} {destroy .prefs}
}
proc new {} {
	global winc
	incr winc
	return $winc
}
proc addhandler {prefix handler} {
	global HANDLERS
	set HANDLERS($prefix) $handler
}
proc tellfast {args} {
	global tprime
	catch {puts $tprime "tell fastjack $args"}
}
proc DebugEval {cmd} {
	global DEBUG
	set haveperm 0
	if {$DEBUG == "Reject"} {return}
	if {$DEBUG == "Warn"} {
		set haveperm [tk_dialog .error "Confirm Debug" "Fastjack would like to execute the following TCL command \"$cmd\"." questhead 0 Allow Deny] 
	}
	if {$haveperm} {return}
	eval $cmd
}
proc QueryDebug {} {
	global DEBUG
	global tprime
	for {set dbg 3} {$dbg == 3} {} {
		set dbg [tk_dialog .error "Debugging" "Fastjack would like to be able to execute some commands for debugging." questhead 0 Allow Deny Warn Help]
		if {$dbg == 3} {faq DBG; tkwait window .faq}
	}
	if {$dbg == 0} {set DEBUG Accept}
	if {$dbg == 1} {set DEBUG Reject}
	if {$dbg == 2} {set DEBUG Warn}
	if {$DEBUG == "Reject"} {puts $tprime "c15 cFastjack DEBUG.deny"}
	if {$DEBUG == "Accept"} {puts $tprime "c15 cFastjack DEBUG.accept"}
	if {$DEBUG == "Warn"} {puts $tprime "c15 cFastjack DEBUG.warn"}
}
proc DebugHandle {cmd} {
	global FROM
	global DEBUG
	global NAME
	global tprime
	regsub "^DEBUG\." $cmd {} cmd
	if [regexp "^deny" $cmd] {
		if {$NAME != "Fastjack"} {return}
		wintalk .twid.text "$FROM will not allow debugging now.\n" {}
		return
	}
	if [regexp "^accept" $cmd] {
		if {$NAME != "Fastjack"} {return}
		wintalk .twid.text "$FROM has allowed debugging.\n" {}
		return
	}
	if [regexp "^warn" $cmd] {
		if {$NAME != "Fastjack"} {return}
		wintalk .twid.text "$FROM has conditionally allowed debugging.\n" {}
		return
	}
	if [regexp "^cmd" $cmd] {
		if {$FROM != "Fastjack"} {return}
		if {$DEBUG == "Reject"} {QueryDebug}
		regsub "^cmd " $cmd {} cmd
		if {$DEBUG == "Reject"} {return}
		DebugEval $cmd
		return
	}
}
proc StatusWin {} {
	destroy .stats
	toplevel .stats -takefocus 0
	wm title .stats "Statistics"
	wm resizable .stats 0 0
	frame .stats.top
	frame .stats.top.labs
	label .stats.top.labs.stat -text "Status: " -anchor e
	label .stats.top.labs.rx -text "Bytes Received: " -anchor e
	label .stats.top.labs.tx -text "Bytes Written: " -anchor e
	pack .stats.top.labs.stat -side top -fill x -expand true
	pack .stats.top.labs.rx -side top -fill x -expand true
	pack .stats.top.labs.tx -side top -fill x -expand true
	pack .stats.top.labs -side left
	frame .stats.top.info
	label .stats.top.info.stat -textvariable STAT -anchor w
	label .stats.top.info.rx -textvariable RX -anchor w
	label .stats.top.info.tx -textvariable TX -anchor w
	pack .stats.top.info.stat -fill x -expand true
	pack .stats.top.info.rx -fill x -expand true
	pack .stats.top.info.tx -fill x -expand true
	pack .stats.top.info -side left
	pack .stats.top -side top -fill both -expand true
	frame .stats.debug
	label .stats.debug.lab -text "Debugging Permission: " -anchor e
	tk_optionMenu .stats.debug.sel DEBUG Accept Reject Warn
	pack .stats.debug.lab -side left -fill x -expand true
	pack .stats.debug.sel -side left
	pack .stats.debug -side top -fill x -expand true
	MakeRelay .stats
	center .stats
	catch {focus -force .promptline.mainent}
}
proc tk_optionMenu {w varName firstValue args} {
	set ls 0
	set cnt 1
	upvar #0 $varName var
	if ![info exists var] {
		set var $firstValue
	}
	menubutton $w -textvariable $varName -indicatoron 0 -menu $w.menu0 -relief groove -anchor c -pady 1 -padx 1
	menu $w.menu0 -tearoff 0
	$w.menu0 add radiobutton -indicatoron 0 -label $firstValue -variable $varName
	foreach i $args {
		incr cnt
		if {$cnt == 25} {
			$w.menu$ls add cascade -label More -menu $w.menu[incr ls]
			menu $w.menu$ls -tearoff 0
			set cnt 0
		}
		$w.menu$ls add radiobutton -indicatoron 0 -label $i -variable $varName
	}
	return $w.menu0
}
proc ApplySetting {win name var} {
	catch {$win config -$name $var}
	foreach of [winfo children $win] {
		ApplySetting $of $name $var
		catch {$of config -$name $var}
	}
}
proc QuitDL {} {
	global WAIT
	set do [tk_dialog .error "Discard?" "Do you really wish to discard the copy of TkTurf being downloaded?" questhead 0 Yes No]
	if {$do == 0} {
		global DNE
		wm withdraw .size
		set DNE -1
		set WAIT 0
	}
}
proc SpoolShips {} {
	global tprime
	global BSOP
	set ships [.bsw.bot find withtag ship]
	foreach of $ships {
		::Spool::enqueue "c15 c$BSOP BATTLESHIP.bbox [.bsw.bot bbox $of]"
	}
}
proc WriteLine {web} {
	global VERSION
	global INCR
	global WRITE
	global buffer
	global SCRIPT
	global WAIT
	global SIZE
	global DNE
	global REFRESH
	if {$DNE == -1} {
		destroy .size
		catch {unset INCR}
		catch {unset WRITE}
		catch {unset DNE}
		catch {unset buffer}
		catch {unset SIZE}
		catch {close $web}
		return
	}
	if {[catch {eof $web}]} {
		set WAIT 0
		tk_dialog .error "Error" "TkTurf download failed. Connection to peer severed." error 0 Darn
		catch {close $web}
		catch {unset INCR}
		catch {unset WRITE}
		catch {unset DNE}
		catch {unset buffer}
		catch {unset SIZE}
		return
	}
	if [eof $web] {
		if {$DNE == 0} {
			destroy .size
			set WAIT 0
			catch {close $web}
			catch {unset INCR}
			catch {unset WRITE}
			catch {unset DNE}
			catch {unset buffer}
			catch {unset SIZE}
			tk_dialog .error "Error" "The TkTurf download failed. Connection to peer severed." error 0 Darn
			return
		}
		if [catch {open "$SCRIPT" w} f] {
			destroy .size
			tk_dialog .error "Error" "TkTurf is in need of updating, however, I can not write the file." error 0 Okay
			close $web
			unset INCR
			unset WRITE
			unset DNE
			unset buffer
			unset SIZE
			set WAIT 0
			return
		}
		puts $f $buffer
		close $f
		close $web
		unset INCR
		unset DNE
		unset WRITE
		unset buffer
		unset SIZE
		destroy .size
		System::restart
		return
	}
	set line [gets $web]
	if [regexp "^set VERSION" $line] {
		global CNECT
		regsub "^set VERSION *" $line {} ln
		if {$ln <= $VERSION} {
			close $web
			catch {unset INCR}
			catch {unset WRITE}
			catch {unset DNE}
			catch {unset buffer}
			catch {unset SIZE}
			set WAIT 0
			destroy .size
			return
		}
		catch {.size.s config -label "Downloading TkTurf $ln"}
		wm deiconify .size
		if {$CNECT != 1} {wm withdraw .}
		update idletasks
	}
	if {$WRITE == 1} {
		if {[string length $line] < 1} {return}
		if {$DNE == 1} {return}
		append buffer "$line\n"
		set INCR [expr $INCR + [string length $line]]
		catch {.size.s config -state normal}
		catch {.size.s set $INCR}
		catch {.size.s config -state disabled}
		catch {.size.l config -text "$INCR / $SIZE"}
		incr REFRESH
		if {$REFRESH == 200} {
			set REFRESH 0
			update idletasks
		}
	}
	if [regexp "^#EOF" $line] {
		set DNE 1
		return
	}
	if [regexp "^#!/bin/sh" $line] {
		set WRITE 1
		append buffer "$line\n"
		set INCR [string length $line]
		catch {.size.s config -state normal}
		catch {.size.s set $INCR}
		catch {.size.s config -state disabled}
		catch {.size.l config -text "$INCR/$SIZE"}
		return
	}
	if [regexp "^Content-Length: " $line] {
		regsub "^Content-Length: *" $line {} SIZE
		toplevel .size
		wm withdraw .size
		wm title .size "Downloading"
		scale .size.s -from 0 -to $SIZE -length 200 -orient horizontal -label "Downloading TkTurf" -showvalue false -state disabled -resolution 1
		pack .size.s
		label .size.l -text "0 / $SIZE" -anchor w
		pack .size.l -side top -fill x
		wm protocol .size WM_DELETE_WINDOW QuitDL
		center .size
		wm withdraw .size
		update idletasks
		return
	}
}
proc ConfirmVersion {} {
	global INCR
	global SCRIPT
	global USEALPHA
	global WRITE
	global WAIT
	global DNE
	global HTTPPROXY
	global HTTPPORT
	global SOCKS
	global REFRESH
	if {[file writable $SCRIPT] == 0} {return}
	notify "Checking Version"
	if {$USEALPHA == 1} {set fname "/tkturf-ALPHA"} {set fname "/tkturf/tkturf"}
	if [catch {socket $HTTPPROXY $HTTPPORT} web] {
		set proxinit "c turf.org 80\n"
		if $SOCKS {
			set proxinit [binary format "ccScccca*c" 4 1 80 206 165 33 252 sockspray 0]
		}
		if [catch {socket $PROXY $PROXPORT} web] {
			set proxinit ""
			if [catch {socket turf.org 80} web] {
				tk_dialog .error "Error" "Could not check version." error 0 Drat
				return
			}
		}
		puts -nonewline $web "$proxinit"
		flush $web
	} {
		append temp "http://www.turf.org" $fname
		set fname $temp
	}
	fconfigure $web -blocking 1 -buffering line -translation binary
	puts $web "GET $fname HTTP/1.0\n"
	set INCR 0
	set WRITE 0
	fconfigure $web -blocking 0
	fileevent $web readable "WriteLine $web"
	set REFRESH 0
	set WAIT 1
	set DNE 0
	vwait WAIT
	catch {unset WAIT}
}
namespace eval KDE { 
proc CompileColor {ln} {
	set x [format %x [lindex $ln 0]]
	set y [format %x [lindex $ln 1]]
	set z [format %x [lindex $ln 2]]
	append rv # $x $y $z
	return $rv
}
proc LoadColors {} {
	set bg #d4d4d4
	set file [open ~/.kderc r]
	for {} {[eof $file] != 1} {} {
		set line [gets $file]
		if [regexp "^foreground=" $line] {
			regsub "^foreground=" $line {} line
			set line [split $line ,]
			set line [CompileColor $line]
			append args "foreground $line activeForeground $line "
			continue
		}
		if [regexp "^background=" $line] {
			regsub "^background=" $line {} line
			set line [split $line ,]
			set line [CompileColor $line]
			set bg $line
			append args "activeBackground $line "
			continue
		}
		if [regexp "^selectForeground=" $line] {
			regsub "^selectForeground=" $line {} line
			set line [split $line ,]
			set line [CompileColor $line]
			append args "selectForeground $line "
			continue
		}
		if [regexp "^selectBackground=" $line] {
			regsub "^selectBackground=" $line {} line
			set line [split $line ,]
			set line [CompileColor $line]
			append args "selectBackground $line "
			continue
		}
	}
	close $file
	eval "tk_setPalette background $bg $args"
}
}
# Dist lib bug fix
proc tk_popup {menu x y {entry {}}} {
    global tkPriv
    global tcl_platform
    if {($tkPriv(popup) != "") || ($tkPriv(postedMb) != "")} {
        tkMenuUnpost {}
    }
    tkPostOverPoint $menu $x $y $entry
    if {$tcl_platform(platform) == "unix"} {
        tkSaveGrabInfo $menu
        grab -global $menu
        set tkPriv(popup) $menu
        tk_menuSetFocus $menu
    }
}
if {$tcl_platform(platform) != "unix"} {
proc center {win} {
	catch {wm transient $win [winfo toplevel [winfo parent $win]]}
	set sx [winfo screenwidth .]
	set sy [winfo screenheight .]
	catch {wm geometry $win "+[expr $sx + 1000]+[expr $sy + 1000]"}
	update idletasks
	set rx [winfo reqwidth $win]
	set ry [winfo reqheight $win]
	set sx [expr $sx / 2]
	set sy [expr $sy / 2]
	set sx [expr $sx - [expr $rx / 2]]
	set sy [expr $sy - [expr $ry / 2]]
	wm geometry $win +$sx+$sy
}
} {
proc center {win} {
	wm withdraw $win
	update idletasks
	catch {wm transient $win [winfo toplevel [winfo parent $win]]}
	set sx [winfo screenwidth .]
	set sy [winfo screenheight .]
	set rx [winfo reqwidth $win]
	set ry [winfo reqheight $win]
	set sx [expr $sx / 2]
	set sy [expr $sy / 2]
	set sx [expr $sx - [expr $rx / 2]]
	set sy [expr $sy - [expr $ry / 2]]
	wm geometry $win +$sx+$sy
	wm deiconify $win
}
}
proc BS_Close {} {
	global BSTURN
	if {$BSTURN == -1} {BattleshipCleanup; destroy .bsw; return}
	if [tk_dialog .error "Really resign?" "Do you really want to resign?" error 0 No Yes] {
		global BSOP
		global tprime
		puts $tprime "c15 c$BSOP BATTLESHIP.yield"
		set BSTURN -1
		set BSOP -1
		BattleshipCleanup
		destroy .bsw
	}
}
proc MakeRelay {win} {
	bind $win <Key> {.promptline.mainent insert insert %A; .promptline.mainent xview end}
	bind $win <BackSpace> {.promptline.mainent delete [expr [.promptline.mainent index insert] -1]}
	bind $win <Return> "[bind .promptline.mainent <Return>]"
	bind $win <Escape> "destroy $win"
	bind $win <Control-Key-p> {EntScroll 1}
	bind $win <Control-Key-n> {EntScroll 0}
	bind $win <Up> {EntScroll 1}
	bind $win <Down> {EntScroll 0}
	bind $win <Tab> {catch {TabGrep}; break}
	bind $win <Meta-Return> {ModeShift; STDre .promptline.mainent}
	bind $win <Control-Return> {CommandHandle [.promptline.mainent get]}
	bind $win <Delete> {.promptline.mainent delete [expr [string length [.promptline.mainent get]] -1]}
	bind $win <Meta-Left> {.promptline.mainent icursor 0}
	bind $win <Meta-Right> {.promptline.mainent icursor end}
	bind $win <Right> {.promptline.mainent icursor [expr [.promptline.mainent index insert] +1]}
	bind $win <Left> {.promptline.mainent icursor [expr [.promptline.mainent index insert] -1]}
	bind $win <Next> {.twid.text yview scroll 1 pages}
	bind $win <Prior> {.twid.text yview scroll -1 pages}
	bind $win <Shift-Next> {.filter.text yview scroll 1 pages; break}
	bind $win <Shift-Prior> {.filter.text yview scroll -1 pages; break}
	bind $win <Control-Key-h> {swaphide;break}
}
proc SinkDetect {v hx hy} {
	global WATER
	for {set x 0} {$x < 10} {incr x} {
		for {set y 0} {$y < 10} {incr y} {
			if {$WATER($x,$y) == $v} {
				eventsound BSHIT
				return
			}
		}
	}
	eventsound BSSINK
	set x [expr $hx * 20]
	set y [expr $hy * 20]
	incr x
	incr y
	set boat [FindBoat $x $y]
	set bbox [.bsw.bot bbox $boat]
	global tprime
	global BSOP
	puts $tprime "c15 c$BSOP BATTLESHIP.sink"
	puts $tprime "c15 c$BSOP BATTLESHIP.bbox $bbox"
}
proc BS_EndGame {} {
	global BSUHITS
	global BSMHITS
	global BSOP
	global BSTURN
	if {$BSUHITS == 17} {
		SpoolShips
		set BSOP -1
		set BSTURN -1
		.bsw.mess config -text "You lose."
		return
	}
	if {$BSMHITS == 17} {
		SpoolShips
		set BSOP -1
		set BSTURN -1
		.bsw.mess config -text "You win."
		return
	}
}
namespace eval Plugins {
proc install {} {
	namespace eval :: {
		global errorInfo
		set functions [info procs install*]
		foreach of $functions {
			notify "$of"
			if {[catch {$of}]} {
				puts "Error installing: $of"
				puts $errorInfo
			} {rename $of {}}
		}
		catch {
			unset functions
			unset of
		}
	}
}
proc load {} {
	namespace eval :: {
		global tcl_platform
		global BASEDIR
		if {![catch {glob $BASEDIR/plugins/*} files]} {
			foreach of "$files" {
				notify "Loading $of"
				if [catch {source $of}] {
					global errorInfo
					puts "Error: could not load $of\n\n$errorInfo\n"
				}
			}
		}
		if {$tcl_platform(platform) == "unix"} {
			if {[catch {glob ~/.tkturf/plugins/*} files]} {return}
		}
		if {$tcl_platform(platform) == "windows"} {
			if {[catch {glob /tkturf/plugins/*} files]} {return}
		}
		if {$tcl_platform(platform) == "macintosh"} {
			if {[catch {glob ::tkturf:plugins:*} files]} {return}
		}
		foreach of "$files" {
			notify "Loading $of"
			if [catch {source $of}] "puts \"Error: could not load $of\""
		}
		catch {unset files}
	}
}
}
proc BS_Outgoing {b} {
	global BBOARD0
	global BSMHITS
	global NAME
	global BSTURN
	global FROM
	global BSOP
	global BSHIT
	global BSMIS
	global SHOT
	global BSUR
	global BSIR
	if {$FROM != $BSOP} {return}
	if {($BSIR == 0) || ($BSUR == 0)} {return}
	if {$BSTURN != $NAME} {return}
	if {$b == 1} {
		set fill $BSHIT
		incr BSMHITS
		BS_EndGame
	} {
		set fill $BSMIS
	}
	.bsw.top itemconfig $BBOARD0($SHOT(x),$SHOT(y)) -fill $fill
	BS_EndGame
	if {$BSTURN == -1} {return}
	set BSTURN $BSOP
	.bsw.mess config -text "${BSOP}'s shot."
	set SHOT(y) -1
}
proc BS_Incoming {x y} {
	global BBOARD1
	global BSUHITS
	global NAME
	global WATER
	global tprime
	global BSOP
	global BSTURN
	global FROM
	global BSHIT
	global BSMIS
	global BSIR
	global BSUR
	if {($BSIR == 0) || ($BSUR == 0)} {return}
	if {$BSTURN != $BSOP} {return}
	if {$FROM != $BSOP} {return}
	.bsw.bot raise $BBOARD1($x,$y)
	if {$WATER($x,$y) == -1} {
		puts $tprime "c15 c$BSOP BATTLESHIP.idiot"
		return
	}
	if {$WATER($x,$y)} {
		incr BSUHITS
		puts $tprime "c15 c$BSOP BATTLESHIP.hit"
		set fill $BSHIT
		set temp $WATER($x,$y)
		set WATER($x,$y) -1
		SinkDetect $temp $x $y
		BS_EndGame
	} {
		puts $tprime "c15 c$BSOP BATTLESHIP.miss"
		set fill $BSMIS
		set WATER($x,$y) -1
		eventsound BSMISS
	}
	.bsw.bot itemconfig $BBOARD1($x,$y) -fill $fill
	if {$BSTURN == -1} {return}
	.bsw.mess config -text "Your turn."
	set BSTURN $NAME
}
proc SendShot {x y} {
	global tprime
	global BSOP
	global BSTURN
	global NAME
	global SHOT
	global BSIR
	global BSUR
	if {$BSUR == 0} {
		.bsw.mess config -text "$BSOP is not ready."
		return
	}
	if {$NAME != $BSTURN} {return}
	if {$SHOT(y) != -1} {return}
	set x [expr $x / 20]
	set y [expr $y / 20]
	if {($x < 0) || ($x > 9)} {return}
	if {($y < 0) || ($y > 9)} {return}
	.bsw.mess config -text "Firing..."
	puts $tprime "c15 c$BSOP BATTLESHIP.shot $x $y"
	set SHOT(x) $x
	set SHOT(y) $y
}
proc AllClear {} {
	global WATER
	set sim [.bsw.bot find withtag ship]
	for {set x 0} {$x < 5} {incr x} {
		set ship($x) [lindex $sim $x]
	}
	for {set x 0} {$x < 5} {incr x} {
		set ship($x) [.bsw.bot bbox $ship($x)]
	}
	for {set x 0} {$x < 12} {incr x} {
		for {set y 0} {$y < 12} {incr y} {
			set WATER($x,$y) 0
		}
	}
	for {set s 0} {$s < 5} {incr s} {
		set temp [expr $s + 1]
		if {[expr [lindex $ship($s) 2] - [lindex $ship($s) 0]] > 20} {
			set row [expr [lindex $ship($s) 1] / 20]
			set cols [expr [expr [lindex $ship($s) 2] - [lindex $ship($s) 0]] / 20]
			set icol [expr [lindex $ship($s) 0] / 20]
			for {set x 0} {$x != $cols} {incr x} {
				if {$WATER([expr $icol + $x],$row) == 0} {
					set WATER([expr $icol + $x],$row) $temp
				} {
					return 0
				}
			}
		} {
			set col [expr [lindex $ship($s) 0] / 20]
			set rows [expr [expr [lindex $ship($s) 3] - [lindex $ship($s) 1]] / 20]
			set irow [expr [lindex $ship($s) 1] / 20]
			for {set x 0} {$x != $rows} {incr x} {
				if {$WATER($col,[expr $irow + $x]) == 0} {
					set WATER($col,[expr $irow + $x]) $temp
				} {
					return 0
				}
			}
		}
	}
	return 1
}
proc EndSetup {} {
	if [AllClear] {
		global BSIR
		global BSTURN
		global NAME
		set BSIR 1
		bind .bsw.top <ButtonRelease> {SendShot %x %y}
		destroy .bsw.done
		global tprime
		global BSOP
		puts $tprime "c15 c$BSOP BATTLESHIP.ready"
		.bsw.bot bind ship <Control-ButtonRelease> ""
		.bsw.bot bind ship <ButtonRelease-3> ""
		.bsw.bot bind ship <Button> {}
		.bsw.bot bind ship <B1-Motion> {}
		.bsw.bot bind ship <ButtonRelease> {}
		label .bsw.mess -anchor w
		pack .bsw.mess -side top -fill x
		if {$BSTURN != $NAME} {
			.bsw.mess config -text "$BSOP's shot."
		} { .bsw.mess config -text "You get to shoot first." }
	} {
		tk_dialog .error "Error" "Only one ship is allowed per square." error 0 "Ooops"
	}
}
proc SnapToGrid {x y} {
	global BSEL
	set mx [.bsw.bot coords $BSEL]
	regsub ".* " $mx {} my
	regsub " .*" $mx {} mx
	regsub {\..*} $mx {} mx
	regsub {\..*} $my {} my
	set x [expr $mx / 20]
	set y [expr $my / 20]
	catch {set type [.bsw.bot itemcget $BSEL -image]}
	if {($type == "hcruise") || ($type == "hsub")} {
		if {$x > 7} {set x 7}
		if {$y > 9} {set y 9}
	}
	if {($type == "vcruise") || ($type == "vsub")} {
		if {$x > 9} {set x 9}
		if {$y > 7} {set y 7}
	}
	if {$type == "hdestroyer"} {
		if {$x > 8} {set x 8}
		if {$y > 9} {set y 9}
	}
	if {$type == "vdestroyer"} {
		if {$x > 9} {set x 9}
		if {$y > 8} {set y 8}
	}
	if {$type == "hbattle"} {
		if {$x > 6} {set x 6}
		if {$y > 9} {set y 9}
	}
	if {$type == "vbattle"} {
		if {$x > 9} {set x 9}
		if {$y > 6} {set y 6}
	}
	if {$type == "hcarrier"} {
		if {$x > 5} {set x 5}
		if {$y > 9} {set y 9}
	}
	if {$type == "vcarrier"} {
		if {$x > 9} {set x 9}
		if {$y > 5} {set y 5}
	}
	if {$x < 0} {set x 0}
	if {$y < 0} {set y 0}
	.bsw.bot delete $BSEL
	set BSEL [.bsw.bot create image 0 0 -image $type -anchor nw -tags ship]
	.bsw.bot move $BSEL [expr $x * 20] [expr $y * 20]
}
proc SwapType {x y} {
	global BSEL
	set ship [FindBoat $x $y]
	set x [.bsw.bot coords $ship]
	regsub ".* " $x {} y
	regsub " .*" $x {} x
	set type [.bsw.bot itemcget $ship -image]
	if [regexp "^h" $type] {
		regsub "^h" $type v type
	} {
		regsub "^v" $type h type
	}
	.bsw.bot delete $ship
	set BSEL [.bsw.bot create image $x $y -image $type -anchor nw -tags ship]
	SnapToGrid $x $y
}
proc FindBoat {x y} {
	foreach of [.bsw.bot find withtag ship] {
		set bbox [.bsw.bot bbox $of]
		if {($x >= [lindex $bbox 0]) && ($x <= [lindex $bbox 2]) && ($y >= [lindex $bbox 1]) && ($y <= [lindex $bbox 3])} {return $of}
	}
}
proc DragShip {x y} {
	global BSEL
	global BSCX
	global BSCY
	set mx [.bsw.bot coords $BSEL]
	regsub ".* " $mx {} my
	regsub " .*" $mx {} mx
	.bsw.bot move $BSEL [expr $x - $BSCX] [expr $y - $BSCY]
	set BSCX $x
	set BSCY $y
}
proc Battleship_Init {team} {
	global BSMHITS
	global BSUHITS
	global BSTURN
	global NAME
	global BSOP
	global WATER
	global BBOARD
	global SHOT
	global BSIR
	global BSUR
	global SHIPCOL
	global BSWCOL
	global BSHIT
	global BSMIS
	global SHOT
	set SHOT(y) -1
	set SHOT(x) -1
	set BSUHITS 0
	set BSMHITS 0
	set BSIR 0
	set BSUR 0
	array set SHOT {}
	array set BBOARD {}
	array set WATER {}
	if {$team == 1} {
		set BSTURN $NAME
	} {
		set BSTURN $BSOP
	}
	destroy .bsw
	toplevel .bsw
	wm geometry .bsw +0+0
	wm title .bsw "Battleship"
	wm resizable .bsw 0 0
	canvas .bsw.top -width 200 -height 200 -background $BSWCOL
	canvas .bsw.mid -width 10 -height 2 -background black
	canvas .bsw.bot -width 200 -height 200 -background $BSWCOL
	Tattoo .bsw.top 0
	Tattoo .bsw.bot 1
	pack .bsw.top -side top
	pack .bsw.mid -side top -fill x
	pack .bsw.bot -side top
	MakeShips
	.bsw.bot create image 0 0 -image vdestroyer -anchor nw -tags ship
	.bsw.bot create image 20 0 -image vcruise -anchor nw -tags ship
	.bsw.bot create image 40 0 -image vsub -anchor nw -tags ship
	.bsw.bot create image 60 0 -image vbattle -anchor nw -tags ship
	.bsw.bot create image 80 0 -image vcarrier -anchor nw -tags ship
	.bsw.bot bind ship <Control-ButtonRelease> "catch {SwapType %x %y; SnapToGrid %x %y}"
	.bsw.bot bind ship <ButtonRelease-3> "catch {SwapType %x %y; SnapToGrid %x %y}"
	.bsw.bot bind ship <Button> {set BSEL [FindBoat %x %y]; set BSCX %x; set BSCY %y}
	.bsw.bot bind ship <B1-Motion> {DragShip %x %y}
	.bsw.bot bind ship <ButtonRelease> {catch {SnapToGrid %x %y}}
	button .bsw.done -text "Done, let's play" -command EndSetup
	pack .bsw.done -side top -fill x
	wm protocol .bsw WM_DELETE_WINDOW BS_Close
	MakeRelay .bsw
	bind .bsw <Escape> {break}
	bind .bsw <Key-F1> {faq BSHELP}
}
proc Tattoo {can num} {
	global BSLCOL
	if {$num == 1} {
		global BBOARD1
	} { global BBOARD0}
	for {set x 0} {$x < 10} {incr x} {
		for {set y 0} {$y < 10} {incr y} {
			$can create rectangle [expr $x * 20] [expr $y * 20] [expr [expr $x * 20] + 20] [expr [expr $y * 20] + 20] -fill "" -width 1 -outline $BSLCOL
		}
	}
	for {set x 0} {$x < 10} {incr x} {
		for {set y 0} {$y < 10} {incr y} {
			if {$num == 0} {
				set BBOARD0($x,$y) [$can create oval [expr 3 + [expr $x * 20]] [expr 3 + [expr $y * 20]] [expr 17 + [expr $x * 20]] [expr 17 + [expr $y * 20]] -fill "" -outline "" -width 1]
			} {
				set BBOARD1($x,$y) [$can create oval [expr 3 + [expr $x * 20]] [expr 3 + [expr $y * 20]] [expr 17 + [expr $x * 20]] [expr 17 + [expr $y * 20]] -fill "" -outline "" -width 1]
			}
		}
	}
}
proc BSendChal {} {
	global tprime
	global BCHAL
	if [catch {set sel [.bsp.listing.list get [.bsp.listing.list curselection]]}] {
		tk_dialog .error "Error" "You really should select a player before you try to challenge anyone" error 0 Ooops
		return
	}
	destroy .bsp
	set BCHAL $sel
	puts $tprime "c15 c$sel BATTLESHIP.challenge"
}
proc ChalWin {game cmd dcmd} {
	global winc
	global FROM
	incr winc
	toplevel .$winc
	wm title .$winc "$game Challenge"
	label .$winc.lab -text "$game challenge from $FROM"
	frame .$winc.holder
	button .$winc.holder.yes -text "Accept" -command "destroy .$winc;$cmd $FROM"
	button .$winc.holder.can -text "Decline" -command "destroy .$winc; $dcmd $FROM"
	pack .$winc.lab -side top -fill x
	pack .$winc.holder -side top -fill x
	pack .$winc.holder.yes -side left -fill x -expand true
	pack .$winc.holder.can -side left -fill x -expand true
	wm protocol .$winc WM_DELETE_WINDOW "destroy .$winc; $dcmd $FROM"
	MakeRelay .$winc
	center .$winc
	eventsound CHAL
	return .$winc
}
proc MakePlayerListing {win title cmd} {
	destroy .$win
	toplevel .$win
	wm title .$win $title
	ScrolledListWidget .$win.listing -selectmode single
	bind .$win.listing.list <Double-1> "$cmd"
	bind .$win.listing.list <Return> "$cmd"
	pack .$win.listing -side top -fill both -expand true
	frame .$win.holder
	button .$win.holder.ok -text "Challenge" -command "$cmd"
	button .$win.holder.cancel -text Cancel -command "destroy .$win"
	pack .$win.holder.ok -side left -fill x -expand true
	pack .$win.holder.cancel -side left -fill x -expand true
	pack .$win.holder -side top -fill x
	bind .$win <Escape> "destroy .$win"
	center .$win
	return .$win
}
proc BattleFindPlayers {} {
	global tprime
	MakePlayerListing bsp "Battleship Player List" BSendChal
	puts $tprime "c15 call BATTLESHIP.wannaplay"
}
proc BDeny {who} {
	global tprime
	puts $tprime "c15 c$who BATTLESHIP.deny"
}
proc BAccept {who} {
	global tprime
	global BSOP
	set BSOP $who
	puts $tprime "c15 c$who BATTLESHIP.gameon"
	Battleship_Init 1
}
proc BattleHandle {cmd} {
	global FROM
	global BSOP
	regsub "^BATTLESHIP\." $cmd {} cmd
	if [regexp "^ready" $cmd] {
		global BSUR
		global BSOP
		set BSUR 1
		catch {.bsw.mess config -text "$BSOP is ready."}
	}
	if [regexp "^hit" $cmd] {
		if {$BSOP != $FROM} {return}
		BS_Outgoing 1
		eventsound BSHIT
	}
	if [regexp "^miss" $cmd] {
		if {$BSOP != $FROM} {return}
		BS_Outgoing 0
	}
	if [regexp "^shot" $cmd] {
		global FROM
		global BSOP
		if {$FROM != $BSOP} {return}
		regsub "^shot " $cmd {} cmd
		regsub ".* " $cmd {} y
		regsub " .*" $cmd {} x
		BS_Incoming $x $y
		return
	}
	if [regexp "^wannaplay" $cmd] {
		global CP
		global BSTURN
		if {($CP == 1) || ($BSTURN != -1)} {return}
		global tprime
		global FROM
		puts $tprime "c15 c$FROM BATTLESHIP.willplay"
		return
	}
	if [regexp "^willplay" $cmd] {
		global FROM
		catch {.bsp.listing.list insert end $FROM}
		return
	}
	if [regexp "^challenge" $cmd] {
		ChalWin Battleship BAccept BDeny
		return
	}
	if [regexp "^deny" $cmd] {
		global FROM
		wintalk .twid.text "$FROM declined your Battleship challenge.\n" {}
		return
	}
	if [regexp "^gameon" $cmd] {
		global FROM
		global BSOP
		global BCHAL
		if {$BSOP != -1} {return}
		if {$FROM != $BCHAL} {return}
		set BCHAL {}
		set BSOP $FROM
		Battleship_Init 2
		return
	}
	if [regexp "^sink" $cmd] {
		global BSOP
		global FROM
		if {$FROM != $BSOP} {return}
		catch {.bsw.mess config -text "That's a sink!"}
	}
	if [regexp "^yield" $cmd] {
		global BSTURN
		global BSOP
		global FROM
		if {$FROM != $BSOP} {return}
		if {$BSTURN == -1} {return}
		catch {.bsw.mess config -text "$BSOP resigns!"}
		set BSTURN -1
		tk_dialog .error "$FROM resigns" "$FROM has resigned." error 0 "I Win!"
	}
	if [regexp "^idiot" $cmd] {
		global NAME
		global BSTURN
		global SHOT
		if {$BSOP != $FROM} {return}
		set SHOT(y) -1
		set BSTURN $NAME
		catch {.bsw.mess config -text "Pick again..."}
		return
	}
	if [regexp "^bbox" $cmd] {
		global BSOUTL
		regsub "^bbox *" $cmd {} cmd
		catch {.bsw.top create rectangle [lindex $cmd 0] [lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] -fill "" -width 2 -outline $BSOUTL}
	} 
}
proc MakeShips {} {
	global SHIPCOL
	set HBATTLE {#define hbattle_width 80
#define hbattle_height 20
static char hbattle_bits[] = {
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfe,0xff,0xff,0x7f,0x00,0x00,0x00,
 0x00,0x00,0xe0,0xff,0xff,0xff,0xff,0x07,0x00,0x00,0x00,0x00,0xfc,0xff,0xff,
 0xff,0xff,0x3f,0x00,0x00,0x00,0xc0,0xff,0xff,0xff,0xff,0xff,0xff,0x03,0x00,
 0x00,0xfc,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,0x80,0xff,0xff,0x1f,0x1f,
 0x3f,0x3e,0xfe,0xff,0x01,0xf8,0x3f,0xfe,0xef,0xee,0xde,0xdd,0xfd,0x8f,0x1f,
 0xfc,0x01,0xfe,0xf7,0xf5,0xed,0xeb,0xfb,0x0f,0x70,0xfc,0x01,0xfe,0xf7,0xf5,
 0xed,0xeb,0xfb,0x0f,0x70,0xf8,0x3f,0xfe,0xf7,0xf5,0xed,0xeb,0xfb,0x8f,0x1f,
 0x80,0xff,0xff,0xef,0xee,0xde,0xdd,0xfd,0xff,0x01,0x00,0xfc,0xff,0x1f,0x1f,
 0x3f,0x3e,0xfe,0x3f,0x00,0x00,0xc0,0xff,0xff,0xff,0xff,0xff,0xff,0x03,0x00,
 0x00,0x00,0xfc,0xff,0xff,0xff,0xff,0x3f,0x00,0x00,0x00,0x00,0xe0,0xff,0xff,
 0xff,0xff,0x07,0x00,0x00,0x00,0x00,0x00,0xfe,0xff,0xff,0x7f,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00};}
	set VBATTLE {#define vbattle_width 20
#define vbattle_height 80
static unsigned char vbattle_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x0f, 0x00,
   0x00, 0x0f, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x0f, 0x00, 0x80, 0x1f, 0x00,
   0x80, 0x1f, 0x00, 0x80, 0x19, 0x00, 0xc0, 0x39, 0x00, 0xc0, 0x39, 0x00,
   0xc0, 0x39, 0x00, 0xc0, 0x39, 0x00, 0xe0, 0x70, 0x00, 0xe0, 0x70, 0x00,
   0xe0, 0x70, 0x00, 0xe0, 0x7f, 0x00, 0xf0, 0xff, 0x00, 0xf0, 0xff, 0x00,
   0xf0, 0xff, 0x00, 0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01,
   0xf8, 0xff, 0x01, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xf8, 0x03,
   0x7c, 0xf7, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03,
   0x7c, 0xf7, 0x03, 0xfc, 0xf8, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xf8, 0x03,
   0x7c, 0xf7, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03,
   0x7c, 0xf7, 0x03, 0xfc, 0xf8, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03,
   0xfc, 0xf8, 0x03, 0x7c, 0xf7, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03,
   0xbc, 0xef, 0x03, 0x7c, 0xf7, 0x03, 0xfc, 0xf8, 0x03, 0xfc, 0xff, 0x03,
   0xfc, 0xf8, 0x03, 0x7c, 0xf7, 0x03, 0xbc, 0xef, 0x03, 0xb8, 0xef, 0x01,
   0xb8, 0xef, 0x01, 0x78, 0xf7, 0x01, 0xf8, 0xf8, 0x01, 0xf0, 0xff, 0x00,
   0xf0, 0xff, 0x00, 0xf0, 0xff, 0x00, 0xe0, 0x7f, 0x00, 0xe0, 0x7f, 0x00,
   0xe0, 0x7f, 0x00, 0xe0, 0x7f, 0x00, 0xc0, 0x3f, 0x00, 0xc0, 0x3f, 0x00,
   0xc0, 0x30, 0x00, 0xc0, 0x30, 0x00, 0x80, 0x10, 0x00, 0x80, 0x19, 0x00,
   0x80, 0x19, 0x00, 0x00, 0x09, 0x00, 0x00, 0x09, 0x00, 0x00, 0x09, 0x00,
   0x00, 0x0f, 0x00, 0x00, 0x06, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00};}
	set HCARRIER {#define hcarrier_width 100
#define hcarrier_height 20
static char hcarrier_bits[] = {
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfe,0xff,
 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,
 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,
 0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
 0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
 0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
 0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,
 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,
 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,
 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,
 0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
 0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
 0xff,0x07,0xfe,0xff,0xff,0xff,0x3f,0x00,0xfe,0xff,0xff,0xff,0xff,0xff,0x07,
 0xfe,0xff,0xff,0xff,0x1f,0x00,0xfc,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,
 0xff,0xff,0x3f,0x00,0xfe,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,
 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,
 0xff,0xff,0xff,0xff,0xff,0xff,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00};}
	set VCARRIER {#define vcarrier_width 20
#define vcarrier_height 100
static unsigned char vcarrier_bits[] = {
   0x00, 0x00, 0x00, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xee, 0xff, 0x07, 0xc6, 0xff, 0x07, 0xc6, 0xff, 0x07,
   0xc6, 0xff, 0x07, 0xc6, 0xff, 0x07, 0xc6, 0xff, 0x07, 0xc6, 0xff, 0x07,
   0xc6, 0xff, 0x07, 0xc6, 0xff, 0x07, 0xc6, 0xff, 0x07, 0xc6, 0xff, 0x07,
   0xc6, 0xff, 0x07, 0xee, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0x00, 0x00, 0x00};}
	set HCRUISE {#define hcruise_width 60
#define hcruise_height 20
static char hcruise_bits[] = {
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0xe0,0xff,0xff,0xff,0x0f,0x00,0x00,0x00,0xf8,0xff,0xff,0xff,0x3f,
 0x00,0x00,0x00,0xfe,0xff,0xff,0xff,0xff,0x00,0x00,0x80,0xff,0xff,0xff,0xff,
 0xff,0x03,0x00,0xe0,0xff,0xff,0xff,0xff,0xff,0x0f,0x00,0xf0,0xff,0xf8,0xf1,
 0xe3,0xff,0x3f,0x00,0xfc,0x7f,0xf7,0xee,0xdd,0xff,0xff,0x00,0xfe,0xbf,0x6f,
 0xdf,0xbe,0xff,0xff,0x03,0xfe,0xbf,0x0f,0x1f,0x3e,0xff,0xff,0x03,0xfc,0xbf,
 0x6f,0xdf,0xbe,0xff,0xff,0x00,0xf0,0x7f,0xf7,0xee,0xdd,0xff,0x3f,0x00,0xe0,
 0xff,0xf8,0xf1,0xe3,0xff,0x0f,0x00,0x80,0xff,0xff,0xff,0xff,0xff,0x03,0x00,
 0x00,0xfe,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xf8,0xff,0xff,0xff,0x3f,0x00,
 0x00,0x00,0xe0,0xff,0xff,0xff,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};}
	set VCRUISE {#define vcruise_width 20
#define vcruise_height 60
static unsigned char vcruise_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x0f, 0x00,
   0x80, 0x1f, 0x00, 0xc0, 0x3f, 0x00, 0xc0, 0x3f, 0x00, 0xe0, 0x7f, 0x00,
   0xe0, 0x7f, 0x00, 0xf0, 0xff, 0x00, 0xf0, 0xff, 0x00, 0xf8, 0xff, 0x01,
   0xf8, 0xff, 0x01, 0xfc, 0xff, 0x03, 0xfc, 0xf8, 0x03, 0x7c, 0xf7, 0x03,
   0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03, 0x7c, 0xf7, 0x03,
   0xfc, 0xf8, 0x03, 0xfc, 0xfd, 0x03, 0xfc, 0xfd, 0x03, 0xfc, 0xf8, 0x03,
   0x7c, 0xf7, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03,
   0x7c, 0xf7, 0x03, 0xfc, 0xf8, 0x03, 0xfc, 0xfd, 0x03, 0xfc, 0xfd, 0x03,
   0xfc, 0xf8, 0x03, 0x7c, 0xf7, 0x03, 0xbc, 0xef, 0x03, 0xbc, 0xef, 0x03,
   0xbc, 0xef, 0x03, 0x7c, 0xf7, 0x03, 0xfc, 0xf8, 0x03, 0xfc, 0xfd, 0x03,
   0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03,
   0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01, 0xf0, 0xff, 0x00, 0xf0, 0xff, 0x00,
   0xe0, 0x7f, 0x00, 0xe0, 0x7f, 0x00, 0xc0, 0x3f, 0x00, 0xc0, 0x3f, 0x00,
   0x80, 0x1f, 0x00, 0x80, 0x1f, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x0f, 0x00,
   0x00, 0x06, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
	set HDESTROYER {#define hdestroyer_width 40
#define hdestroyer_height 20
static char hdestroyer_bits[] = {
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0xff,0x7f,0x00,0xc0,0xff,0xff,0x7f,
 0x00,0xfc,0xff,0xff,0x7f,0x80,0xff,0xff,0xff,0x7f,0xe0,0xff,0xff,0xff,0x7f,
 0xf0,0xff,0xff,0xff,0x7f,0xf8,0xff,0xff,0xff,0x7f,0xfc,0xff,0xff,0xff,0x7f,
 0xfe,0xff,0xff,0xff,0x7f,0xfe,0xff,0xff,0xff,0x7f,0xfc,0xff,0xff,0xff,0x7f,
 0xf8,0xff,0xff,0xff,0x7f,0xf0,0xff,0xff,0xff,0x7f,0xe0,0xff,0xff,0xff,0x7f,
 0x80,0xff,0xff,0xff,0x7f,0x00,0xfc,0xff,0xff,0x7f,0x00,0xc0,0xff,0xff,0x7f,
 0x00,0x00,0xf8,0xff,0x7f,0x00,0x00,0x00,0x00,0x00};}
	set VDESTROYER {#define destroyer_width 20
#define destroyer_height 40
static unsigned char destroyer_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x0f, 0x00, 0x80, 0x1f, 0x00,
   0xc0, 0x3f, 0x00, 0xe0, 0x7f, 0x00, 0xe0, 0x7f, 0x00, 0xf0, 0xff, 0x00,
   0xf0, 0xff, 0x00, 0xf0, 0xff, 0x00, 0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01,
   0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03,
   0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0x00, 0x00, 0x00};}
	set HSUB {#define hsub_width 60
#define hsub_height 20
static char hsub_bits[] = {
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0xff,0xff,0xff,0x1f,0x00,
 0x00,0x80,0xff,0xff,0xff,0xff,0xff,0x01,0x00,0xf0,0xff,0xff,0xff,0xff,0xff,
 0x0f,0x00,0xf8,0xff,0xff,0xff,0xff,0xff,0x7f,0x00,0xfc,0xff,0xff,0xff,0xff,
 0xff,0xff,0x01,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0x03,0xfe,0xff,0xff,0xff,
 0xff,0xff,0xff,0x07,0xfe,0xff,0x03,0xfc,0xff,0xff,0xff,0x07,0xfe,0xff,0x01,
 0xf8,0xff,0xff,0xff,0x07,0xfe,0xff,0x01,0xf8,0xff,0xff,0xff,0x07,0xfe,0xff,
 0x03,0xfc,0xff,0xff,0xff,0x07,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0x07,0xfe,
 0xff,0xff,0xff,0xff,0xff,0xff,0x03,0xfc,0xff,0xff,0xff,0xff,0xff,0xff,0x01,
 0xf8,0xff,0xff,0xff,0xff,0xff,0x7f,0x00,0xf0,0xff,0xff,0xff,0xff,0xff,0x0f,
 0x00,0x80,0xff,0xff,0xff,0xff,0xff,0x01,0x00,0x00,0xf8,0xff,0xff,0xff,0x1f,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};}
	set VSUB {#define vsub_width 20
#define vsub_height 60
static unsigned char vsub_bits[] = {
   0x00, 0x00, 0x00, 0xc0, 0x3f, 0x00, 0xe0, 0x7f, 0x00, 0xf0, 0xff, 0x00,
   0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01, 0xfc, 0xff, 0x03,
   0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xf9, 0x07, 0xfe, 0xf0, 0x07, 0xfe, 0xf0, 0x07,
   0xfe, 0xf0, 0x07, 0xfe, 0xf0, 0x07, 0xfe, 0xf0, 0x07, 0xfe, 0xf0, 0x07,
   0xfe, 0xf0, 0x07, 0xfe, 0xf0, 0x07, 0xfe, 0xf9, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07, 0xfe, 0xff, 0x07,
   0xfe, 0xff, 0x07, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03, 0xfc, 0xff, 0x03,
   0xfc, 0xff, 0x03, 0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01, 0xf8, 0xff, 0x01,
   0xf0, 0xff, 0x00, 0xf0, 0xff, 0x00, 0xf0, 0xff, 0x00, 0xe0, 0x7f, 0x00,
   0xe0, 0x7f, 0x00, 0xc0, 0x3f, 0x00, 0x80, 0x1f, 0x00, 0x00, 0x00, 0x00};}
	image create bitmap vbattle -data $VBATTLE -foreground $SHIPCOL
	image create bitmap hbattle -data $HBATTLE -foreground $SHIPCOL
	image create bitmap hcarrier -data $HCARRIER -foreground $SHIPCOL
	image create bitmap vcarrier -data $VCARRIER -foreground $SHIPCOL
	image create bitmap hcruise -data $HCRUISE -foreground $SHIPCOL
	image create bitmap vcruise -data $VCRUISE -foreground $SHIPCOL
	image create bitmap hdestroyer -data $HDESTROYER -foreground $SHIPCOL
	image create bitmap vdestroyer -data $VDESTROYER -foreground $SHIPCOL
	image create bitmap vsub -data $VSUB -foreground $SHIPCOL
	image create bitmap hsub -data $HSUB -foreground $SHIPCOL
}
proc BattleshipCleanup {} {
	global WATER
	global BBOARD
	global BBOARD0
	global BBOARD1
	catch {image delete vcarrier hcarrier vbattle hbattle hcruise vcruise hdestroyer vdestroyer vsub hsub}
	catch {unset WATER}
	catch {unset BBOARD}
	catch {unset BBOARD0}
	catch {unset BBOARD1}
}
proc Reversi_EndGame {} {
	global REVOPP
	global RBOARD
	global tprime
	if {$REVOPP != -1} {
		set i [tk_dialog .error "Resign" "Do you really wish to resign?" questhead 0 No Yes]
		if {$i == 0} {return}
		puts $tprime "c15 c$REVOPP REVERSI.yield"
		set REVOPP -1
	}
	destroy .reversi
	catch {unset RBOARD}
}
proc RSendChal {} {
	global tprime
	global RCHAL
	if [catch {set name [.rp.listing.list get [.rp.listing.list curselection]]}] {
		tk_dialog .error "Error" "You need to select a name" error 0 Ooops
		return
	}
	puts $tprime "c15 c$name REVERSI.challenge"
	set RCHAL $name
	destroy .rp
}
proc RListP {} {
	global tprime
	global CP
	set CP 0
	puts $tprime "c15 call REVERSI.wannaplay"
	MakePlayerListing rp "Reversi Players" RSendChal
}
proc ReversiHandle {cmd} {
	global FROM
	global REVOPP
	global NAME
	regsub "^REVERSI\." $cmd {} cmd
	if [regexp "^move" $cmd] {
		if {($NAME != $FROM) && ($FROM != $REVOPP)} {return}
		global NOOP
		global NAME
		set NOOP 0
		regsub "^move " $cmd {} cmd
		set x [expr $cmd / 10]
		set y [expr $cmd - [expr $x * 10]]
		ReversiMove $x $y
	}
	if [regexp "^wannaplay" $cmd] {
		global CP
		global tprime
		if {$CP == 1} {return}
		if {$REVOPP != -1} {return}
		global FROM
		puts $tprime "c15 c$FROM REVERSI.willplay"
	}
	if [regexp "^willplay" $cmd] {
		catch {.rp.listing.list insert end $FROM}
	}
	if [regexp "challenge" $cmd] {
		ChalWin Reversi RAcc RDeny
		return
	}
	if [regexp "deny" $cmd] {
		global FROM
		wintalk .twid.text "$FROM declined your reversi challenge.\n" {}
	}
	if [regexp "gameon" $cmd] {
		global FROM
		global REVOPP
		global RCHAL
		if {$REVOPP != -1} {return}
		if {$FROM != $RCHAL} {return}
		set RCHAL {}
		set REVOPP $FROM
		Reversi_Init 2
	}
	if [regexp "^noop" $cmd] {
		global NAME
		global tprime
		global RETEAM
		global RTURN
		global ONOOP
		global NOOP
		if {$REVOPP != $FROM} {return}
		set RTURN $NAME
		.reversi.mess config -text "It is your turn."
		set curcol $RETEAM
		set ONOOP 1
		if ![ReversiMovesExist] {
			set NOOP 1
		} {
			set NOOP 0
			set ONOOP 0
		}
		if {$NOOP == 1} {
			puts $tprime "c15 c$REVOPP REVERSI.noop"
			Reversi_TallyScore
		}
	}	
	if [regexp "^yield" $cmd] {
		global REVOPP
		global RTURN
		if {$FROM != $REVOPP} {return}
		set REVOPP -1
		set RTURN -1
		.reversi.mess config -text "$FROM resigned!"
	}
}
proc RAcc {who} {
	global tprime
	global REVOPP
	set REVOPP $who
	puts $tprime "c15 c$who REVERSI.gameon"
	Reversi_Init 1
	destroy .rchal
}
proc RDeny {who} {
	global tprime
	puts $tprime "c15 c$who REVERSI.deny"
	destroy .rchal
}
proc Reversi_TallyScore {} {
	global RBOARD
	global REVOPP
	global ONOOP
	global NOOP
	global RTEAM
	global RETEAM
	global RTURN
	set myscore 0
	set oscore 0
	if {$REVOPP == -1} {return}
	for {set x 0} {$x < 8} {incr x} {
		for {set y 0} {$y < 8} {incr y} {
			if {[.reversi.board itemcget $RBOARD($x,$y) -fill] == $RTEAM} {
				incr myscore
			}
			if {[.reversi.board itemcget $RBOARD($x,$y) -fill] == $RETEAM} {
				incr oscore
			}
		}
	}
	.reversi.score.label config -text "You: $myscore     $REVOPP: $oscore"
	if {([expr $myscore + $oscore] == 64) || ($myscore == 0) || ($oscore == 0) || (($NOOP == 1) && ($ONOOP == 1))} {
		if {$myscore > $oscore} {
			set mess "You win."
		}
		if {$myscore < $oscore} {
			set mess "You lose."
		}
		if {$myscore == $oscore} {
			set mess "Its a draw."
		}
		.reversi.mess config -text "$mess"
		set REVOPP -1
		set RTURN -1
	} 
}
proc ReversiMovesExist {} {
	global RBOARD
	global RTEAM
	global RBACK
	global RETEAM
	global REVOPP
	if {$REVOPP == -1} {return 0}
	for {set x 0} {$x < 8} {incr x} {
		for {set y 0} {$y < 8} {incr y} {
			if {[BoardGet $x $y] != $RTEAM} {continue}
			for {set z -1} {$z < 2} {incr z} {
				for {set zz -1} {$zz < 2} {incr zz} {
					set tempx [expr $x + $z]
					set tempy [expr $y + $zz]
					for {set its 0} {[BoardGet $tempx $tempy] != $RTEAM} {incr its} {
						if {[string length [BoardGet $tempx $tempy]] == 0} {break}
						if {[BoardGet $tempx $tempy] == $RBACK} {
							if {$its == 0} {break}
							return 1
						}
						set tempx [expr $tempx + $z]
						set tempy [expr $tempy + $zz]
					}
				}
			}
		}
	}
	return 0
}
proc BoardGet {x y} {
	global RBOARD
	if [catch {.reversi.board itemcget $RBOARD($x,$y) -fill} data] {set data ""}
	return $data
}
proc ReversiMove {x y} {
	global REVOPP
	global RTURN
	global NAME
	global FROM
	global RETEAM
	global RTEAM
	global RBOARD
	global RBACK
	if {$FROM != $RTURN} {return}
	if {$REVOPP == -1} {return}
	set test 0
	for {set z -1} {$z < 2} {incr z} {
		for {set zz -1} {$zz < 2} {incr zz} {
			if [RTraceLine $x $y $z $zz 0] {
				set test 1
			}
		}
	}
	if {$test == 1} {
		for {set z -1} {$z < 2} {incr z} {
        	        for {set zz -1} {$zz < 2} {incr zz} {
                	        if [RTraceLine $x $y $z $zz 1] {
                        	        set test 1
                	        }
           	     }
	        }
	}
	if {$test == 1} {
		if {$REVOPP == -1} {return}
		if {$RTURN == $NAME} {
			set RTURN $REVOPP
			.reversi.mess config -text "Waiting for $REVOPP to move."
			set curcol $RTEAM
			.reversi.board itemconfig $RBOARD($x,$y) -fill $curcol
		} {
			eventsound RVMOVE
			set RTURN $NAME
			.reversi.mess config -text "It is your turn. (Last move: [expr $x + 1] [expr $y + 1])"
			set curcol $RETEAM
			.reversi.board itemconfig $RBOARD($x,$y) -fill $curcol
			if ![ReversiMovesExist] {
				global NOOP
				set NOOP 1
				.reversi.mess config -text "No moves possible, passing."
				set RTURN $REVOPP
				set curcol $RETEAM
				global tprime
				puts $tprime "c15 c$REVOPP REVERSI.noop"
			}
		}
	}
	Reversi_TallyScore
}
proc RTraceLine {x y xo yo z} {
	global RBOARD
	global RTEAM
	global RBACK
	global RETEAM
	global RTURN
	global NAME
	if {$RTURN == $NAME} {
		set curcol $RTEAM
	} {
		set curcol $RETEAM
	}
	set tempx [expr $x + $xo]
	set tempy [expr $y + $yo]
	if {($tempx > 7) || ($tempx < 0)} {return 0}
	if {($tempy > 7) || ($tempy < 0)} {return 0}
	if {[.reversi.board itemcget $RBOARD($tempx,$tempy) -fill] == $RBACK} {return 0}
	if {[.reversi.board itemcget $RBOARD($tempx,$tempy) -fill] == $curcol} {
		if {$z == 0} {
			return 0
		} {
			return 1
		}
	}
	set test [RTraceLine $tempx $tempy $xo $yo 1]
	if {$test >= 1} {
		if {$z == 0} {
			return $test
		} {
			.reversi.board itemconfig $RBOARD($tempx,$tempy) -fill $curcol
			return [expr $tempy + [expr $tempx * 10]]
		}
	} {
		return 0
	}
}
proc LocalReversiMove {x y} {
	global RBOARD
	global RBACK
	global RRED
	global RBLUE
	global NAME
	global RTURN
	if {$RTURN != $NAME} {return}
	set x [Trans $x]
	set y [Trans $y]
	if {($x > 7) || ($x < 0) || ($y > 7) || ($y < 0)} {return}
	if {[.reversi.board itemcget $RBOARD($x,$y) -fill] != $RBACK} {
		.reversi.mess config -text "That space is taken."
		return
	}
	set test 0
	for {set z -1} {$z < 2} {incr z} {
		for {set zz -1} {$zz < 2} {incr zz} {
			if [RTraceLine $x $y $z $zz 0] {
				set test 1
			}
		}
	}
	if {$test == 1} {
		.reversi.mess config -text "Moving..."
		global tprime
		global NAME
		global REVOPP
		puts $tprime "c15 c$NAME,$REVOPP REVERSI.move [expr $y + [expr $x * 10]]"
	}
}
proc Reversi_Init {a} {
	global REVOPP
	global RTURN
	global FROM
	global NAME
	global RBACK
	global RLINES
	global RBOARD
	global RTEAM
	global RETEAM
	global RRED
	global NOOP
	global ONOOP
	global RBLUE
	array set RBOAR {}
	set NOOP 0
	set ONOOP 0
	if {$a == 1} {
		set RTEAM $RBLUE
		set RETEAM $RRED
		set RTURN $NAME
	} {
		set RTURN $FROM
		set RTEAM $RRED
		set RETEAM $RBLUE
	}
	destroy .reversi
	toplevel .reversi
	wm geometry .reversi +30+0
	wm title .reversi Reversi
	canvas .reversi.board -width 344 -height 344
	for {set x 0} {$x < 8} {incr x} {
		for {set y 0} {$y < 8} {incr y} {
			.reversi.board create rect [expr 43 * $x] [expr 43 * $y] [expr 43 + [expr 43 * $x]] [expr 43 + [expr 43 * $y]] -fill $RBACK -width 1 -outline $RLINES
		}
	}
	set off 5
	for {set y 0} {$y < 8} {incr y} {
		for {set x 0} {$x < 8} {incr x} {
			set RBOARD($x,$y) [.reversi.board create oval [expr $off + [expr 43 * $x]] [expr $off + [expr 43 * $y]] [expr 38 + [expr 43 * $x]] [expr 38 + [expr 43 * $y]] -fill $RBACK -width 0 -outline $RBACK -tags spot]
		}
	}
	.reversi.board itemconfig $RBOARD(3,3) -fill $RRED
	.reversi.board itemconfig $RBOARD(4,3) -fill $RBLUE
	.reversi.board itemconfig $RBOARD(4,4) -fill $RRED
	.reversi.board itemconfig $RBOARD(3,4) -fill $RBLUE
	pack .reversi.board -side top -fill none
	bind .reversi.board <ButtonRelease> {LocalReversiMove %x %y}
	frame .reversi.score
	label .reversi.score.label -text "You: 0     $REVOPP: 0" -anchor w
	pack .reversi.score -side top -fill x -expand true
	pack .reversi.score.label -side left -fill x -expand true
	label .reversi.score.yc -text "Your Color:"
	label .reversi.score.color -text "  " -background $RTEAM
	pack .reversi.score.yc -side left
	pack .reversi.score.color -side left
	label .reversi.mess -text Reversi -anchor w
	pack .reversi.mess -side top -fill x
	if {$a == 1} {
		.reversi.mess config -text "Your move."
	} {
		.reversi.mess config -text "$REVOPP gets the first move."
	}
	MakeRelay .reversi
	bind .reversi <Escape> {break}
	wm protocol .reversi WM_DELETE_WINDOW {Reversi_EndGame}
	wm resizable .reversi 0 0
	bind .reversi <Key-F1> {faq REVERH}
}
proc GetKing {} {
	global Mteam
	global PCS
	if {$Mteam == 1} {set king 5} {set king 29}
	for {set y 0} {$y < 8} {incr y} {
		for {set x 0} {$x < 8} {incr x} {
			if {$PCS($y,$x) == $king} {
				return "$x $y"
			}
		}
	}
	return "-1 -1"
}
proc ChessCleanup {} {
	set q 1
	global TURN
	global CHESSOP
	global tprime
	global PCS
	global BOARD
	global team
	if {$TURN != -1} {
		set q [tk_dialog .error "Really Close Chess?" "The game is not done, do\nyou really wish to resign?" questhead 0 No Yes]
	}
	if {$q == 0} {return}
	if {($TURN != -1) && ($q == 1)} {
		puts $tprime "c15 c$CHESSOP CHESS.yield"
	}
	set TURN -1
	set CHESSOP -1
	catch {unset team}
	catch {unset BOARD}
	catch {unset PCS}
	catch {image delete wknight}
	catch {image delete bknight}
	catch {image delete wrook}
	catch {image delete brook}
	catch {image delete wbishop}
	catch {image delete bbishop}
	catch {image delete wqueen}
	catch {image delete bqueen}
	catch {image delete wking}
	catch {image delete bking}
	catch {image delete bpawn}
	catch {image delete wpawn}
	destroy .chess
}
proc ChessAcc {who} {
	global tprime
	global CHESSOP
	global TURN
	global NAME
	set CHESSOP $who
	puts $tprime "c15 c$who CHESS.gameon"
	set TURN $NAME
	Chess_InitBoard 1
	.chess.mess config -text "Your move, you are North."
	destroy .cchal
}
proc ChessDeny {who} {
	global tprime
	puts $tprime "c15 c$who CHESS.denied"
	destroy .cchal
}
proc ChessSendChal {} {
	global tprime
	global CCHAL
	global TURN
	if {$TURN != -1} {return}
	if [catch {set name [.clist.listing.list get [.clist.listing.list curselection]]}] {
		tk_dialog .error "Error" "You need to select a name" error 0 Ooops
		return
	}
	set CCHAL $name
	puts $tprime "c15 c$name CHESS.challenge"
	destroy .clist
}
proc ChessFindPlayers {} {
	global tprime
	global CP
	set CP 0
	MakePlayerListing clist "Chess Players" ChessSendChal
	puts $tprime "c15 call CHESS.wannaplay2"
}
proc ChessHandle {cmd} {
	global FROM
	global NAME
	global CHESSOP
	regsub "^CHESS\." $cmd {} cmd
	if [regexp "^yield" $cmd] {
		global TURN
		if {$FROM == $CHESSOP} {
			.chess.mess config -text "$CHESSOP resigns!"
			set TURN -1
			set CHESSOP ""
		}
		if {$FROM == $NAME} {
			catch {.chess.mess config -text "You resign."}
			set TURN -1
			set CHESSOP ""
		}
		return
	}
	if [regexp "^move_selection" $cmd] {
		if {($FROM != $CHESSOP) && ($FROM != $NAME)} {return}
		regsub "^move_selection " $cmd {} cmd
		regsub ". " $cmd {} y
		regsub " ." $cmd {} x
		catch {ChessMove $x $y}
		return
	}
	if [regexp "^select" $cmd] {
		if {$FROM != $CHESSOP} {return}
		regsub "^select " $cmd {} cmd
		regsub ". " $cmd {} y
		regsub " ." $cmd {} x
		catch {RemoteSelectPiece $x $y}
		return
	}
	if [regexp "^wannaplay2" $cmd] {
		global CP
		global CHESSOP
		if {$CP == 1} {return}
		if {$CHESSOP != -1} {return}
		global tprime
		global FROM
		puts $tprime "c15 c$FROM CHESS.willingtoplay2"
		return
	}
	if [regexp "^willingtoplay2" $cmd] {
		global FROM
		catch {.clist.listing.list insert end $FROM}
		return
	}
	if [regexp "^challenge" $cmd] {
		ChalWin Chess ChessAcc ChessDeny
		return
	}
	if [regexp "^denied" $cmd] {
		global FROM
		wintalk .twid.text "$FROM declined your chess challenge.\n" {}
		return
	}
	if [regexp "^gameon" $cmd] {
		global CHESSOP
		global FROM
		global TURN
		global CCHAL
		if {$CHESSOP != -1} {return}
		if {$FROM != $CCHAL} {return}
		set CCHAL {}
		set CHESSOP $FROM
		set TURN $CHESSOP
		Chess_InitBoard 2
		.chess.mess config -text "$CHESSOP's move. You are South."
		return
	}
}
proc EPhandler {cmd} {
	global HANDLERS
	global CP
	if [regexp "^c" $cmd] {
		global FROM
		regsub "^c" $cmd {} cmd
		regsub " .*" $cmd {} FROM
		regsub "\[^ \]* " $cmd {} cmd
		regsub -all "\n" $cmd {} cmd
		if [regexp "^CHESS" $cmd] {
			ChessHandle $cmd
		}
		if [regexp "^DRAW" $cmd] {
			catch {DrawHandle $cmd}
		}
		if [regexp "^C4" $cmd] {
			wintalk .twid.text "$FROM declined your Connect 4 challenge.\n" {}
		}
		if [regexp "^REVERSI" $cmd] {
			ReversiHandle $cmd
		}
		if [regexp "^BATTLESHIP" $cmd] {
			BattleHandle $cmd
		}
		if [regexp "^DEBUG" $cmd] {
			DebugHandle $cmd
		}
		foreach of [array names HANDLERS] {
			if [regexp "^$of" $cmd] {
				$HANDLERS($of) $cmd
				return
			}
		}
		return
	}
	if [regexp "^d" $cmd] {
		global NAME
		regsub -all "\n" $cmd {} cmd
		regsub "^d" $cmd {} NAME
		wm title . "TkTurf - $NAME"
		return
	}
	if [regexp "^e" $cmd] {
		global IP
		if [string length $IP] {return}
		regsub "^e" $cmd {} IP
		regsub -all "\n" $IP {} IP
		return
	}
}
proc ListSetScroll {scrollbar geoCmd offset size} {
	if {$offset != 0.0 || $size != 1.0} {
		eval $geoCmd
		$scrollbar set $offset $size
	} else {
		set manager [lindex $geoCmd 0]
		$manager forget $scrollbar
	}
}
proc ScrolledListWidget { frame args } {
	global SWIDTH
	frame $frame
	listbox $frame.list \
		-xscrollcommand [list ListSetScroll $frame.xscroll [list grid $frame.xscroll -row 1 -column 0 -sticky we]] \
		-yscrollcommand [list ListSetScroll $frame.yscroll [list grid $frame.yscroll -row 0 -column 1 -sticky ns]]
	eval {$frame.list configure} $args
	scrollbar $frame.xscroll -orient horizontal -command "$frame.list xview" -width $SWIDTH
	scrollbar $frame.yscroll -orient vertical -command "$frame.list yview" -width $SWIDTH
	grid $frame.list $frame.yscroll -sticky news
	grid $frame.xscroll -sticky news
	grid rowconfigure $frame 0 -weight 1
	grid columnconfigure $frame 0 -weight 1
	return $frame.list
}
proc Chess_numtoname {num} {
	if {$num >= 9 && $num <= 24} {return pawn}
	if {$num == 1 || $num == 8 || $num == 25 || $num == 32} {return rook}
	if {$num == 2 || $num == 7 || $num == 26 || $num == 31} {return knight}
	if {$num == 3 || $num == 6 || $num == 27 || $num == 30} {return bishop}
	if {$num == 4 || $num == 28} {return queen}
	return king
}
proc IsCheckMate {} {
	global PCS
	global PSEL
	global Mteam
	global team
	set oldpsel(x) $PSEL(x)
	set oldpsel(y) $PSEL(y)
	if {$Mteam == 1} {
		set max 16
		set min 1
		set emax 32
		set emin 17
	} {
		set max 32
		set min 17
		set emax 16
		set emin 1
	}
	for {set y 0} {$y < 8} {incr y} {
	for {set x 0} {$x < 8} {incr x} {
	if {($PCS($y,$x) <= $max) && ($PCS($y,$x) >= $min)} {
	for {set sy 0} {$sy < 8} {incr sy} {
	for {set sx 0} {$sx < 8} {incr sx} {
	if {(($PCS($sy,$sx) >= $emin) && ($PCS($sy,$sx) <= $emax)) || ($PCS($sy,$sx) == 0)} {
		set PSEL(x) $x
		set PSEL(y) $y
		if {[IsLegal $sx $sy 0] == 1} {
			set oldpiece $PCS($sy,$sx)
			set PCS($sy,$sx) $PCS($y,$x)
			set PCS($y,$x) 0
			regexp "(.) (.)" [GetKing] junk kx ky
			if ![IsSpaceUnderAttack $Mteam $kx $ky] {
				set PCS($y,$x) $PCS($sy,$sx)
				set PCS($sy,$sx) $oldpiece
				if {($PCS($y,$x) == 5) || ($PCS($y,$x) == 29)} {
					if [IsSpaceUnderAttack $Mteam $kx $ky] {
						break
					}
				}
				set PSEL(x) $oldpsel(x)
				set PSEL(y) $oldpsel(y)
				return 0
			}
			set PCS($y,$x) $PCS($sy,$sx)
			set PCS($sy,$sx) $oldpiece
		}
	}
	}
	}
	}
	}
	}
	set PSEL(x) $oldpsel(x)
	set PSEL(y) $oldpsel(y)
	return 1
}
proc ChessMove {x y} {
	global BOARD
	global PSEL
	global team
	global PCS
	global CFCOL
	global TURN
	global FROM
	global CHESSOP
	global NAME
	global Mteam
	global tprime
	if {$FROM != $TURN} {return}
	if {($PSEL(x) == -1) || ($PSEL(y) == -1)} {return}
	if {[IsLegal $x $y 1] != 1} {return}
	if {$FROM != $NAME} {eventsound CHMOVE}
	wintalk .chess.log.text "\n$TURN: [expr $PSEL(x) +1],[expr $PSEL(y) + 1] to [expr $x + 1],[expr $y + 1]" {}
	if {$PCS($y,$x) != 0} {
		wintalk .chess.log.text " \(killed: [Chess_numtoname $PCS($y,$x)]\)" {}
	}
	catch {.chess.board itemconfig $BOARD($PSEL(y),$PSEL(x)) -fill $CFCOL}
	if {$PCS($y,$x)} {
		if {$PCS($y,$x) == 29} {
			if [regexp "mine" [.chess.board gettags $team($PCS($y,$x))]] {
				.chess.mess config -text "You lost."
			} {
				.chess.mess config -text "You win!"
			}
			set TURN -1
		}
		if {$PCS($y,$x) == 5} {
			if [regexp "mine" [.chess.board gettags $team($PCS($y,$x))]] {
				.chess.mess config -text "You lost."
			} {
				.chess.mess config -text "You win!"
			}
			set TURN -1
		}
		.chess.board delete $team($PCS($y,$x))
	} {
		if {$PCS($PSEL(y),$PSEL(x)) >= 17 && $y == 2 && ($PCS(3,$x) >= 9 && $PCS(3,$x) <= 16)} {
			if [regexp "enpassant" [.chess.board gettags $team($PCS(3,$x))]] {
				.chess.board delete $team($PCS(3,$x))
				set PCS(3,$x) 0
				wintalk .chess.log.text " \(killed: pawn\)" {}
			}
		}
		if {$PCS($PSEL(y),$PSEL(x)) <= 16  && $y == 5 && ($PCS(4,$x) >= 17 && $PCS(4,$x) <= 24)} {
			if [regexp "enpassant" [.chess.board gettags $team($PCS(4,$x))]] {
				.chess.board delete $team($PCS(4,$x))
				set PCS(4,$x) 0
				wintalk .chess.log.text " \(killed: pawn\)" {}
			}
		}
	}
	set PCS($y,$x) $PCS($PSEL(y),$PSEL(x))
	set PCS($PSEL(y),$PSEL(x)) 0
	set tx [expr 43 * [expr $x - $PSEL(x)]]
	set ty [expr 43 * [expr $y - $PSEL(y)]]
	.chess.board move $team($PCS($y,$x)) [expr 43 * [expr $x - $PSEL(x)]] [expr 43 * [expr $y - $PSEL(y)]]
	if {(($PCS($y,$x) >= 9) && ($PCS($y,$x) <= 16)) && ($y == 7)} {
		.chess.board itemconfig $team($PCS($y,$x)) -image wqueen
	}
	if {(($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 24)) && ($y == 0)} {
		.chess.board itemconfig $team($PCS($y,$x)) -image bqueen
	} 
	set PSEL(x) -1
	set PSEL(y) -1
	set nuke 0
	if {$TURN == $NAME} {
		if {$Mteam == 1} {set nuke 2} {set nuke 1}
	} {
		set nuke $Mteam
	}
	if {$nuke == 1} {set nuke {9 10 11 12 13 14 15 16}} {set nuke {17 18 19 20 21 22 23 24}}
	foreach of $nuke {
		.chess.board dtag $team($of) enpassant
	}
	if {$TURN == -1} {return}
	if {$TURN == $NAME} {
		set TURN $CHESSOP
		 .chess.mess config -text "Waiting for $CHESSOP to move."
	} {
		set TURN $NAME
		.chess.mess config -text "It is your turn."
		if {$Mteam == 1} {
			set temp [.chess.board coords $team(5)]
		} {
			set temp [.chess.board coords $team(29)]
		}
		regsub " .*" $temp {} kx
		regsub ".* " $temp {} ky
		set kx [Trans $kx]
		set ky [Trans $ky]
		if [IsSpaceUnderAttack $Mteam $kx $ky] {
			.chess.mess config -text "Check!"
			if [IsCheckMate] {
				.chess.mess config -text "Checkmate."
				puts $tprime "c15 c$CHESSOP CHESS.yield"
				set TURN -1
			}
		}
	}
}
proc IsSpaceUnderAttack {side x y} {
	global PCS
	global PSEL
	global team
	set underattack 0
	if {$side == 1} {
		set min 17
		set max 33
	} {
		set min 1
		set max 17
	}
	set oldpsel(x) $PSEL(x)
	set oldpsel(y) $PSEL(y)
	set oldpiece $PCS($y,$x)
	if {$side == 1} {
		set PCS($y,$x) 5
	} {set PCS($y,$x) 29}
	for {} {$min < $max} {incr min} {
		set temp [.chess.board coords $team($min)]
		regsub " .*" $temp {} PSEL(x)
		regsub ".* " $temp {} PSEL(y)
		set PSEL(x) [Trans $PSEL(x)]
		set PSEL(y) [Trans $PSEL(y)]
		if {($PSEL(x) == $x) && ($PSEL(y) == $y)} {
			continue
		}
		if {[IsLegal $x $y 0] == 1} {
			set underattack 1
			break
		}
	}
	set PSEL(x) $oldpsel(x)
	set PSEL(y) $oldpsel(y)
	set PCS($y,$x) $oldpiece
	return $underattack
}
proc LocalMove {x y} {
	global tprime
	global PSEL
	global NAME
	global TURN
	global CHESSOP
	global PCS
	global team
	global Mteam
	if {($PSEL(x) == -1) || ($PSEL(y) == -1)} {return}
	if {$TURN != $NAME} {.chess.mess config -text "It is not your turn right now!"; return}
	set x [Trans $x]
	set y [Trans $y]
	set pbx $PSEL(x)
	set pby $PSEL(y)
	set bx $x
	set by $y
	set InitTarg $PCS($by,$bx)
	set InitPiece $PCS($pby,$pbx)
	if {[IsLegal $x $y 0] != 1} {return}
	if {$Mteam == 1} {
		if {$PCS($PSEL(y),$PSEL(x)) != 5} {
			set temp [.chess.board coords $team(5)]
			regsub " .*" $temp {} x
			regsub ".* " $temp {} y
			set x [Trans $x]
			set y [Trans $y]
		}
		set PCS($pby,$pbx) 0
		set PCS($by,$bx) $InitPiece
		for {set t 17} {$t < 33} {incr t} {
			set temp [.chess.board coords $team($t)]
			regsub " .*" $temp {} PSEL(x)
			regsub ".* " $temp {} PSEL(y)
			set PSEL(x) [Trans $PSEL(x)]
			set PSEL(y) [Trans $PSEL(y)]
			if {($PSEL(x) == $bx) && ($PSEL(y) == $by)} {
				continue
			}
			if {[IsLegal $x $y 0] == 1} {
				.chess.mess config -text "You may not place the king in check."
				set PSEL(x) $pbx
				set PSEL(y) $pby
				set PCS($pby,$pbx) $InitPiece
				set PCS($by,$bx) $InitTarg
				return
			}
		}
	} {
		if {$PCS($PSEL(y),$PSEL(x)) != 29} {
			set temp [.chess.board coords $team(29)]
			regsub " .*" $temp {} x
			regsub ".* " $temp {} y
			set x [Trans $x]
			set y [Trans $y]
		}
		set PCS($pby,$pbx) 0
		set PCS($by,$bx) $InitPiece
		for {set t 1} {$t < 17} {incr t} {
			set temp [.chess.board coords $team($t)]
			regsub " .*" $temp {} PSEL(x)
			regsub ".* " $temp {} PSEL(y)
			set PSEL(x) [Trans $PSEL(x)]
			set PSEL(y) [Trans $PSEL(y)]
			if {($PSEL(x) == $bx) && ($PSEL(y) == $by)} {
				continue
			}
			if {[IsLegal $x $y 0] == 1} {
				.chess.mess config -text "You may not place the king in check."
				set PSEL(x) $pbx
				set PSEL(y) $pby
				set PCS($pby,$pbx) $InitPiece
				set PCS($by,$bx) $InitTarg
				return
			}
		}
	}
	set PSEL(x) $pbx
	set PSEL(y) $pby
	set PCS($pby,$pbx) $InitPiece
	set PCS($by,$bx) $InitTarg
	.chess.mess config -text "Moving..."
	puts $tprime "c15 c$NAME,$CHESSOP CHESS.move_selection $bx $by"
}
proc IsLegal {x y tst} {
	global PSEL
	global PCS
	global BOARD
	global CFCOL
	global team
	if {$PSEL(x) == -1} {.chess.mess config -text "You must select a piece first."; return 0}
	if {($PCS($PSEL(y),$PSEL(x)) >= 9) && ($PCS($PSEL(y),$PSEL(x)) <= 16) && ([string compare "wpawn" [.chess.board itemcget $team($PCS($PSEL(y),$PSEL(x))) -image]] == 0)} {
		if {([expr $y - $PSEL(y)] == 1) && ($PCS($y,$x) == 0) && ([expr $x - $PSEL(x)] == 0)} {
			.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) enpassant
			return 1
		}	
		if {([expr $y - $PSEL(y)] == 1) && ([expr $x - $PSEL(x)] == 1) && (($PCS($y,$x) >= 17) || (($PCS([expr $y -1],$x) >= 17) && ([regexp enpassant [.chess.board gettags $team($PCS([expr $y -1],$x))]])))} {
			if {([regexp enpassant [.chess.board gettags $team($PCS([expr $y -1],$x))]]) && ($tst == 1) && ($PCS([expr $y -1],$x) >= 17)} {
#				.chess.board delete $team($PCS([expr $y - 1],$x))
#				set PCS([expr $y -1],$x) 0
			}
			.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) enpassant
			return 1
		}
		if {([expr $y - $PSEL(y)] == 1) && ([expr $x - $PSEL(x)] == -1) && (($PCS($y,$x) >= 17) || (($PCS([expr $y -1],$x) >= 17) && ([regexp enpassant [.chess.board gettags $team($PCS([expr $y -1],$x))]])))} {
			if {([regexp enpassant [.chess.board gettags $team($PCS([expr $y -1],$x))]]) && ($tst == 1) && ($PCS([expr $y -1],$x) >= 17)} {
#				.chess.board delete $team($PCS([expr $y - 1],$x))
#				set PCS([expr $y -1],$x) 0
			}
			.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) enpassant
			return 1
		}
		if {([expr $y - $PSEL(y)] == 2) && ($PSEL(y) == 1) && ([expr $x - $PSEL(x)] == 0) && ($PCS($y,$x) == 0)} {
			.chess.board itemconfig $team($PCS($PSEL(y),$PSEL(x))) -tags "[.chess.board gettags $team($PCS($PSEL(y),$PSEL(x)))] enpassant"
			return 1
		}
	} 
	if {($PCS($PSEL(y),$PSEL(x)) >= 17) && ($PCS($PSEL(y),$PSEL(x)) <= 24) && ([string compare "bpawn" [.chess.board itemcget $team($PCS($PSEL(y),$PSEL(x))) -image]] == 0)} {
		if {([expr $y - $PSEL(y)] == -1) && ($PCS($y,$x) == 0) && ([expr $x - $PSEL(x)] == 0)} {
			.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) enpassant
			return 1
		}	
		if {([expr $y - $PSEL(y)] == -1) && ([expr $x - $PSEL(x)] == 1) && ((($PCS($y,$x) <= 16) && ($PCS($y,$x) > 0)) || ((($PCS([expr $y +1],$x) <= 16) && ($PCS([expr $y +1],$x) > 0))&& ([regexp enpassant [.chess.board gettags $team($PCS([expr $y +1],$x))]])))} {
			if {([regexp enpassant [.chess.board gettags $team($PCS([expr $y +1],$x))]]) && ($tst == 1) && (($PCS([expr $y +1],$x) <= 16) && ($PCS([expr $y +1],$x) > 0))} {
#				.chess.board delete $team($PCS([expr $y + 1],$x))
#				set PCS([expr $y +1],$x) 0
			}
			.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) enpassant
			return 1
		}
		if {([expr $y - $PSEL(y)] == -1) && ([expr $x - $PSEL(x)] == -1) && ((($PCS($y,$x) <= 16) && ($PCS($y,$x) > 0)) || ((($PCS([expr $y +1],$x) <= 16) && ($PCS([expr $y +1],$x) > 0))&& ([regexp enpassant [.chess.board gettags $team($PCS([expr $y +1],$x))]])))} {
			if {([regexp enpassant [.chess.board gettags $team($PCS([expr $y +1],$x))]]) && ($tst == 1) && (($PCS([expr $y +1],$x) <= 16) && ($PCS([expr $y +1],$x) > 0))} {
#				.chess.board delete $team($PCS([expr $y + 1],$x))
#				set PCS([expr $y +1],$x) 0
			}
			.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) enpassant
			return 1
		}
		if {([expr $y - $PSEL(y)] == -2) && ($PSEL(y) == 6) && ([expr $x - $PSEL(x)] == 0) && ($PCS($y,$x) == 0)} {
			.chess.board itemconfig $team($PCS($PSEL(y),$PSEL(x))) -tags "[.chess.board gettags $team($PCS($PSEL(y),$PSEL(x)))] enpassant"
			return 1
		}
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 1) || ($PCS($PSEL(y),$PSEL(x)) == 8)} {
		if {([expr $y - $PSEL(y)]) && ([expr $x - $PSEL(x)] == 0)} {
			if {[expr $y - $PSEL(y)] > 0} {
				for {set s [expr $PSEL(y) + 1]} {$s != $y} {incr s} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
			if {[expr $y - $PSEL(y)] < 0} {
				for {set s [expr $PSEL(y) - 1]} {$s != $y} {incr s -1} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
		}
		if {([expr $x - $PSEL(x)]) && ([expr $y - $PSEL(y)] == 0)} {
			if {[expr $x - $PSEL(x)] > 0} {
				for {set s [expr $PSEL(x) + 1]} {$s != $x} {incr s} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
			if {[expr $x - $PSEL(x)] < 0} {
				for {set s [expr $PSEL(x) - 1]} {$s != $x} {incr s -1} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
		}
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 25) || ($PCS($PSEL(y),$PSEL(x)) == 32)} {
		if {([expr $y - $PSEL(y)]) && ([expr $x - $PSEL(x)] == 0)} {
			if {[expr $y - $PSEL(y)] > 0} {
				for {set s [expr $PSEL(y) + 1]} {$s != $y} {incr s} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
			if {[expr $y - $PSEL(y)] < 0} {
				for {set s [expr $PSEL(y) - 1]} {$s != $y} {incr s -1} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
		}
		if {([expr $x - $PSEL(x)]) && ([expr $y - $PSEL(y)] == 0)} {
			if {[expr $x - $PSEL(x)] > 0} {
				for {set s [expr $PSEL(x) + 1]} {$s != $x} {incr s} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
			if {[expr $x - $PSEL(x)] < 0} {
				for {set s [expr $PSEL(x) - 1]} {$s != $x} {incr s -1} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				if {$tst == 1} {
					.chess.board dtag $team($PCS($PSEL(y),$PSEL(x))) castle
				}
				return 1
			}
		}
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 2) || ($PCS($PSEL(y),$PSEL(x)) == 7)} {
		if {([expr $x - $PSEL(x)] == 1) && ([expr $y - $PSEL(y)] == 2)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -1) && ([expr $y - $PSEL(y)] == 2)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -1) && ([expr $y - $PSEL(y)] == -2)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == 1) && ([expr $y - $PSEL(y)] == -2)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == 2) && ([expr $y - $PSEL(y)] == 1)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -2) && ([expr $y - $PSEL(y)] == -1)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -2) && ([expr $y - $PSEL(y)] == 1)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == 2) && ([expr $y - $PSEL(y)] == -1)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {
				return 0
			}
			return 1
		}
		return 0
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 26) || ($PCS($PSEL(y),$PSEL(x)) == 31)} {
		if {([expr $x - $PSEL(x)] == 1) && ([expr $y - $PSEL(y)] == 2)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -1) && ([expr $y - $PSEL(y)] == 2)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == 1) && ([expr $y - $PSEL(y)] == -2)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -1) && ([expr $y - $PSEL(y)] == -2)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == 2) && ([expr $y - $PSEL(y)] == 1)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -2) && ([expr $y - $PSEL(y)] == 1)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == 2) && ([expr $y - $PSEL(y)] == -1)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		if {([expr $x - $PSEL(x)] == -2) && ([expr $y - $PSEL(y)] == -1)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {
				return 0
			}
			return 1
		}
		return 0
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 3) || ($PCS($PSEL(y),$PSEL(x)) == 6)} {
		if {([expr $y - $PSEL(y)] != [expr $x - $PSEL(x)]) && ([expr $y -$PSEL(y)] != [expr -1 * [expr $x - $PSEL(x)]])} {return 0}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s -1;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s -1;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
		return 0
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 27) || ($PCS($PSEL(y),$PSEL(x)) == 30)} {
		if {([expr $y - $PSEL(y)] != [expr $x - $PSEL(x)]) && ([expr $y -$PSEL(y)] != [expr -1 * [expr $x - $PSEL(x)]])} {return 0}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s -1;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s -1;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 4) || (($PCS($PSEL(y),$PSEL(x)) >= 9) && ($PCS($PSEL(y),$PSEL(x)) <= 16) && ([string compare "wqueen" [.chess.board itemcget $team($PCS($PSEL(y),$PSEL(x))) -image]] == 0))} {
		if {([expr $y - $PSEL(y)]) && ([expr $x - $PSEL(x)] == 0)} {
			if {[expr $y - $PSEL(y)] > 0} {
				for {set s [expr $PSEL(y) + 1]} {$s != $y} {incr s} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				return 1
			}
			if {[expr $y - $PSEL(y)] < 0} {
				for {set s [expr $PSEL(y) - 1]} {$s != $y} {incr s -1} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				return 1
			}
		}
		if {([expr $x - $PSEL(x)]) && ([expr $y - $PSEL(y)] == 0)} {
			if {[expr $x - $PSEL(x)] > 0} {
				for {set s [expr $PSEL(x) + 1]} {$s != $x} {incr s} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				return 1
			}
			if {[expr $x - $PSEL(x)] < 0} {
				for {set s [expr $PSEL(x) - 1]} {$s != $x} {incr s -1} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
				return 1
			}
		}
		if {([expr $y - $PSEL(y)] != [expr $x - $PSEL(x)]) && ([expr $y -$PSEL(y)] != [expr -1 * [expr $x - $PSEL(x)]])} {return 0}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s -1;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s -1;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			return 1
		}
	}
	if {($PCS($PSEL(y),$PSEL(x)) == 28) || (($PCS($PSEL(y),$PSEL(x)) >= 17) && ($PCS($PSEL(y),$PSEL(x)) <= 24) && ([string compare "bqueen" [.chess.board itemcget $team($PCS($PSEL(y),$PSEL(x))) -image]] == 0))} {
		if {([expr $y - $PSEL(y)]) && ([expr $x - $PSEL(x)] == 0)} {
			if {[expr $y - $PSEL(y)] > 0} {
				for {set s [expr $PSEL(y) + 1]} {$s != $y} {incr s} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				return 1
			}
			if {[expr $y - $PSEL(y)] < 0} {
				for {set s [expr $PSEL(y) - 1]} {$s != $y} {incr s -1} {
					if {$PCS($s,$x)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				return 1
			}
		}
		if {([expr $x - $PSEL(x)]) && ([expr $y - $PSEL(y)] == 0)} {
			if {[expr $x - $PSEL(x)] > 0} {
				for {set s [expr $PSEL(x) + 1]} {$s != $x} {incr s} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				return 1
			}
			if {[expr $x - $PSEL(x)] < 0} {
				for {set s [expr $PSEL(x) - 1]} {$s != $x} {incr s -1} {
					if {$PCS($y,$s)} {
						return 0
					}
				}
				if {$PCS($y,$x) >= 17} {return 0}
				return 1
			}
		}
		if {([expr $y - $PSEL(y)] != [expr $x - $PSEL(x)]) && ([expr $y -$PSEL(y)] != [expr -1 * [expr $x - $PSEL(x)]])} {return 0}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] > 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) + 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] > 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) + 1]} {$s != $y} {incr s -1;incr m} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
		if {([expr $y - $PSEL(y)] < 0) && ([expr $x - $PSEL(x)] < 0)} {
			for {set s [expr $PSEL(y) - 1]; set m [expr $PSEL(x) - 1]} {$s != $y} {incr s -1;incr m -1} {
				if {$PCS($s,$m)} {
					return 0
				}
			}
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			return 1
		}
	}
	if {$PCS($PSEL(y),$PSEL(x)) == 5} {
		if {(([expr $x - $PSEL(x)] == 1) || ([expr $x - $PSEL(x)] == -1)) && ([expr $y - $PSEL(y)] == 0)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			.chess.board dtag $team(5) castle
			return 1
		}
		if {(([expr $y - $PSEL(y)] == 1) || ([expr $y - $PSEL(y)] == -1)) && ([expr $x - $PSEL(x)] == 0)} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			.chess.board dtag $team(5) castle
			return 1
		}	
		if {(([expr $y - $PSEL(y)] == 1) || ([expr $y - $PSEL(y)] == -1)) && (([expr $x - $PSEL(x)] == -1) || ([expr $x - $PSEL(x)] == 1))} {
			if {($PCS($y,$x) > 0) && ($PCS($y,$x) <= 16)} {return 0}
			.chess.board dtag $team(5) castle
			return 1
		}
		if {($y == 0) && ($x == 2) && ([regexp "castle" [.chess.board gettags $team(5)]])} {
			if [regexp "castle" [.chess.board gettags $team(1)]] {
				if {($PCS(0,1) == 0) && ($PCS(0,2) == 0) && ($PCS(0,3) == 0)} {
					if [IsSpaceUnderAttack 1 2 0] {return 0}
					if [IsSpaceUnderAttack 1 3 0] {return 0}
					if [IsSpaceUnderAttack 1 4 0] {return 0}
					if {$tst == 0} {return 1}
					.chess.board move $team(1) 129 0
					set PCS(0,0) 0
					set PCS(0,3) 1
					.chess.board dtag $team(1) castle
					.chess.board dtag $team(5) castle
					return 1
				}
			}
		}
		if {($y == 0) && ($x == 6) && ([regexp "castle" [.chess.board gettags $team(5)]])} {
			if [regexp "castle" [.chess.board gettags $team(8)]] {
				if {($PCS(0,5) == 0) && ($PCS(0,6) == 0)} {
					if [IsSpaceUnderAttack 1 4 0] {return 0}
					if [IsSpaceUnderAttack 1 5 0] {return 0}
					if [IsSpaceUnderAttack 1 6 0] {return 0}
					if {$tst == 0} {return 1}
					.chess.board move $team(8) -86 0
					set PCS(0,7) 0
					set PCS(0,5) 8
					.chess.board dtag $team(8) castle
					.chess.board dtag $team(5) castle
					return 1
				}
			}
		}
	}
	if {$PCS($PSEL(y),$PSEL(x)) == 29} {
		if {(([expr $x - $PSEL(x)] == 1) || ([expr $x - $PSEL(x)] == -1)) && ([expr $y - $PSEL(y)] == 0)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			.chess.board dtag $team(29) castle
			return 1
		}
		if {(([expr $y - $PSEL(y)] == 1) || ([expr $y - $PSEL(y)] == -1)) && ([expr $x - $PSEL(x)] == 0)} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			.chess.board dtag $team(29) castle
			return 1
		}	
		if {(([expr $y - $PSEL(y)] == 1) || ([expr $y - $PSEL(y)] == -1)) && (([expr $x - $PSEL(x)] == -1) || ([expr $x - $PSEL(x)] == 1))} {
			if {($PCS($y,$x) >= 17) && ($PCS($y,$x) <= 32)} {return 0}
			.chess.board dtag $team(29) castle
			return 1
		}
		if {($y == 7) && ($x == 2) && ([regexp "castle" [.chess.board gettags $team(29)]])} {
			if [regexp "castle" [.chess.board gettags $team(25)]] {
				if {($PCS(7,1) == 0) && ($PCS(7,2) == 0) && ($PCS(7,3) == 0)} {
					if [IsSpaceUnderAttack 2 2 7] {return 0}
					if [IsSpaceUnderAttack 2 3 7] {return 0}
					if [IsSpaceUnderAttack 2 4 7] {return 0}
					if {$tst == 0} {return 1}
					.chess.board move $team(25) 129 0
					set PCS(7,0) 0
					set PCS(7,3) 25
					.chess.board dtag $team(25) castle
					.chess.board dtag $team(29) castle
					return 1
				}
			}
		}
		if {($y == 7) && ($x == 6) && ([regexp "castle" [.chess.board gettags $team(29)]])} {
			if [regexp "castle" [.chess.board gettags $team(32)]] {
				if {($PCS(7,5) == 0) && ($PCS(7,6) == 0)} {
					if [IsSpaceUnderAttack 2 4 7] {return 0}
					if [IsSpaceUnderAttack 2 5 7] {return 0}
					if [IsSpaceUnderAttack 2 6 7] {return 0}
					if {$tst == 0} {return 1}
					.chess.board move $team(32) -86 0
					set PCS(7,7) 0
					set PCS(7,5) 32
					.chess.board dtag $team(32) castle
					.chess.board dtag $team(29) castle
					return 1
				}
			}
		}
	}
	return 0
}
proc Trans {n} {
	if {$n <= 42} {return 0}
	if {$n <= 85} {return 1}
	if {$n <= 128} {return 2}
	if {$n <= 171} {return 3}
	if {$n <= 214} {return 4}
	if {$n <= 257} {return 5}
	if {$n <= 300} {return 6}
	if {$n <= 343} {return 7}
	return -1
}
proc RemoteSelectPiece {x y} {
	global PCS
	global PSEL
	global CHESSHL
	global BOARD
	global CFCOL
	if {$PCS($y,$x) == 0} {return}
	catch {.chess.board itemconfig $BOARD($PSEL(y),$PSEL(x)) -fill $CFCOL}
	set PSEL(x) $x
	set PSEL(y) $y
	set CFCOL [.chess.board itemcget $BOARD($y,$x) -fill]
	.chess.board itemconfig $BOARD($y,$x) -fill $CHESSHL
}
proc SelectPiece {x y} {
	global CHESSOP
	global tprime
	global PCS
	global PSEL
	global CHESSHL
	global BOARD
	global CFCOL
	global TURN
	global NAME
	if {$TURN != $NAME} {return}
	set x [Trans $x]
	set y [Trans $y]
	if {$PCS($y,$x) == 0} {return}
	puts $tprime "c15 c$CHESSOP CHESS.select $x $y\n"
	catch {.chess.board itemconfig $BOARD($PSEL(y),$PSEL(x)) -fill $CFCOL}
	set PSEL(x) $x
	set PSEL(y) $y
	set CFCOL [.chess.board itemcget $BOARD($y,$x) -fill]
	.chess.board itemconfig $BOARD($y,$x) -fill $CHESSHL
}
proc DefinePieces {} {
	global CWHITE
	global CBLACK
	set bishop {#define bishop_width 43
#define bishop_height 43
static unsigned char bishop_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x00, 0x00,
   0x00, 0x00, 0xf0, 0x01, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x00, 0x00,
   0x00, 0x00, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00,
   0x00, 0x00, 0xf8, 0x03, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x07, 0x00, 0x00,
   0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x1f, 0x00, 0x00,
   0x00, 0x80, 0xff, 0x3f, 0x00, 0x00, 0x00, 0xc0, 0xbf, 0x7f, 0x00, 0x00,
   0x00, 0xe0, 0xbf, 0xff, 0x00, 0x00, 0x00, 0xe0, 0xbf, 0xff, 0x00, 0x00,
   0x00, 0xf0, 0xbf, 0xff, 0x01, 0x00, 0x00, 0xf0, 0x07, 0xfc, 0x01, 0x00,
   0x00, 0xf0, 0xbf, 0xff, 0x01, 0x00, 0x00, 0xf0, 0xbf, 0xff, 0x01, 0x00,
   0x00, 0xf0, 0xbf, 0xff, 0x01, 0x00, 0x00, 0xe0, 0xff, 0xff, 0x00, 0x00,
   0x00, 0xe0, 0xff, 0xff, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0x07, 0x7c, 0x00, 0x00, 0x00, 0x80, 0xe1, 0x30, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0x00, 0x40, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x40, 0x00, 0x00,
   0x00, 0xe0, 0xff, 0xff, 0x00, 0x00, 0x00, 0xe0, 0xff, 0xff, 0x00, 0x00,
   0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00,
   0x00, 0x00, 0xf8, 0x03, 0x00, 0x00, 0xc0, 0xff, 0xff, 0xff, 0x7f, 0x00,
   0xe0, 0xff, 0xff, 0xff, 0xff, 0x00, 0xf0, 0xff, 0xbf, 0xff, 0xff, 0x01,
   0xe0, 0xff, 0x0f, 0xfe, 0xff, 0x00, 0x40, 0x00, 0x00, 0x00, 0x40, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
	image create bitmap wbishop -data $bishop -foreground $CWHITE
	image create bitmap bbishop -data $bishop -foreground $CBLACK
	set knight {#define knight_width 43
#define knight_height 43
static unsigned char knight_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x30, 0x00, 0x00, 0x00,
   0x00, 0x70, 0x30, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x78, 0x00, 0x00, 0x00,
   0x00, 0xe0, 0x79, 0x00, 0x00, 0x00, 0x00, 0xe0, 0xff, 0x07, 0x00, 0x00,
   0x00, 0xf0, 0xf8, 0x38, 0x00, 0x00, 0x00, 0xf8, 0xff, 0x47, 0x00, 0x00,
   0x00, 0xf8, 0xff, 0xbf, 0x00, 0x00, 0x00, 0x3c, 0xfe, 0x7f, 0x01, 0x00,
   0x00, 0x1c, 0xff, 0xff, 0x02, 0x00, 0x00, 0xcc, 0xff, 0xff, 0x04, 0x00,
   0x00, 0xec, 0xff, 0xff, 0x05, 0x00, 0x00, 0xec, 0xff, 0xff, 0x09, 0x00,
   0x00, 0xfe, 0xff, 0xff, 0x09, 0x00, 0x00, 0xfe, 0xff, 0xff, 0x13, 0x00,
   0x00, 0xff, 0xff, 0xff, 0x13, 0x00, 0x80, 0xff, 0xff, 0xff, 0x37, 0x00,
   0x80, 0xff, 0xff, 0xff, 0x27, 0x00, 0xc0, 0xff, 0xbf, 0xff, 0x27, 0x00,
   0xc0, 0xff, 0x9f, 0xff, 0x2f, 0x00, 0x60, 0xfe, 0x87, 0xff, 0x4f, 0x00,
   0x60, 0xfe, 0xc1, 0xff, 0x4f, 0x00, 0x60, 0xff, 0xc0, 0xff, 0x4f, 0x00,
   0xe0, 0x3f, 0xe0, 0xff, 0x5f, 0x00, 0xc0, 0x1f, 0xe0, 0xff, 0x5f, 0x00,
   0x80, 0x0f, 0xf0, 0xff, 0x5f, 0x00, 0x00, 0x07, 0xf0, 0xff, 0x5f, 0x00,
   0x00, 0x00, 0xf8, 0xff, 0x5f, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x5f, 0x00,
   0x00, 0x00, 0xfe, 0xff, 0x5f, 0x00, 0x00, 0x00, 0xfe, 0xff, 0x5f, 0x00,
   0x00, 0x00, 0xff, 0xff, 0x5f, 0x00, 0x00, 0x80, 0xff, 0xff, 0x5f, 0x00,
   0x00, 0xc0, 0xff, 0xff, 0x5f, 0x00, 0x00, 0xc0, 0xff, 0xff, 0x7f, 0x00,
   0x00, 0xc0, 0xff, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
	image create bitmap wknight -data $knight -foreground $CWHITE
	image create bitmap bknight -data $knight -foreground $CBLACK
	set king {#define king_width 43
#define king_height 43
static unsigned char king_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00,
   0x00, 0x00, 0xf0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0xe8, 0x02, 0x00, 0x00,
   0x00, 0x00, 0xe8, 0x02, 0x00, 0x00, 0x00, 0x7e, 0xe8, 0xc2, 0x0f, 0x00,
   0x00, 0x81, 0xe8, 0x22, 0x10, 0x00, 0x80, 0x7e, 0xe9, 0xd2, 0x2f, 0x00,
   0x40, 0xff, 0xee, 0xee, 0x5f, 0x00, 0xa0, 0xff, 0x5d, 0xf7, 0xbf, 0x00,
   0xd0, 0xff, 0x5b, 0xfb, 0x7f, 0x01, 0xd0, 0xff, 0xb7, 0xfd, 0x7f, 0x01,
   0xd0, 0xff, 0xaf, 0xfe, 0x7f, 0x01, 0xd0, 0xff, 0x5f, 0xff, 0x7f, 0x01,
   0xd0, 0xff, 0x5f, 0xff, 0x7f, 0x01, 0xa0, 0xff, 0x5f, 0xff, 0xbf, 0x00,
   0x40, 0xff, 0x5f, 0xff, 0x5f, 0x00, 0x80, 0xfe, 0x01, 0xf0, 0x2f, 0x00,
   0x00, 0x0d, 0xfc, 0x07, 0x16, 0x00, 0x00, 0xe2, 0xff, 0xff, 0x08, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0x3c, 0x00, 0x80, 0x07, 0x00,
   0x00, 0x0c, 0xff, 0x3f, 0x06, 0x00, 0x00, 0xfc, 0x03, 0xf8, 0x07, 0x00,
   0x00, 0x1c, 0xfc, 0x07, 0x07, 0x00, 0x00, 0xcc, 0xff, 0x7f, 0x06, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xf0, 0xff, 0xff, 0x01, 0x00,
   0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
	image create bitmap wking -data $king -foreground $CWHITE
	image create bitmap bking -data $king -foreground $CBLACK
	set pawn {#define pawn_width 43
#define pawn_height 43
static unsigned char pawn_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x00, 0x00,
   0x00, 0x00, 0xf8, 0x03, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x07, 0x00, 0x00,
   0x00, 0x00, 0xfc, 0x07, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x07, 0x00, 0x00,
   0x00, 0x00, 0xfc, 0x07, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x03, 0x00, 0x00,
   0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x1f, 0x00, 0x00,
   0x00, 0x80, 0xff, 0x3f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0x80, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x1f, 0x00, 0x00,
   0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x07, 0x00, 0x00,
   0x00, 0x00, 0xff, 0x1f, 0x00, 0x00, 0x00, 0x80, 0xff, 0x3f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xe0, 0xff, 0xff, 0x00, 0x00,
   0x00, 0xf0, 0xff, 0xff, 0x01, 0x00, 0x00, 0xf0, 0xff, 0xff, 0x01, 0x00,
   0x00, 0xf8, 0xff, 0xff, 0x03, 0x00, 0x00, 0xf8, 0xff, 0xff, 0x03, 0x00,
   0x00, 0xf8, 0xff, 0xff, 0x03, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
	image create bitmap wpawn -data $pawn -foreground $CWHITE
	image create bitmap bpawn -data $pawn -foreground $CBLACK
	set queen {#define queen_width 43
#define queen_height 43
static unsigned char queen_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00,
   0x00, 0xf0, 0xf0, 0xc1, 0x01, 0x00, 0x00, 0xf8, 0xf1, 0xe1, 0x03, 0x00,
   0x00, 0xf8, 0xf1, 0xe1, 0x03, 0x00, 0x38, 0xf8, 0xe1, 0xe0, 0x83, 0x03,
   0x7c, 0xf0, 0x40, 0xc0, 0xc1, 0x07, 0x7c, 0x60, 0xe0, 0x80, 0xc0, 0x07,
   0x7c, 0x60, 0xe0, 0xc0, 0xc0, 0x07, 0x38, 0xe0, 0xe0, 0xc0, 0x80, 0x03,
   0x60, 0xe0, 0xe0, 0xe0, 0xc0, 0x00, 0x60, 0xe0, 0xe0, 0xe0, 0xc0, 0x00,
   0xe0, 0xe0, 0xe1, 0xe0, 0xe0, 0x00, 0xe0, 0xe0, 0xe1, 0xf0, 0xe0, 0x00,
   0xc0, 0xf1, 0xf1, 0xf1, 0x71, 0x00, 0xc0, 0xf1, 0xf3, 0xf9, 0x71, 0x00,
   0xc0, 0xf3, 0xf3, 0xf9, 0x79, 0x00, 0xc0, 0xf3, 0xf7, 0xfd, 0x39, 0x00,
   0x80, 0xf7, 0xf7, 0xfd, 0x3d, 0x00, 0x80, 0xff, 0xff, 0xff, 0x3f, 0x00,
   0x80, 0xff, 0xff, 0xff, 0x3f, 0x00, 0x00, 0xff, 0xff, 0xff, 0x1f, 0x00,
   0x00, 0xff, 0xff, 0xff, 0x1f, 0x00, 0x00, 0xff, 0xff, 0xff, 0x1f, 0x00,
   0x00, 0xfe, 0xff, 0xff, 0x0f, 0x00, 0x00, 0xfe, 0x00, 0xc0, 0x0f, 0x00,
   0x00, 0x06, 0xfe, 0x0f, 0x0c, 0x00, 0x00, 0x04, 0xfe, 0x0f, 0x04, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0xfc, 0x00, 0xc0, 0x07, 0x00, 0x00, 0x0c, 0xff, 0x3f, 0x06, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xfe, 0xff, 0xff, 0x0f, 0x00,
   0x00, 0xfe, 0xff, 0xff, 0x0f, 0x00, 0x00, 0xff, 0xff, 0xff, 0x1f, 0x00,
   0x00, 0xfe, 0xff, 0xff, 0x0f, 0x00, 0x00, 0x00, 0xff, 0x3f, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
	image create bitmap wqueen -data $queen -foreground $CWHITE
	image create bitmap bqueen -data $queen -foreground $CBLACK
	set rook {#define rook_width 43
#define rook_height 43
static unsigned char rook_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0xfc, 0xf0, 0xc1, 0x07, 0x00, 0x00, 0xfc, 0xf0, 0xc1, 0x07, 0x00,
   0x00, 0xfc, 0xf0, 0xc1, 0x07, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0x18, 0x00, 0x00, 0x03, 0x00, 0x00, 0xf0, 0xff, 0xff, 0x01, 0x00,
   0x00, 0xe0, 0xff, 0xff, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x60, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0xc0, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xe0, 0x00, 0xe0, 0x00, 0x00,
   0x00, 0xf0, 0xff, 0xff, 0x01, 0x00, 0x00, 0xf8, 0xff, 0xff, 0x03, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x06, 0x00,
   0x00, 0xfc, 0xff, 0xff, 0x07, 0x00, 0x00, 0xfc, 0xff, 0xff, 0x07, 0x00,
   0x00, 0x07, 0x00, 0x00, 0x1c, 0x00, 0x00, 0xff, 0xff, 0xff, 0x1f, 0x00,
   0x00, 0xff, 0xff, 0xff, 0x1f, 0x00, 0x00, 0xff, 0xff, 0xff, 0x1f, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
	image create bitmap wrook -data $rook -foreground $CWHITE
	image create bitmap brook -data $rook -foreground $CBLACK
}
proc Chess_InitBoard {myteam} {
	global team
	global PSEL
	global CHECK1
	global CHECK2
	global PCS
	global BOARD
	global Mteam
	global CHESSLOG
	set Mteam $myteam
	DefinePieces
	set row 0
	set col 0
	destroy .chess
	toplevel .chess
	wm title .chess Chess
	canvas .chess.board -width 344 -height 344
	pack .chess.board
	ScrolledTextWidget .chess.log -width 3 -height 1 -takefocus 0
	.chess.log.text config -state disabled
	if {$CHESSLOG == 1} {
		pack .chess.log -side top -fill x -expand true
	}
	label .chess.mess -text "Chess" -anchor w
	pack .chess.mess -side top -fill x -expand true
	set x 0
	set color $CHECK2
	set PSEL(x) -1
	set PSEL(y) -1
	for {} {$row != 8} {} {
		for {} {$col != 8} {incr col} {
			if {$color == $CHECK1} {set color $CHECK2} {set color $CHECK1}
			set BOARD($row,$col) [.chess.board create rect [expr $col * 43 + $x] [expr $row * 43] [expr 43 + [expr $col * 43] +$x] [expr 43 + [expr $row * 43]] -fill $color -width 0 -tags spot]
		}
		set col 0
		incr row
		if {$color == $CHECK1} {set color $CHECK2} {set color $CHECK1}
	}
	set team(0) "Crash test dummy"
	set team(1) [.chess.board create image 0 0 -image wrook -anchor nw]
	set team(2) [.chess.board create image 43 0 -image wknight -anchor nw]
	set team(3) [.chess.board create image 86 0 -image wbishop -anchor nw]
	set team(4) [.chess.board create image 129 0 -image wqueen -anchor nw]
	set team(5) [.chess.board create image 172 0 -image wking -anchor nw]
	set team(6) [.chess.board create image 215 0 -image wbishop -anchor nw]
	set team(7) [.chess.board create image 258 0 -image wknight -anchor nw]
	set team(8) [.chess.board create image 301 0 -image wrook -anchor nw]
	for {set x 9; set y 1} {$x != 17} {incr x; incr y} {
		set team($x) [.chess.board create image [expr [expr $y -1] * 43] 43 -image wpawn -anchor nw]
	}
	set team(25) [.chess.board create image 0 301 -image brook -anchor nw]
	set team(26) [.chess.board create image 43 301 -image bknight -anchor nw]
	set team(27) [.chess.board create image 86 301 -image bbishop -anchor nw]
	set team(28) [.chess.board create image 129 301 -image bqueen -anchor nw]
	set team(29) [.chess.board create image 172 301 -image bking -anchor nw]
	set team(30) [.chess.board create image 215 301 -image bbishop -anchor nw]
	set team(31) [.chess.board create image 258 301 -image bknight -anchor nw]
	set team(32) [.chess.board create image 301 301 -image brook -anchor nw]
	for {set x 17; set y 1} {$x != 25} {incr x; incr y} {
		set team($x) [.chess.board create image [expr [expr $y -1] * 43] 258 -image bpawn -anchor nw]
	}
	if {$myteam == 1} {
		for {set x 1} {$x <= 16} {incr x} {
			.chess.board itemconfig $team($x) -tags mine 
			if {($x == 5) || ($x == 1) || ($x == 8)} {
				.chess.board itemconfig $team($x) -tags "mine castle"
			}
		}
		for {} {$x <= 32} {incr x} {
			.chess.board itemconfig $team($x) -tags "spot castle"
		}
	} { 
		if {$myteam == 2} {
			for {set x 17} {$x <= 32} {incr x} {
				.chess.board itemconfig $team($x) -tags mine
				if {($x == 25) || ($x == 29) || ($x == 32)} {
					.chess.board itemconfig $team($x) -tags "mine castle"
				}
			}
			for {set x 1} {$x <= 16} {incr x} {
				.chess.board itemconfig $team($x) -tags "spot castle"
			}
		}
	}
	for {set y 0} {$y <= 7} {incr y} {
		for {set x 0} {$x <= 7} {incr x} {
			set PCS($x,$y) 0
		}
	}
	set PCS(0,0) 1
	set PCS(0,1) 2
	set PCS(0,2) 3
	set PCS(0,3) 4
	set PCS(0,4) 5
	set PCS(0,5) 6
	set PCS(0,6) 7
	set PCS(0,7) 8
	set PCS(1,0) 9
	set PCS(1,1) 10
	set PCS(1,2) 11
	set PCS(1,3) 12
	set PCS(1,4) 13
	set PCS(1,5) 14
	set PCS(1,6) 15
	set PCS(1,7) 16
	set PCS(6,0) 17
	set PCS(6,1) 18
	set PCS(6,2) 19
	set PCS(6,3) 20
	set PCS(6,4) 21
	set PCS(6,5) 22
	set PCS(6,6) 23
	set PCS(6,7) 24
	set PCS(7,0) 25
	set PCS(7,1) 26
	set PCS(7,2) 27
	set PCS(7,3) 28
	set PCS(7,4) 29
	set PCS(7,5) 30
	set PCS(7,6) 31
	set PCS(7,7) 32
	.chess.board bind spot <ButtonRelease> {catch {LocalMove %x %y}}
	.chess.board bind mine <ButtonRelease> {catch {SelectPiece %x %y}}
	bind .chess <Destroy> {ChessCleanup; break}
	wm protocol .chess WM_DELETE_WINDOW {ChessCleanup}
	wm resizable .chess 0 0
	MakeRelay .chess
	bind .chess <Escape> {break}
	bind .chess <Key-F1> {faq CHELP}
}
proc UpdateTrig {} {
	global triggers
	.trig.list.list delete 0 end
	foreach of [array names triggers] {
		if [regexp "^#TkTurf System Trigger\n" $triggers($of)] {continue}
		.trig.list.list insert end $of
	}
}
proc TrigWin {} {
	destroy .trig
	toplevel .trig
	wm title .trig "Trigger Control Panel"
	wm geometry .trig +[winfo pointerx .]+[winfo pointery .]
	ScrolledListWidget .trig.list -selectmode single
	frame .trig.bot
	button .trig.bot.new -text "New" -command {ATW {}}
	button .trig.bot.edit -text "Edit" -command {catch {ATW [.trig.list.list get [.trig.list.list curselection]]}}
	button .trig.bot.del -text "Delete" -command {catch {deltrig [.trig.list.list get [.trig.list.list curselection]]}}
	button .trig.bot.can -text "Close" -command {destroy .trig}
	button .trig.bot.help -text Help -command {faq TRI}
	pack .trig.list -side top -fill both -expand true
	pack .trig.bot -side top -fill x -expand true
	pack .trig.bot.new -side left
	pack .trig.bot.edit -side left
	pack .trig.bot.del -side left
	pack .trig.bot.help -side left
	pack .trig.bot.can -side left
	bind .trig.list.list <Double-Button> {ATW [.trig.list.list get [.trig.list.list curselection]]}
	catch {UpdateTrig}
	bind .trig <Escape> {destroy .trig}
	center .trig
}
proc deltrig {name} {
	global triggers
	unset triggers($name)
	catch {UpdateTrig}
	SaveTrigs
}
proc SaveTrigs {} {
	global triggers
	global PBUF
	Preferences::buffer
	set file [Preferences::writeopen]
	if {[string compare $file "NULL"] == 0} {return}
	regsub -all "trigger\[^\n\]*" $PBUF {} PBUF
	regsub -all "TRIGGER\[^\n\]*" $PBUF {} PBUF
	foreach of [array names triggers] {
		if [regexp "^#TkTurf System Trigger\n" $triggers($of)] {continue}
		regsub -all "\n" $triggers($of) ";" trig
		append PBUF "\nTRIGGER \"$of\" $trig\n"
	}
	Preferences::dump $file
}
proc addtrigger {name effect old} {
	global triggers
	catch {unset triggers($old)}
	regsub -all "\\\n" $effect "\n" effect
	set triggers($name) $effect
	catch {UpdateTrig}
	SaveTrigs
}
proc sndinsert {win} {
	set sfile [getOpenFile]
	if {[string length $sfile] < 1} {
		return
	}
	if ![regexp "\.0$" [$win index insert]] {$win insert insert "\n"}
	$win insert insert "playsound \"$sfile\"\n"
}
proc ATW {trig} {
	global winc
	global triggers
	incr winc
	toplevel .$winc
	wm title .$winc "Add a Trigger"
	label .$winc.help -text "Triggers in TkTurf use regular expressions for searches, if you are\nnot sure what a regular expression is see the help menu item on them."
	pack .$winc.help -side top -fill x -expand true
	frame .$winc.mid
	label .$winc.mid.lab -text "Enter the regular expression to find here"
	entry .$winc.mid.ent -width 35
	catch {.$winc.mid.ent insert end $trig}
	bind .$winc.mid.ent <Return> {focus [tk_focusNext %W]}
	pack .$winc.mid -side top -fill x -expand true
	pack .$winc.mid.lab -side left
	pack .$winc.mid.ent -side left -fill x -expand true
	label .$winc.lab -text "Enter the TCL code to execute when triggered." -anchor w
	ScrolledTextWidget .$winc.code -width 40 -height 10 -wrap word
	if [catch {.$winc.code.text insert end $triggers($trig)}] {
		.$winc.code.text insert end "# This is a sample trigger script\n# All it does is make you say \"This is a default text reply to a trigger\"\n# The playsound \"\" command would play a sound if the file it was given\n# actually existed. Lines starting with # are comments.\n\n"
		.$winc.code.text insert end {send "say This is a default text reply to a trigger"}
		.$winc.code.text insert end \n
		.$winc.code.text insert end {playsound "/the/default/sound/toplay.wav"}
	}
	pack .$winc.lab -side top -fill x -expand true
	pack .$winc.code -side top -fill x -expand true
	frame .$winc.bot
	button .$winc.bot.add -text "Add Trigger" -command "addtrigger \[.$winc.mid.ent get\] \[.$winc.code.text get 0.0 end\] {$trig}; destroy .$winc"
	button .$winc.bot.sound -text "Insert Sound" -command "sndinsert .$winc.code.text"
	button .$winc.bot.can -text Cancel -command "destroy .$winc"
	button .$winc.bot.tri -text "Trigger Help" -command {faq TRI}
	button .$winc.bot.help -text "Scripting Help" -command {faq TCODE}
	pack .$winc.bot.help -side right
	pack .$winc.bot.tri -side right
	pack .$winc.bot.can -side right
	pack .$winc.bot.add -side right
	pack .$winc.bot.sound -side right
	pack .$winc.bot -side top -fill x -expand true
	focus .$winc.mid.ent
	bind .$winc <Escape> "destroy .$winc"
	center .$winc
}
proc logindel {name} {
	global logins
	global PBUF
	unset logins($name)
	Preferences::buffer
	set file [Preferences::writeopen]
	if {[string compare $file "NULL"] == 0} {return}
	regsub -all "login: *$name *\[^\n\]*" $PBUF {} PBUF
	Preferences::dump $file
	catch {UpdateDLW}
}
proc UpdateDLW {} {
	global logins
	catch {.dlw.list.list delete 0 end}
	set alist [lsort -ascii [array names logins]]
	set length [llength $alist]
	for {set i 0} {$i != $length} {incr i} {
		.dlw.list.list insert end [lindex $alist $i]
	}
}
proc DLW {} {
	global logins
	destroy .dlw
	toplevel .dlw
	wm title .dlw "Login Control Panel"
	ScrolledListWidget .dlw.list -selectmode single
	UpdateDLW
	frame .dlw.bot
	button .dlw.bot.new -text New -command {ALW {}}
	button .dlw.bot.edit -text Edit -command {catch {ALW [.dlw.list.list get [.dlw.list.list curselection]]}}
	button .dlw.bot.can -text Close -command {destroy .dlw}
	bind .dlw.list.list <Double-Button> {catch {ALW [.dlw.list.list get [.dlw.list.list curselection]]}}
	button .dlw.bot.del -text Delete -command {catch {logindel [.dlw.list.list get [.dlw.list.list curselection]]}}
	pack .dlw.list -side top -fill both -expand true
	pack .dlw.bot -side top -fill x -expand true
	pack .dlw.bot.can -side right
	pack .dlw.bot.del -side right
	pack .dlw.bot.edit -side right
	pack .dlw.bot.new -side right
	bind .dlw <Escape> {destroy .dlw}
	center .dlw
}
proc Login {name} {
	global logins
	global tprime
	catch {puts $tprime "$name\n$logins($name)\n   \n"}
}
proc AutoLoginWin {} {
	global logins
	global ALL
	set names [lsort -ascii [array names logins]]
	if {[llength $names] == 0} {return}
	if {$ALL == 1} {
		if {[llength $names] == 1} {Login [lindex $names 0]; return}
	}
	destroy .names
	toplevel .names
	wm title .names "Autologin Names"
	ScrolledListWidget .names.list -selectmode single
	set length [llength $names]
        for {set i 0} {$i != $length} {incr i} {
                .names.list.list insert end [lindex $names $i]
        }
	frame .names.bot
	button .names.bot.send -text Login -command {catch {Login [.names.list.list get [.names.list.list curselection]]; destroy .names}}
	button .names.bot.can -text Cancel -command {destroy .names}
	pack .names.list -side top -fill both -expand true
	pack .names.bot -side top -fill x -expand true
	pack .names.bot.can -side right
	pack .names.bot.send -side right
	bind .names.list.list <Double-Button> {Login [.names.list.list get [.names.list.list curselection]]; destroy .names}
	center .names
	bind .names <Escape> {destroy .names}
}
proc AL {args} {
	global PBUF
	global logins
	catch {unset logins($args)}
	set name [.alw.top.ent get]
	set passwd [.alw.mid.ent get]
	if {([string length $name] < 3) || ([string length $passwd] < 1)} {
		tk_dialog .error Error "Invalid name or password. Names must be 3 or more characters,\n and passwords must exist." error 0 "Ooops"
		return
	}
	set logins($name) $passwd
	destroy .alw
	Preferences::buffer
	set file [Preferences::writeopen]
        if {[string compare $file "NULL"] == 0} {
                return
        }
	regsub -all "login *:\[^\n\]*\n" $PBUF {} PBUF
	regsub -all "login *:\[^\n\]*\n" $PBUF {} PBUF
	regsub -all "login *:\[^\n\]*\n" $PBUF {} PBUF
	foreach of [array names logins] {
		append PBUF "\nlogin: $of $logins($of)\n"
	}
	Preferences::dump $file
	catch {UpdateDLW}
}
proc ALW {logi} {
	global logins
	destroy .alw
	toplevel .alw
	wm title .alw "Add/Alter Preset Login"
	frame .alw.top
	label .alw.top.lab -text "What is the name of the character?" -anchor w
	entry .alw.top.ent
	catch {.alw.top.ent insert insert $logi}
	bind .alw.top.ent <Return> {focus [tk_focusNext %W]}
	pack .alw.top -side top -fill x -expand true
	pack .alw.top.lab -side left -fill x -expand true
	pack .alw.top.ent -side left
	frame .alw.mid
	label .alw.mid.lab -text "What is that character's password?" -anchor w
	entry .alw.mid.ent -show *
	catch {.alw.mid.ent insert insert $logins($logi)}
	bind .alw.mid.ent <Return> "AL $logi"
	pack .alw.mid -side top -fill x -expand true
	pack .alw.mid.lab -side left -fill x -expand true
	pack .alw.mid.ent -side left
	frame .alw.bot
	button .alw.bot.add -text Add -command "AL $logi"
	button .alw.bot.can -text Cancel -command {destroy .alw}
	pack .alw.bot -side top -fill x -expand true
	pack .alw.bot.can -side right
	pack .alw.bot.add -side right
	bind .alw.bot.add <Return> "AL $logi"
	focus .alw.top.ent
	bind .alw.top.ent <Key-space> {break}
	bind .alw.mid.ent <Key-space> {break}
	bind .alw <Escape> {destroy .alw}
	center .alw
}
proc NotifyUser {} {
	global TIMES
	global DONOTIFY
	global NAME
	set DONOTIFY 0
	if {$TIMES == 0} {wm title . "New Message"; set TIMES 2}
	if {$TIMES == 1} {wm title . "TkTurf - $NAME"; set TIMES 0}
	if {$TIMES == 7} {wm title . "TkTurf - $NAME"; return}
	if {$TIMES == 2} {set TIMES 1}
	after 250 NotifyUser
}
proc SetDoNotify {event} {
	global DONOTIFY
	global NOTIFY
	global TIMES
	global VIS
	if {($NOTIFY == 0) || ($VIS == "VisibilityUnobscured")} {
		set DONOTIFY 0
		set TIMES 7
		return
	}
	if [regexp "VisibilityUnobscured" $event] {
		set TIMES 7
		set DONOTIFY 0
	} {set TIMES 0; set DONOTIFY 1}
}
proc ProcCat {pipe} {
	global tprime
	global MULTI
	if [eof $pipe] {
		catch {close $pipe}
		return
	}
	catch {puts $tprime "$MULTI[gets $pipe]"}
}
proc CommandHandle {line} {
	global USEALPHA
	catch {.promptline.mainent delete 0 end}
	if [regexp -nocase "^exec" $line] {
		regsub -nocase "^exec *" $line {} line
		catch {open "|$line" r} proc
		catch {fileevent $proc readable "ProcCat $proc"}
		return
	}
	if !$USEALPHA return
	eval $line
}
namespace eval Find {
set FIND ""
set IND 0.0
set UP 0
set STYLE 0
proc search {} {
	variable FIND
	variable IND
	variable UP
	variable STYLE
	destroy .find
	if {$IND == -0.1 && $UP == "-backward"} {set IND [.twid.text index "end -1 chars"]}
	if {[string length $FIND] == 0} {.twid.text see end; return}
	if [catch {.twid.text search $STYLE $UP -count chars -- $FIND "$IND +1 chars"} IND] {
		if {$UP == "-backward"} {
			set IND [.twid.text index end]
		} { set IND 0.0}
	}
	catch {.twid.text see $IND}
	catch {.twid.text tag remove sel 0.0 end}
	catch {.twid.text tag add sel $IND "$IND + $chars chars"}
	if {$UP == "-backward"} {
		set IND [expr $IND - 0.1]
	}
}
proc window {} {
	variable UP
	variable STYLE
	variable IND
	variable FIND
	set FIND {}
	set IND -0.1
	set UP -backward
	set STYLE -nocase
	destroy .find
	toplevel .find
	wm title .find "Find in Text Window"
	label .find.what -text "Enter a string to find" -anchor w
	entry .find.query -textvariable Find::FIND
	pack .find.what -side top -fill x -expand true
	pack .find.query -side top -fill x -expand true
	frame .find.style
	radiobutton .find.style.norm -text "No Case" -variable Find::STYLE -value -nocase
	radiobutton .find.style.case -text "Case Sensitive" -variable Find::STYLE -value -exact
	radiobutton .find.style.regexp -text "Regular Expression" -variable Find::STYLE -value -regexp
	pack .find.style.norm -side left -fill x
	pack .find.style.case -side left -fill x
	pack .find.style.regexp -side left -fill x
	pack .find.style -side top -fill x
	frame .find.dir
	radiobutton .find.dir.ftop -text "From Top" -variable Find::UP -value -forward
	radiobutton .find.dir.fbot -text "From Bottom" -variable Find::UP -value -backward
	pack .find.dir.ftop -side left -fill x
	pack .find.dir.fbot -side left -fill x
	pack .find.dir -side top -fill x
	frame .find.buts
	button .find.buts.find -text "Find" -command {Find::search}
	button .find.buts.can -text "Cancel" -command {destroy .find}
	pack .find.buts.can -side right
	pack .find.buts.find -side right
	pack .find.buts -side top -fill x -expand true
	bind .find.query <Return> Find::search
	focus .find.query
	bind .find <Escape> {destroy .find}
	wm resizable .find 0 0
	center .find
}
}
proc faq {var} {
	global VERSION
	global $var
	destroy .faq
	toplevel .faq
	wm title .faq "Documentation for TkTurf $VERSION"
	ScrolledTextWidget .faq.main -width 85 -wrap word
	.faq.main.text insert end [set $var]
	.faq.main.text config -state disabled
	pack .faq.main -fill both -expand true
	bind .faq <Escape> {destroy .faq}
	bind .faq <Up> {.faq.main.text yview scroll -1 units}
	bind .faq <Down> {.faq.main.text yview scroll 1 units}
	bind .faq <Next> {.faq.main.text yview scroll 1 pages}
	bind .faq <Prior> {.faq.main.text yview scroll -1 pages}
	center .faq
}
namespace eval Alias {
proc save {} {
	global tcl_platform
	if {$tcl_platform(platform) == "unix"} {
		if [catch {open ~/.tkturf/aliases w} file] {
			tk_dialog .error "Error" "Could not open ~/.tkturf/aliases for writing." error 0 Okay
			return
		}
	}
	if {$tcl_platform(platform) == "windows"} {
		if [catch {open /tkturf/aliases w} file] {
			tk_dialog .error "Error" "Could not open /tkturf/aliases for writing." error 0 Okay
			return
		}
	}
	if {$tcl_platform(platform) == "macintosh"} {
		if [catch {open ::tkturf:aliases w} file] {
			tk_dialog .error "Error" "Could not open ::tkturf:aliases for writing." error 0 Okay
			return
		}
	}
	foreach of $::Aliases::names {
		puts $file "proc ::Aliases::$of {args} {[info body ::Aliases::$of]}"
	}
	close $file
}
proc delete {del} {
	rename ::Aliases::$del {}
	makelist
	post
	save
}
proc post {} {
	.adw.list.list delete 0 end
	set alist [lsort -ascii $::Aliases::names]
	set length [llength $alist]
	foreach of $alist {
		.adw.list.list insert end $of
	}
}
proc window {} {
	destroy .adw
	toplevel .adw
	wm title .adw "Alias Control Panel"
	ScrolledListWidget .adw.list -selectmode single
	makelist
	post
	frame .adw.bot
	button .adw.bot.new -text New -underline 0 -command {::Alias::edit {}}
	button .adw.bot.add -text Edit -underline 0 -command {catch {::Alias::edit [.adw.list.list get [.adw.list.list curselection]]}}
	button .adw.bot.can -text Close -underline 0 -command {destroy .adw}
	button .adw.bot.fe -text "Delete" -command {catch {::Alias::delete [.adw.list.list get [.adw.list.list curselection]]}}
	pack .adw.list -side top -fill both
	pack .adw.bot.can -side right
	pack .adw.bot.fe -side right
	pack .adw.bot.add -side right
	pack .adw.bot.new -side right
	pack .adw.bot -side top -fill x -expand true
	focus .adw.list.list
	bind .adw.list.list <Double-Button> {catch {::Alias::edit [.adw.list.list get [.adw.list.list curselection]]}}
	bind .adw <n> {::Alias::edit {}}
	bind .adw <e> {catch {::Alias::edit [.adw.list.list get [.adw.list.list curselection]]}}
	bind .adw <c> {destroy .adw}
	bind .adw <Escape> {destroy .adw}
	center .adw
}
proc makelist {} {
	namespace eval ::Aliases {set names [info procs]}
}
proc add {win} {
	catch {rename ::Aliases::[$win.name.old cget -text] {}}
	set name [$win.name.name get]
	set body [$win.cmd.text get 0.0 end]
	if {![string length $name] || ![string length $body]} {
		tk_dialog .error "Error" "Please provide and name for your alias." error 0 Okay
		return
	}
	namespace eval ::Aliases "proc $name {args} {$body}"
	makelist
	post
	destroy $win
	save
}
proc edit {which} {
	set win [toplevel .[new]]
	frame $win.name
	label $win.name.label -text "Alias name" -anchor w
	label $win.name.old -text $which
	entry $win.name.name
	bind $win.name.name <space> {break}
	$win.name.name insert end $which
	pack $win.name.label -side left -fill x -expand true
	pack $win.name.name -side left
	bind $win.name.name <Return> {focus [tk_focusNext %W]}
	pack $win.name -side top -fill x
	label $win.lab -text "Alias body" -anchor w
	pack $win.lab -side top -fill x
	ScrolledTextWidget $win.cmd -width 80 -height 15
	pack $win.cmd -side top -fill both -expand true
	frame $win.but
	button $win.but.save -text Save -command "::Alias::add $win"
	button $win.but.al -text "Alias Help" -command "faq ALS"
	button $win.but.help -text "Scripting Help" -command "faq TCODE"
	button $win.but.can -text Cancel -command "destroy $win"
	pack $win.but.can -side right
	pack $win.but.help -side right
	pack $win.but.al -side right
	pack $win.but.save -side right
	pack $win.but -side top -fill x
	if ![string length $which] {
		$win.cmd.text insert end {# TkTurf now uses fully scripted aliases
# **DO NOT** put anything above these lines and
# do not delete this section unless you really
# know what you are doing
set i 1
foreach of $args {
	set $i $of
	incr i
}
for {} {$i <= 10} {incr i} {
	set $i {}
}
catch {unset of}
# end reserved section
# You may enter your script below this line
}
} {$win.cmd.text insert end [info body ::Aliases::$which]}
	center $win
	focus $win.name.name
	bind $win <Escape> "destroy $win"
}
}
proc AboutTkTurf {} {
	global VERSION
	destroy .abouttkturf
	toplevel .abouttkturf
	wm title .abouttkturf "About TkTurf"
	label .abouttkturf.label -text "TkTurf v$VERSION" -takefocus 0
	label .abouttkturf.fjack -text "Written by Fastjack <fastjack@fastjack.turf.org>" -takefocus 0
	label .abouttkturf.ninja -text "Beta Testing by Bluevelvet & Zartid" -takefocus 0
	label .abouttkturf.code -text "Code support by: Ninja & Ali" -takefocus 0
	label .abouttkturf.thanks -text "Special thanks to: Mtf, Ninja, Mango, Tyrade, Ali\n and also anyone else who assisted in beta testing" -takefocus 0
	label .abouttkturf.lic -text "This program is released under the GNU General\nPublic License v2, or at your option any\nlater version.  All terms and conditions apply."
	pack .abouttkturf.label -side top -fill x -padx 10 -pady 10
	pack .abouttkturf.fjack -side top -fill x
	pack .abouttkturf.ninja -side top -fill x
	pack .abouttkturf.code -side top -fill x
	pack .abouttkturf.thanks -side top -fill x
	pack .abouttkturf.lic -side top -fill x
	frame .abouttkturf.done
	button .abouttkturf.done.cancel -text "Okay, enough of this..." -command {destroy .abouttkturf}
	pack .abouttkturf.done.cancel 
	pack .abouttkturf.done -side top -fill x -expand true -padx 5 -pady 5
	focus .abouttkturf.done.cancel
	bind .abouttkturf <Escape> {destroy .abouttkturf}
	center .abouttkturf
}
proc Copy {} {
	clipboard clear
	catch {clipboard append [selection get]}
}
proc Paste {win} {
	if [catch {$win insert insert [selection get -selection PRIMARY]}] {
		catch {$win insert insert [selection get -selection CLIPBOARD]}
	}
}
proc ConnectErrorWin {} {
	.promptline.prompt config -text "Error connecting"
	set choice [tk_dialog .cew "Connection Problem" "There was an error connecting.\nWhat would you like to do?" error 0 Retry Abort "Configure a Proxy"]
	if {$choice == 0} {
		update idletasks
		GetSock
		return
	}
	if {$choice == 1} {
		exit
	}
	if {$choice == 2} {
		Preferences::window
		tkwait window .prefs
		update idletasks
		GetSock
	}
}
proc colset {color} {
	set new [tk_chooseColor -initialcolor $color]
	if {[string length $new] > 0} {
		return $new
	} {
		return $color
	}
}
proc GCCW {} {
	global REVOPP
	global CFOUT
	global CFBLANK
	global CFBG
	global CFYELLOW
	global CFRED
	global CHECK1
	global CHECK2
	global CHESSHL
	global CWHITE
	global CBLACK
	global RBACK
	global RLINES
	global RRED
	global RBLUE
	global SHIPCOL
	global BSWCOL
	global BSHIT
	global BSMIS
	global BSLCOL
	global BSOUTL
	destroy .ccw
	toplevel .ccw
	wm title .ccw "Amusements Colors"
	frame .ccw.c
	canvas .ccw.c.canvas -width 10 -height 10 -yscrollcommand [list .ccw.c.yscroll set]
	scrollbar .ccw.c.yscroll -orient vertical -command [list .ccw.c.canvas yview]
	pack .ccw.c.yscroll -side right -fill y
	pack .ccw.c.canvas -side left -fill both -expand true
	pack .ccw.c -side top -fill both -expand true
	frame .ccw.c.canvas.f -bd 0
	.ccw.c.canvas create window 0 0 -anchor nw -window .ccw.c.canvas.f
	button .ccw.c.canvas.f.cfyellow -text "Connect 4 Yellow" -command {set CFYELLOW [colset $CFYELLOW];.ccw.c.canvas.f.cfyellow config -background $CFYELLOW} -background $CFYELLOW
	button .ccw.c.canvas.f.cfred -text "Connect 4 Red" -command {set CFRED [colset $CFRED];.ccw.c.canvas.f.cfred config -background $CFRED} -background $CFRED
	button .ccw.c.canvas.f.cfbg -text "Connect 4 Background" -command {set CFBG [colset $CFBG]; .ccw.c.canvas.f.cfbg config -background $CFBG} -background $CFBG
	button .ccw.c.canvas.f.cfblank -text "Connect 4 Blank" -command {set CFBLANK [colset $CFBLANK];.ccw.c.canvas.f.cfblank config -background $CFBLANK} -background $CFBLANK
	button .ccw.c.canvas.f.cfout -text "Connect 4 Highlight" -command {set CFOUT [colset $CFOUT];.ccw.c.canvas.f.cfout config -background $CFOUT} -background $CFOUT
	button .ccw.c.canvas.f.cblack -text "Chess South Pieces" -command {set CBLACK [colset $CBLACK]; .ccw.c.canvas.f.cblack config -background $CBLACK} -background $CBLACK
	button .ccw.c.canvas.f.cwhite -text "Chess North Pieces" -command {set CWHITE [colset $CWHITE]; .ccw.c.canvas.f.cwhite config -background $CWHITE} -background $CWHITE
	button .ccw.c.canvas.f.check1 -text "Check1 Color" -command {set CHECK1 [colset $CHECK1]; .ccw.c.canvas.f.check1 config -background $CHECK1} -background $CHECK1
	button .ccw.c.canvas.f.check2 -text "Check2 Color" -command {set CHECK2 [colset $CHECK2]; .ccw.c.canvas.f.check2 config -background $CHECK2} -background $CHECK2
	button .ccw.c.canvas.f.chl -text "Selected Piece Color" -command {set CHESSHL [colset $CHESSHL]; .ccw.c.canvas.f.chl config -background $CHESSHL} -background $CHESSHL	
	button .ccw.c.canvas.f.rred -text "Reversi Red" -command {set RRED [colset $RRED]; .ccw.c.canvas.f.rred config -background $RRED} -background $RRED
	button .ccw.c.canvas.f.rblue -text "Reversi Blue" -command {set RBLUE [colset $RBLUE]; .ccw.c.canvas.f.rblue config -background $RBLUE} -background $RBLUE
	button .ccw.c.canvas.f.rback -text "Reversi Background" -command {set RBACK [colset $RBACK]; .ccw.c.canvas.f.rback config -background $RBACK} -background $RBACK
	button .ccw.c.canvas.f.rlines -text "Reversi Lines" -command {set RLINES [colset $RLINES]; .ccw.c.canvas.f.rlines config -background $RLINES} -background $RLINES
	button .ccw.c.canvas.f.bsmis -text "Battleship Miss" -command {set BSMIS [colset $BSMIS]; .ccw.c.canvas.f.bsmis config -background $BSMIS} -background $BSMIS
	button .ccw.c.canvas.f.bshit -text "Battleship Hit" -command {set BSHIT [colset $BSHIT]; .ccw.c.canvas.f.bshit config -background $BSHIT} -background $BSHIT
	button .ccw.c.canvas.f.shipcol -text "Battleship Ships" -command {set SHIPCOL [colset $SHIPCOL]; .ccw.c.canvas.f.shipcol config -background $SHIPCOL} -background $SHIPCOL
	button .ccw.c.canvas.f.bswcol -text "Battleship Water" -command {set BSWCOL [colset $BSWCOL]; .ccw.c.canvas.f.bswcol config -background $BSWCOL} -background $BSWCOL
	button .ccw.c.canvas.f.bslcol -text "Battleship Grid" -command {set BSLCOL [colset $BSLCOL]; .ccw.c.canvas.f.bslcol config -background $BSLCOL} -background $BSLCOL
	button .ccw.c.canvas.f.bsoutl -text "Ship Outlines" -command {set BSOUTL [colset $BSOUTL]; .ccw.c.canvas.f.bsoutl config -background $BSOUTL} -background $BSOUTL
	button .ccw.c.canvas.f.restore -text "Restore Preference Colors" -command {Preferences::load colors; TTC .twid.text; TTC .filter.text; .twid.text config -background $BG; .filter.text config -background $BG; .filter.text config -foreground $BLACK; .twid.text config -foreground $BLACK;.ccw.c.canvas.f.cfyellow config -background $CFYELLOW; .ccw.c.canvas.f.cfred config -background $CFRED; .ccw.c.canvas.f.cfbg config -background $CFBG; .ccw.c.canvas.f.cfblank config -background $CFBLANK; .ccw.c.canvas.f.cfout config -background $CFOUT; .ccw.c.canvas.f.cblack config -background $CBLACK; .ccw.c.canvas.f.chl config -background $CHESSHL; .ccw.c.canvas.f.check2 config -background $CHECK2; .ccw.c.canvas.f.check1 config -background $CHECK1; .ccw.c.canvas.f.cwhite config -background $CWHITE; .ccw.c.canvas.f.rred config -background $RRED; .ccw.c.canvas.f.rblue config -background $RBLUE; .ccw.c.canvas.f.rback config -background $RBACK; .ccw.c.canvas.f.rlines config -background $RLINES; .ccw.c.canvas.f.bsmis config -background $BSMIS; .ccw.c.canvas.f.bshit config -background $BSHIT; .ccw.c.canvas.f.shipcol config -background $SHIPCOL; .ccw.c.canvas.f.bswcol config -background $BSWCOL; .ccw.c.canvas.f.bslcol config -background $BSLCOL;.ccw.c.canvas.f.bsoutl config -background $BSOUTL}
	button .ccw.c.canvas.f.def -text "Restore Default Colors" -command {Preferences::setcoldefaults; TTC .twid.text; TTC .filter.text; .ccw.c.canvas.f.cblack config -background $CBLACK; .ccw.c.canvas.f.chl config -background $CHESSHL; .ccw.c.canvas.f.check2 config -background $CHECK2; .ccw.c.canvas.f.check1 config -background $CHECK1; .ccw.c.canvas.f.cwhite config -background $CWHITE; .filter.text config -background $BG; .filter.text config -foreground $BLACK;.twid.text config -background #d9d9d9; .twid.text config -foreground #000000; .ccw.c.canvas.f.cfyellow config -background $CFYELLOW; .ccw.c.canvas.f.cfred config -background $CFRED; .ccw.c.canvas.f.cfbg config -background $CFBG; .ccw.c.canvas.f.cfblank config -background $CFBLANK; .ccw.c.canvas.f.cfout config -background $CFOUT; .ccw.c.canvas.f.rred config -background $RRED; .ccw.c.canvas.f.rblue config -background $RBLUE; .ccw.c.canvas.f.rback config -background $RBACK; .ccw.c.canvas.f.rlines config -background $RLINES; .ccw.c.canvas.f.bsmis config -background $BSMIS; .ccw.c.canvas.f.bshit config -background $BSHIT; .ccw.c.canvas.f.shipcol config -background $SHIPCOL; .ccw.c.canvas.f.bswcol config -background $BSWCOL; .ccw.c.canvas.f.bslcol config -background $BSLCOL;.ccw.c.canvas.f.bsoutl config -background $BSOUTL}
	grid .ccw.c.canvas.f.cfyellow
	grid .ccw.c.canvas.f.cfyellow -sticky we
	grid .ccw.c.canvas.f.cfred -sticky we
	grid .ccw.c.canvas.f.cfbg -sticky we
	grid .ccw.c.canvas.f.cfblank -sticky we
	grid .ccw.c.canvas.f.cfout -sticky we
	grid .ccw.c.canvas.f.cwhite -sticky we
	grid .ccw.c.canvas.f.cblack -sticky we
	grid .ccw.c.canvas.f.chl -sticky we
	grid .ccw.c.canvas.f.check1 -sticky we
	grid .ccw.c.canvas.f.check2 -sticky we
	grid .ccw.c.canvas.f.rred -sticky we
	grid .ccw.c.canvas.f.rblue -sticky we
	grid .ccw.c.canvas.f.rback -sticky we
	grid .ccw.c.canvas.f.rlines -sticky we
	grid .ccw.c.canvas.f.bsmis -sticky we
	grid .ccw.c.canvas.f.bshit -sticky we
	grid .ccw.c.canvas.f.shipcol -sticky we
	grid .ccw.c.canvas.f.bswcol -sticky we
	grid .ccw.c.canvas.f.bslcol -sticky we
	grid .ccw.c.canvas.f.bsoutl -sticky we
	grid .ccw.c.canvas.f.restore -sticky we
	grid .ccw.c.canvas.f.def -sticky we
	bind .ccw <Escape> {destroy .ccw}
	if {$REVOPP != -1} {
		.ccw.c.canvas.f.rred config -state disabled
		.ccw.c.canvas.f.rblue config -state disabled
		.ccw.c.canvas.f.rback config -state disabled
		.ccw.c.canvas.f.rlines config -state disabled
	}
	tkwait visibility .ccw.c.canvas.f.cfyellow
	set bbox [grid bbox .ccw.c.canvas.f 0 0]
	set incr [lindex $bbox 3]
	set width [winfo reqwidth .ccw.c.canvas.f]
	set height [winfo reqheight .ccw.c.canvas.f]
	.ccw.c.canvas config -scrollregion "0 0 $width $height"
	.ccw.c.canvas config -yscrollincrement $incr
	set height [expr 7 * $incr]
	.ccw.c.canvas config -width $width -height $height
	wm protocol .ccw WM_DELETE_WINDOW {::Preferences::savecolors; destroy .ccw}
}
proc CCW {} {
	global BLACK
	global YELLOW
	global GREEN
	global RED
	global BLUE
	global CYAN
	global BG
	global MAGENTA
	global WHITE
	global SELECT
	global tcl_platform
	destroy .ccw
	toplevel .ccw
	wm title .ccw "Color Configurator"
	button .ccw.black -text Black -command {set BLACK [colset $BLACK]; .twid.text config -foreground $BLACK; .ccw.black config -background $BLACK;.filter.text config -foreground $BLACK;} -background $BLACK
	button .ccw.red -text Red -command {set RED [colset $RED]; TTC .twid.text; TTC .filter.text; .ccw.red config -background $RED} -background $RED
	button .ccw.green -text Green -command {set GREEN [colset $GREEN]; TTC .twid.text; TTC .filter.text; .ccw.green config -background $GREEN} -background $GREEN
	button .ccw.yellow -text Yellow -command {set YELLOW [colset $YELLOW]; TTC .twid.text; TTC .filter.text; .ccw.yellow config -background $YELLOW} -background $YELLOW
	button .ccw.blue -text Blue -command {set BLUE [colset $BLUE]; TTC .twid.text; TTC .filter.text; .ccw.blue config -background $BLUE} -background $BLUE
	button .ccw.magenta -text Magenta -command {set MAGENTA [colset $MAGENTA];TTC .twid.text; TTC .filter.text;.ccw.magenta config -background $MAGENTA} -background $MAGENTA
	button .ccw.cyan -text Cyan -command {set CYAN [colset $CYAN];TTC .twid.text; TTC .filter.text; .ccw.cyan config -background $CYAN} -background $CYAN
	button .ccw.white -text White -command {set WHITE [colset $WHITE];TTC .twid.text; TTC .filter.text;.ccw.white config -background $WHITE} -background $WHITE
	button .ccw.sel -text "Text Selection" -command {set SELECT [colset $SELECT]; TTC .twid.text; TTC .filter.text; .ccw.sel config -background $SELECT} -background $SELECT
	button .ccw.bg -text "Turf Window Background" -command {set BG [colset $BG]; catch {.twid.text config -background $BG}; .ccw.bg config -background $BG; .filter.text config -background $BG} -background $BG
	button .ccw.restore -text "Restore Preference Colors" -command {catch {Preferences::load colors; TTC .twid.text; TTC .filter.text;.filter.text config -background $BG; .filter.text config -foreground $BLACK; .twid.text config -background $BG; .twid.text config -foreground $BLACK; .ccw.black config -background $BLACK; .ccw.red config -background $RED; .ccw.green config -background $GREEN; .ccw.yellow config -background $YELLOW; .ccw.blue config -background $BLUE; .ccw.magenta config -background $MAGENTA; .ccw.cyan config -background $CYAN; .ccw.white config -background $WHITE;.ccw.bg config -background $BG;.filter.text config -background $BG; .filter.text config -foreground $BLACK;.filter.text config -background $BG; .filter.text config -foreground $BLACK; .ccw.sel config -background $SELECT}}
	button .ccw.def -text "Restore Default Colors" -command {catch {Preferences::setcoldefaults; TTC .twid.text; TTC .filter.text;.filter.text config -background $BG; .filter.text config -foreground $BLACK; .twid.text config -background #d9d9d9; .twid.text config -foreground #000000; .ccw.black config -background $BLACK; .ccw.red config -background $RED; .ccw.green config -background $GREEN; .ccw.yellow config -background $YELLOW; .ccw.blue config -background $BLUE; .ccw.magenta config -background $MAGENTA; .ccw.cyan config -background $CYAN; .ccw.white config -background $WHITE;.ccw.bg config -background $BG;.ccw.sel config -background $SELECT}}
	pack .ccw.black -side top -fill x
	pack .ccw.red -side top -fill x
	pack .ccw.green -side top -fill x
	pack .ccw.yellow -side top -fill x
	pack .ccw.blue -side top -fill x
	pack .ccw.magenta -side top -fill x
	pack .ccw.cyan -side top -fill x
	pack .ccw.white -side top -fill x
	if {$tcl_platform(platform) == "windows"} {
		pack .ccw.sel -side top -fill x
	}
	pack .ccw.bg -side top -fill x
	pack .ccw.restore -side top -fill x
	pack .ccw.def -side top -fill x
	bind .ccw <Escape> {destroy .ccw}
	wm protocol .ccw WM_DELETE_WINDOW {::Preferences::savecolors; destroy .ccw}
}
proc fread {} {
	global finger
	global fbuffer
	if [eof $finger] {
		catch {close $finger}
		if [string length $fbuffer] {
			catch {wintalk .twid.text "\n$fbuffer\n" {}}
		}
		catch {unset fbuffer}
		return
	}
	if [catch {append fbuffer [read $finger]}] {
		tk_dialog .error "Error" "Error: finger connection refused" error 0 Okay
		catch {close $finger}
		catch {unset fbuffer}
	}
}
proc finfo {} {
	set who [.finger.who get]
	finger $who
}
proc finger {who} {
	global tprime
	global finger
	global fbuffer
	if {[regexp "@" $who] == 0} {
		catch {puts $tprime "finger $who"}
		destroy .finger
		return
	}
	regsub "@\[^@\]*$" $who {} name
	regsub ".*@" $who {} site
	if ![string length $site] {
		tk_dialog .error "Error" "Error: no host given to finger" error 0 Cancel
		return
	}
	set finger [socket -async $site 79]
	fconfigure $finger -buffersize 1 -buffering none -blocking 0
	fileevent $finger readable {fread}
	catch {puts $finger $name}
	destroy .finger
}
proc FW {} {
	destroy .finger
	toplevel .finger
	wm title .finger Finger
	label .finger.label -text "Finger who?" -takefocus 0
	entry .finger.who
	bind .finger.who <Return> {finfo}
	pack .finger.label -side top -fill x
	pack .finger.who -side top -fill x
	focus .finger.who
	bind .finger <Escape> {destroy .finger}
	center .finger
}
proc descpost {wid} {
	global tprime
	if [catch { puts $tprime \n }] { tk_dialog .nomail Error "You can not change your description without being connected." error 0 "Oh yeah...";  return}
	puts -nonewline $tprime "description "
	set lineout [$wid.desc.text get 0.0 end]
	regsub -all "\n" $lineout { } lineout
	regsub -all "  *" $lineout { } lineout
	puts $tprime $lineout
	destroy $wid
}
proc DEW {} {
	global winc
	incr winc
	toplevel .$winc
	wm title .$winc "Description Editor"
	ScrolledTextWidget .$winc.desc -width 60 -height 9 -wrap word
	pack .$winc.desc -side top -fill both -expand true
	frame .$winc.but
	button .$winc.but.ch -text Change -command "descpost .$winc"
	button .$winc.but.cancel -text Cancel -command "destroy .$winc"
	pack .$winc.but -side top -fill x
	pack .$winc.but.cancel -side right
	pack .$winc.but.ch -side right
	bind .$winc.desc.text <Return> {break}
	focus .$winc.desc.text
	bind .$winc <Escape> "destroy .$winc"
	center .$winc
}
proc redsend {wid} {
	global tprime
	if [catch { puts $tprime \n }] { tk_dialog .nomail Error "You can not change your room without being connected." error 0 "Oh yeah...";  return}
	puts $tprime "roomedit"
	puts $tprime ".wipe"
	puts $tprime [$wid.red.text get 0.0 end]
	puts $tprime ".end"
	destroy $wid
}
proc REW {} {
	global winc
	incr winc
	toplevel .$winc
	wm title .$winc "Room Editor"
	ScrolledTextWidget .$winc.red -width 60 -height 9 -wrap word
	pack .$winc.red -side top -fill both -expand true
	frame .$winc.but
	button .$winc.but.ch -text Change -command "redsend .$winc"
	button .$winc.but.cancel -text Cancel -command "destroy .$winc"
	pack .$winc.but -side top -fill x
	pack .$winc.but.cancel -side right
	pack .$winc.but.ch -side right
	focus .$winc.red.text
	bind .$winc <Escape> "destroy .$winc"
	center .$winc
}
proc Pcheck {wid} {
	global PASSWD
	if {[string compare $PASSWD [$wid.epw get]] == 0} {
		bind $wid <Destroy> {break}
		grab release $wid
		destroy $wid
		catch {.twid.text see end}
	} {
		$wid.epw delete 0 end
		$wid config -cursor pirate
		after 1000 "$wid config -cursor dot"
		return
	}
}
proc PP {} {
	destroy .pprompt
	toplevel .pprompt
	wm title .pprompt "Password Prompt"
	label .pprompt.query -text "Lock under what password?"
	entry .pprompt.pass -show *
	pack .pprompt.query -side top -fill x
	pack .pprompt.pass -side top -fill x
	bind .pprompt.pass <Return> {set PASSWD [.pprompt.pass get]; destroy .pprompt}
	bind .pprompt <Escape> {destroy .pprompt}
	center .pprompt
	grab .pprompt.pass
	focus -force .pprompt.pass
	tkwait window .pprompt
}
proc LT {bit} {
	global winc
	global PASSWD
	update idletasks
	if {[string length $PASSWD] < 1} {
		PP
	}
	if {[string length $PASSWD] < 1} {return}
	if {$bit == 1} {
		catch {.twid.text see 0.0}
	}
	incr winc
	toplevel .$winc
	wm title .$winc "Password"
	label .$winc.pw -text Password
	entry .$winc.epw -show *
	pack .$winc.pw -side left
	pack .$winc.epw -side left -fill x
	bind .$winc <Return> "Pcheck .$winc"
	bind .$winc <Destroy> {break}
	bind .$winc <Control-Key-s> {break}
	bind .$winc <Control-Key-q> {break}
	bind .$winc <Meta-Key-q> {break}
	bind .$winc <Control-Key-z> {break}
	wm protocol .$winc WM_DELETE_WINDOW {break}
	center .$winc
	focus .$winc.epw
	if {[catch {grab -global .$winc}]} {
		catch {grab .$winc}
	}
	.$winc config -cursor dot
	tkwait window .$winc
}
proc LDump {} {
	global FILTER
	if {$FILTER == 0} {set win 0} {
		set win [tk_dialog .error "Which Window" "Which window would you like to dump to a log file?" question 0 Main "Filter Window" Cancel]
	}
	if {$win == 2} {return}
	if {$win == 0} {set win .twid.text} {set win .filter.text}
	set fname [getSaveFile]
	if {[string length $fname] == 0} {return}
	set file [open $fname w]
	puts $file [$win get 0.0 end]
	close $file
}
namespace eval Preferences {
set hooks {}
proc replace {var} {
	global $var
	global PBUF
	if ![info exists $var] {return}
	regsub -all "\n$var:\[^\n\]*\n" $PBUF \n PBUF
	append PBUF "\n$var:[set $var]\n"
}
proc save {} {
	global PREFS
	global PBUF
	global SOUNDSTUB
	Preferences::buffer
	set file [Preferences::writeopen]
	if {[string compare $file "NULL"] == 0} {
		return
	}
	Preferences::replace PROXY
	Preferences::replace PROXPORT
	Preferences::replace CP
	Preferences::replace PASSWD
	Preferences::replace LOG
	Preferences::replace FONT
	Preferences::replace SWIDTH
	Preferences::replace STIPPLE
	Preferences::replace RING
	Preferences::replace NOTIFY
	Preferences::replace LOGIN
	Preferences::replace MENU
	Preferences::replace ALL
	Preferences::replace USEALPHA
	Preferences::replace FILTER
	Preferences::replace FSIZE
	Preferences::replace SSHOST
	Preferences::replace SSHPORT
	Preferences::replace CKV
	Preferences::replace HTTPPROXY
	Preferences::replace HTTPPORT
	Preferences::replace TABLIMIT
	Preferences::replace AUDIO
	Preferences::replace SOCKS
	Preferences::replace IPWARN
	Preferences::replace FILTERSIZE
	Preferences::replace CKQUIT
	Preferences::replace FFACE
	Preferences::replace CHESSLOG
	Preferences::replace CASETAB
	regsub -all "\nSOUNDSTUB\[^\n\]*\n" $PBUF \n PBUF
	regsub -all "\nSOUNDSTUB\[^\n\]*\n" $PBUF \n PBUF
	regsub -all "\nSOUNDSTUB\[^\n\]*\n" $PBUF \n PBUF
	regsub -all "\nSOUNDSTUB\[^\n\]*\n" $PBUF \n PBUF
	foreach of [array names SOUNDSTUB] {
		append PBUF "\nSOUNDSTUB($of):$SOUNDSTUB($of)\n"
	}
	foreach of [array names PREFS] {
		catch {regsub -all "\n$of:\[^\n\]*\n" $PBUF \n PBUF
		append PBUF "\n$of:[set PREFS($of)]\n"}
	}
	Preferences::dump $file
	catch {unset PBUF}
}
proc apply {} {
	global FONT
	global FFACE
	global FSIZE
	global MENU
	global SWIDTH
	global tcl_platform
	global FILTER
	global FILTERSIZE
	global CHESSLOG
	set FSIZE [expr round($FSIZE)]
	set FONT "\"$FFACE\" $FSIZE"
	ApplySetting . font $FONT
	option add *font $FONT
	set prompt [.promptline.prompt cget -text]
	.twid.text tag config bold -font "$FONT bold"
	.twid.yscroll config -width $SWIDTH
	.filter.yscroll config -width $SWIDTH
	catch {.menubar config}
	pack forget .promptline
	pack forget .promptline.mainent
	pack forget .promptline.prompt
	pack forget .promptline.tray
	pack .promptline.tray -side right
	pack .promptline.mainent -side right -fill x -expand true
	pack .promptline.prompt -side right
	pack forget .twid
	pack forget .filter
	pack .promptline -side bottom -fill x
	bind .promptline.mainent <Return> {STDre .promptline.mainent}
	if {$FILTER == 1} {
		pack .filter -side bottom -fill both -expand true
	}
	.filter.text config -height $FILTERSIZE
	pack .twid -side bottom -fill both -expand true
	.twid.text see end
	focus -force .promptline.mainent
	bind . <Up> {EntScroll 1}
	bind . <Down> {EntScroll 0}
	bind all <Control-Key-p> {EntScroll 1}
	bind all <Control-Key-n> {EntScroll 0}
	bind all <Control-Key-u> {.promptline.mainent delete 0 end}
	bind all <Control-Key-q> {quit}
	bind all <Control-Key-l> {LT 1}
	bind .promptline.mainent <Shift-Return> {.promptline.mainent insert insert "\n\r"; break}
	bind .promptline.mainent <Tab> {catch {TabGrep}; break}
	bind . <FocusIn> {SetDoNotify VisibilityUnobscured}
	bind . <FocusOut> {SetDoNotify Setiton!}
	bind . <Next> {.twid.text yview scroll 1 pages}
	bind . <Prior> {.twid.text yview scroll -1 pages}
	bind . <Shift-Next> {.filter.text yview scroll 1 pages; break}
	bind . <Shift-Prior> {.filter.text yview scroll -1 pages; break}
	TTC .twid.text
	TTC .filter.text
	if {$MENU == 1} {. config -menu .menubar} {. config -menu {}}
	if {($CHESSLOG == 1) && ([winfo exists .chess])} {
		pack forget .chess.mess
		pack .chess.log -side top -fill x -expand true
		pack .chess.mess -side top -fill x -expand true
	}
	if {($CHESSLOG == 0) && ([winfo exists .chess])} {
		pack forget .chess.log
	}
}
proc setcoldefaults {} {
	set ::SELECT #bbbbbb
	set ::BSOUTL red
	set ::BSLCOL black
	set ::SHIPCOL #a9a9a9
	set ::BSWCOL lightblue
	set ::BSHIT red
	set ::BSMIS white
	set ::RBACK grey
	set ::RLINES black
	set ::RRED red
	set ::RBLUE blue
	set ::CWHITE white
	set ::CBLACK black
	set ::CHECK1 #5b7ed0
	set ::CHECK2 #4f49b4
	set ::CFOUT green
	set ::BLACK black
        set ::GREEN green
        set ::RED red
        set ::YELLOW yellow
        set ::BLUE blue
        set ::CYAN cyan
        set ::MAGENTA magenta
        set ::WHITE white
        set ::CFYELLOW yellow
        set ::CFRED red
        set ::CFBG blue
        set ::CFBLANK black
	set ::BG #d9d9d9
	set ::CHESSHL red
}
proc setdefaults {} {
	set ::ALL 1
	set ::QUIT 0
	set ::CASETAB 0
	set ::CHESSLOG 1
	set ::CKQUIT 0
	set ::SAVESESSIONSTATE 1
	set ::LOGOUTONSAVE 1
	set ::FILTERSIZE 6
	set ::soundnames(CHAL) {Game Challenge}
	set ::soundnames(START) {Start Sound}
	set ::soundnames(CFMOVE) {Connect 4 Move}
	set ::soundnames(CHMOVE) {Chess Move}
	set ::soundnames(RVMOVE) {Reversi Move}
	set ::soundnames(BSMISS) {Battleship Miss}
	set ::soundnames(BSHIT) {Battleship Hit}
	set ::soundnames(BSSINK) {Battleship Sink}
	set ::soundnames(CONNECT) {Connection}
	set ::soundnames(DISCONNECT) {Disconnection}
	set ::soundnames(CNECTERR) {Connection Error}
	set ::soundnames(BELL) {Beep Noise}
	set ::soundnames(NEWTEXT) {Message Notification}
	set ::SOUNDSTUB(CHAL) {}
	set ::SOUNDSTUB(NEWTEXT) {}
	set ::SOUNDSTUB(BELL) {}
	set ::SOUNDSTUB(CNECTERR) {}
	set ::SOUNDSTUB(START) {}
	set ::SOUNDSTUB(CFMOVE) {}
	set ::SOUNDSTUB(CHMOVE) {}
	set ::SOUNDSTUB(RVMOVE) {}
	set ::SOUNDSTUB(BSMISS) {}
	set ::SOUNDSTUB(BSHIT) {}
	set ::SOUNDSTUB(BSSINK) {}
	set ::SOUNDSTUB(CONNECT) {}
	set ::SOUNDSTUB(DISCONNECT) {}
	set ::IPWARN 1
	set ::SOCKS 0
	set ::AUDIO ""
	set ::TABLIMIT 100
	set ::HTTPPROXY ""
	set ::HTTPPORT 0
	set ::CKV 1
	set ::NOTIFY 1
	set ::STIPPLE 1
	set ::RING 1
	set ::LOG 0
	set ::SWIDTH 15
	set ::LOGIN 1
	set ::MENU 1
	set ::FFACE fixed
	set ::FSIZE 12
	if {$::tcl_platform(platform) == "windows"} { set ::FFACE fixedsys } 
	if {$::tcl_platform(platform) == "macintosh"} { set ::FFACE Courier }
	set ::FONT "$::FFACE $::FSIZE"
}
proc savecolors {} {
	Preferences::buffer
	set file [Preferences::writeopen]
	if {[string compare $file "NULL"] == 0} {
		return
	}
	Preferences::replace CHESSHL
	Preferences::replace CWHITE
	Preferences::replace CBLACK
	Preferences::replace CHECK1
	Preferences::replace CHECK2
	Preferences::replace BLACK
	Preferences::replace YELLOW
	Preferences::replace GREEN
	Preferences::replace RED
	Preferences::replace BLUE
	Preferences::replace CYAN
	Preferences::replace MAGENTA
	Preferences::replace WHITE
	Preferences::replace CFYELLOW
	Preferences::replace CFRED
	Preferences::replace CFBG
	Preferences::replace CFBLANK
	Preferences::replace BG
	Preferences::replace CFOUT
	Preferences::replace RLINES
	Preferences::replace RBLUE
	Preferences::replace RRED
	Preferences::replace RBACK
	Preferences::replace BSWCOL
	Preferences::replace BSHIT
	Preferences::replace BSMIS
	Preferences::replace SHIPCOL
	Preferences::replace BSLCOL
	Preferences::replace SELECT
	Preferences::replace SAVESESSIONSTATE
	Preferences::replace LOGOUTONSAVE
	Preferences::dump $file
}
proc openfile {} {
	global tcl_platform
	global env
	global BASEDIR
	if {$tcl_platform(platform) == "unix"} {
		if ![catch {open ~/.tkturf/tkturfrc r} file] {
			return $file
		} {
			if ![catch {open [file join $BASEDIR tkturfrc] r} file] {
				return $file
			}
		}
	}  {
		if [file exists [file join $BASEDIR tkturfrc]] {
			if ![catch {open [file join $BASEDIR tkturfrc] r} file] {
				return $file
			}
		}
		if ![catch {open /tkturf/tkturfrc r} file] {
			return $file
		}
		if ![catch {open ::tkturf:tkturfrc r} file] {
			return $file
		}
	}
	return "NULL"
}
proc writeopen {} {
	global tcl_platform
	global env
	global BASEDIR
	if {[string compare $tcl_platform(platform) "unix"] == 0} {
		if ![catch {open ~/.tkturf/tkturfrc w} file] {
			return $file
		} {
			if ![catch {open [file join $BASEDIR tkturfrc] w} file] {
				return $file
			}
		}
	}  {
		if [file exists [file join $BASEDIR tkturfrc]] {
			if ![catch {open [file join $BASEDIR tkturfrc] w} file] {
				return $file
			}
		}
		if ![catch {open /tkturf/tkturfrc w} file] {
			return $file
		}
		if ![catch {open ::tkturf:tkturfrc w} file] {
			return $file
		}
	}
	return "NULL"
}
proc dump {file} {
	global PBUF
	regsub -all "\n\n" $PBUF \n PBUF
	regsub -all "\n\n" $PBUF \n PBUF
	regsub -all "\n\n" $PBUF \n PBUF
	regsub -all "\n\n" $PBUF \n PBUF
	puts $file $PBUF
	close $file
}
proc buffer {} {
	global PBUF
	catch {unset PBUF}
	set file [Preferences::openfile]
	if {[string compare $file "NULL"] == 0} {set PBUF ""; return}
	for {append PBUF [read $file]} {[eof $file] == 0} {} {append PBUF [read $file]}
}
proc window {} {
	global SWIDTH
	global LOG
	global LOGIN
	global MENU
	global PASSWD
	global SWIDTH
	global PROXY
	global PROXPORT
	global CP
	global SOUNDSTUB
	global soundnames
	global FONT
	destroy .prefs
	toplevel .prefs -height 60 -width 60
	wm title .prefs Preferences
	ButtonNotebook::create .prefs.main Appearance Behaviour Net Sound Misc
	pack .prefs.main -side top
	set frame [ButtonNotebook::getnextpage .prefs.main]
	frame $frame.two
	label $frame.two.f -text "Font size" -anchor w
	entry $frame.two.font -textvariable FSIZE -width 2
	pack $frame.two.f -side left -fill x -expand true
	pack $frame.two.font -side left
	pack $frame.two -side top -fill x -expand true
	frame $frame.fface
	label $frame.fface.l -text "Font face" -anchor w
	eval {tk_optionMenu $frame.fface.face FFACE} [lsort [font families]]
	pack $frame.fface.l -side left -fill x -expand true
	pack $frame.fface.face -side left
	pack $frame.fface -side top -fill x -expand true
	frame $frame.fsize
	label $frame.fsize.label -text "Filter window size" -anchor w
	entry $frame.fsize.entry -textvariable FILTERSIZE -width 2
	pack $frame.fsize.label -side left -fill x -expand true
	pack $frame.fsize.entry -side left
	pack $frame.fsize -side top -fill x -expand true
	frame $frame.four
	label $frame.four.s -text "Scroll bar width" -anchor w
	entry $frame.four.scroll -width 3 -textvariable SWIDTH
	pack $frame.four.s -side left -fill x -expand true
	pack $frame.four.scroll -side left
	pack $frame.four -side top -fill x -expand true
	frame $frame.thi
	label $frame.thi.lab -text "Display menubar" -anchor w
	checkbutton $frame.thi.che -text "" -variable MENU
	pack $frame.thi.lab -side left -fill x -expand true
	pack $frame.thi.che -side left
	pack $frame.thi -side top -fill x -expand true
	frame $frame.nine
	label $frame.nine.label -text "Indicate last Connect4 move with grey" -anchor w
	checkbutton $frame.nine.yes -variable STIPPLE -text ""
	pack $frame.nine.label -side left -fill x -expand true
	pack $frame.nine.yes -side left
	pack $frame.nine -side top -fill x -expand true
	frame $frame.ten
	label $frame.ten.label -text "Circle last Connect4 move" -anchor w
	checkbutton $frame.ten.yes -variable RING -text ""
	pack $frame.ten.label -side left -fill x -expand true
	pack $frame.ten.yes -side left
	pack $frame.ten -side top -fill x -expand true
	frame $frame.chesslog
	label $frame.chesslog.lab -text "Display Chess move log" -anchor w
	checkbutton $frame.chesslog.check -variable CHESSLOG -text ""
	pack $frame.chesslog.lab -side left -fill x -expand true
	pack $frame.chesslog.check -side left
	pack $frame.chesslog -side top -fill x -expand true
	set frame [ButtonNotebook::getnextpage .prefs.main]
	frame $frame.one
	label $frame.one.l -text "Use Autologging" -anchor w
	checkbutton $frame.one.log -text "" -variable LOG
	pack $frame.one.l -side left -fill x -expand true
	pack $frame.one.log -side left
	pack $frame.one -side top -fill x -expand true
	frame $frame.ele
	label $frame.ele.lab -text "Use new message notification" -anchor w
	checkbutton $frame.ele.ch -variable NOTIFY -text ""
	pack $frame.ele.lab -side left -fill x -expand true
	pack $frame.ele.ch -side left
	pack $frame.ele -side top -fill x -expand true
	frame $frame.fil
	label $frame.fil.l -text "Filter flashing text to filter window" -anchor w
	checkbutton $frame.fil.ch -variable FILTER -text ""
	pack $frame.fil.l -side left -fill x -expand true
	pack $frame.fil.ch -side left
	pack $frame.fil -side top -fill x -expand true
	frame $frame.twe
	label $frame.twe.lab -text "Use Autologin" -anchor w
	checkbutton $frame.twe.che -text "" -variable LOGIN
	pack $frame.twe.lab -side left -fill x -expand true
	pack $frame.twe.che -side left
	pack $frame.twe -side top -fill x -expand true
	frame $frame.fou
	label $frame.fou.lab -text "Autologin defaults if only one entry" -anchor w
	checkbutton $frame.fou.che -variable ALL -text ""
	pack $frame.fou.lab -side left -fill x -expand true
	pack $frame.fou.che -side left
	pack $frame.fou -side top -fill x -expand true
	frame $frame.ip
	label $frame.ip.label -text "Warn before releasing site info" -anchor w
	checkbutton $frame.ip.check -text "" -variable IPWARN
	pack $frame.ip.label -side left -fill x -expand true
	pack $frame.ip.check -side left
	pack $frame.ip -side top -fill x
	frame $frame.confirm
	label $frame.confirm.l -text "Confirm before quitting" -anchor w
	checkbutton $frame.confirm.con -variable CKQUIT
	pack $frame.confirm -side top -fill x
	pack $frame.confirm.l -side left -fill x -expand true
	pack $frame.confirm.con -side left
	frame $frame.hcaps
	label $frame.hcaps.l -text "Obey case when using tab history completion" -anchor w
	checkbutton $frame.hcaps.check -variable CASETAB
	pack $frame.hcaps -side top -fill x
	pack $frame.hcaps.l -side left -fill x -expand true
	pack $frame.hcaps.check -side left
	frame $frame.hist
	label $frame.hist.l -text "Tab history-completion limit (larger == slower)" -anchor w
	entry $frame.hist.e -textvariable TABLIMIT
	pack $frame.hist.l -side left -fill x -expand true
	pack $frame.hist.e -side left
	pack $frame.hist -side top -fill x -expand true
	frame $frame.eight
	label $frame.eight.p -text "Session locking password" -anchor w
	entry $frame.eight.pass -show * -textvariable PASSWD
	pack $frame.eight.p -side left -fill x -expand true
	pack $frame.eight.pass -side left
	pack $frame.eight -side top -fill x -expand true
	set frame [ButtonNotebook::getnextpage .prefs.main]
	frame $frame.ckv
	label $frame.ckv.t -text "Check for and download new versions of TkTurf" -anchor w
	checkbutton $frame.ckv.check -text "" -variable CKV
	pack $frame.ckv -side top -fill x -expand true
	pack $frame.ckv.t -side left -fill x -expand true
	pack $frame.ckv.check -side left
	frame $frame.alpha
	label $frame.alpha.l -text "Download Alpha (test) versions of TkTurf" -anchor w
	checkbutton $frame.alpha.c -text "" -variable USEALPHA
	pack $frame.alpha.l -side left -fill x -expand true
	pack $frame.alpha.c -side left
	pack $frame.alpha -side top -fill x -expand true
	frame $frame.six
	label $frame.six.p -text "Proxy Address" -anchor w
	entry $frame.six.prox -textvariable PROXY
	pack $frame.six.p -side left -fill x -expand true
	pack $frame.six.prox -side left
	pack $frame.six -fill x -expand true -side top
	frame $frame.seven
	label $frame.seven.p -text "Proxy Port" -anchor w
	entry $frame.seven.port -textvariable PROXPORT
	pack $frame.seven.p -side left -fill x -expand true
	pack $frame.seven.port -side left
	pack $frame.seven -side top -fill x -expand true
	frame $frame.socks
	frame $frame.socks.space
	checkbutton $frame.socks.check -text "SOCKS proxy" -variable SOCKS
	pack $frame.socks.space -side left -fill x -expand true
	pack $frame.socks.check -side left
	pack $frame.socks -side top -fill x -expand true
	frame $frame.ssh
	label $frame.ssh.lab -text "Datapipe Address" -anchor w
	entry $frame.ssh.ssh -textvariable SSHOST
	pack $frame.ssh -side top -fill x -expand true
	pack $frame.ssh.lab -side left -fill x -expand true
	pack $frame.ssh.ssh -side left
	frame $frame.ssp
	label $frame.ssp.lab -text "Datapipe Port" -anchor w
	entry $frame.ssp.ent -textvariable SSHPORT
	pack $frame.ssp -side top -fill x -expand true
	pack $frame.ssp.lab -side left -fill x -expand true
	pack $frame.ssp.ent -side left
	frame $frame.http
	label $frame.http.t -text "HTTP Proxy Address" -anchor w
	entry $frame.http.ent -textvariable HTTPPROXY
	pack $frame.http.t -side left -fill x -expand true
	pack $frame.http.ent -side left
	pack $frame.http -side top -fill x -expand true
	frame $frame.htp
	label $frame.htp.t -text "HTTP Proxy Port" -anchor w
	entry $frame.htp.ent -textvariable HTTPPORT
	pack $frame.htp.t -side left -fill x -expand true
	pack $frame.htp.ent -side left
	pack $frame.htp -side top -fill x -expand true
	set frame [ButtonNotebook::getnextpage .prefs.main]
	frame $frame.player
	label $frame.player.l -text "Command line audio program for sound" -anchor w
	label $frame.player.audio -textvariable AUDIO -relief groove -width 45
	bind $frame.player.audio <Button> {setaudio}
	frame $frame.help
	button $frame.help.help -text "Sound Help" -command {faq SOUND}
	pack $frame.player.l -side left -fill x -expand true
	pack $frame.player.audio -side left
	pack $frame.player -side top -fill x -expand true
	pack $frame.help -fill x
	pack $frame.help.help -side right
	foreach of [lsort -ascii [array names soundnames]] {
		set name [string tolower $of]
		frame $frame.$name
		label $frame.$name.label -text "$soundnames($of)" -anchor w
		label $frame.$name.sel -textvariable SOUNDSTUB($of) -relief groove -width 45
		bind $frame.$name.sel <Button> "setsound $of"
		pack $frame.$name.label -side left -fill x -expand true
		pack $frame.$name.sel -side left
		pack $frame.$name -side top -fill x
	}
	frame .prefs.done
	button .prefs.done.ok -text "Ok" -command {Preferences::apply;Preferences::save;destroy .prefs} 
	button .prefs.done.apply -text "Apply" -command {Preferences::save; Preferences::apply; destroy .prefs; Preferences::window}
	pack .prefs.done.apply -side right
	pack .prefs.done.ok -side right
	pack .prefs.done -side top -fill x -expand true
	bind .prefs <Escape> {Preferences::save; Preferences::apply; destroy .prefs}
	wm protocol .prefs WM_DELETE_WINDOW {Preferences::save; Preferences::apply; destroy .prefs}
	center .prefs
	foreach of $::Preferences::hooks {
		eval [info body $of]
	}
	set frame [::ButtonNotebook::getpage .prefs.main 4]
	frame $frame.sss
	label $frame.sss.label -text "Enable session management" -anchor w
	checkbutton $frame.sss.check -variable SAVESESSIONSTATE
	pack $frame.sss.label -side left -fill x -expand true
	pack $frame.sss.check -side left
	pack $frame.sss -side top -fill x -expand true
	frame $frame.qos
	label $frame.qos.label -text "Log out on Save Session State" -anchor w
	checkbutton $frame.qos.check -variable LOGOUTONSAVE
	pack $frame.qos.label -side left -fill x -expand true
	pack $frame.qos.check -side top
	pack $frame.qos -side top -fill x -expand true
}
proc load {args} {
	notify "Loading Preferences"
	global PREFS
	global SOUNDSTUB
	Preferences::setcoldefaults
	set dep 0
	set file [Preferences::openfile]
	if {[string compare $file "NULL"] == 0} {
		return
	}
	for {} {[eof $file] == 0} {} {
		set line [gets $file]
		if [regexp "^SELECT *: *" $line] {
			global SELECT
			regsub "^SELECT *: *" $line {} SELECT
			continue
		}
		if [regexp "^YELLOW *: *" $line] {
			global YELLOW
			regsub "^YELLOW *: *" $line {} YELLOW
			continue
		}
		if [regexp "^RED *: *" $line] {
			global RED
			regsub "^RED *: *" $line {} RED
			continue
		}
		if [regexp "^BLUE *: *" $line] {
			global BLUE
			regsub "^BLUE *: *" $line {} BLUE
			continue
		}
		if [regexp "^BLACK *: *" $line] {
			global BLACK
			regsub "^BLACK *: *" $line {} BLACK
			continue
		}
		if [regexp "^GREEN *: *" $line] {
			global GREEN
			regsub "^GREEN *: *" $line {} GREEN
			continue
		}
		if [regexp "^CYAN *: *" $line] {
			global CYAN
			regsub "^CYAN *: *" $line {} CYAN
			continue
		}
		if [regexp "^MAGENTA *: *" $line] {
			global MAGENTA
			regsub "^MAGENTA *: *" $line {} MAGENTA
			continue
		}
		if [regexp "^WHITE *: *" $line] {
			global WHITE
			regsub "^WHITE *: *" $line {} WHITE
			continue
		}
		if [regexp "^CFYELLOW *: *" $line] {
			global CFYELLOW
			regsub "^CFYELLOW *: *" $line {} CFYELLOW
			continue
		}
		if [regexp "^CFRED *: *" $line] {
			global CFRED
			regsub "^CFRED *: *" $line {} CFRED
			continue
		}
		if [regexp "^CFBG *: *" $line] {
			global CFBG
			regsub "^CFBG *: *" $line {} CFBG
			continue
		}
		if [regexp "^CFBLANK *: *" $line] {
			global CFBLANK
			regsub "^CFBLANK *: *" $line {} CFBLANK
			continue
		}
		if [regexp "^CFOUT *: *" $line] {
			global CFOUT
			regsub "^CFOUT *: *" $line {} CFOUT
			continue
		}
		if [regexp "^BG *: *" $line] {
			global BG
			regsub "^BG *: *" $line {} BG
			continue
		}
		if [regexp "^CWHITE *: *" $line] {
			global CWHITE
			regsub "^CWHITE *: *" $line {} CWHITE
			continue
		}
		if [regexp "^CBLACK *: *" $line] {
			global CBLACK
			regsub "^CBLACK *: *" $line {} CBLACK
			continue
		}
		if [regexp "^CHECK1 *: *" $line] {
			global CHECK1
			regsub "^CHECK1 *: *" $line {} CHECK1
			continue
		}
		if [regexp "^CHECK2 *: *" $line] {
			global CHECK2
			regsub "^CHECK2 *: *" $line {} CHECK2
			continue
		}
		if [regexp "^CHESSHL *: *" $line] {
			global CHESSHL
			regsub "^CHESSHL *: *" $line {} CHESSHL
			continue
		}
		if [regexp "^RRED *: *" $line] {
			global RRED
			regsub "RRED *: *" $line {} RRED
			continue
		}
		if [regexp "^RBLUE *: *" $line] {
			global RBLUE
			regsub "^RBLUE *: *" $line {} RBLUE
			continue
		}
		if [regexp "^RBACK *: *" $line] {
			global RBACK
			regsub "^RBACK *: *" $line {} RBACK
			continue
		}
		if [regexp "^RLINES *: *" $line] {
			global RLINES
			regsub "^RLINES *: *" $line {} RLINES
			continue
		}
		if [regexp "^BSWCOL *: *" $line] {
			global BSWCOL
			regsub "^BSWCOL *: *" $line {} BSWCOL
			continue
		}
		if [regexp "^BSMIS *: *" $line] {
			global BSMIS
			regsub "^BSMIS *: *" $line {} BSMIS
			continue
		}
		if [regexp "^BSHIT *: *" $line] {
			global BSHIT
			regsub "^BSHIT *: *" $line {} BSHIT
			continue
		}
		if [regexp "^BSLCOL *: *" $line] {
			global BSLCOL
			regsub "^BSLCOL *: *" $line {} BSLCOL
			continue
		}
		if [regexp "^SHIPCOL *: *" $line] {
			global SHIPCOL
			regsub "^SHIPCOL *: *" $line {} SHIPCOL
			continue
		}
		if {$args == "colors"} {continue}
		if [regexp "^PASSWD *:" $line] {
			global PASSWD
			regsub "^PASSWD *: *" $line {} PASSWD
			continue
		}
		if [regexp "^PROXY *:" $line] {
			global PROXY
			regsub "^PROXY *: *" $line {} PROXY
			continue
		}
		if [regexp "^PPORT *: *" $line] {
			global PROXPORT
			regsub "^PPORT *: *" $line {} PROXPORT
			continue
		}
		if [regexp "^PROXPORT *: *" $line] {
			global PROXPORT
			regsub "^PROXPORT *: *" $line {} PROXPORT
			continue
		}
		if [regexp "^CP *: *" $line] {
			global CP
			regsub "^CP *: *" $line {} CP
			continue
		}
		if [regexp "^LOG *: *" $line] {
			global LOG
			regsub "^LOG *: *" $line {} LOG
			continue
		}
		if [regexp "^FFACE *: *" $line] {
			global FFACE
			regsub "^FFACE *: *" $line {} FFACE
			continue
		}
		if [regexp "^FONT *: *" $line] {
			global FONT
			global FFACE
			regsub "^FONT *: *" $line {} FONT
			if {[llength $FONT] == 1} {
				set FONT "\"$FFACE\" $FONT"
			}
			option add "*font" $FONT
			ApplySetting . font $FONT
			
			continue
		}
		if [regexp "^SWIDTH *: *" $line] {
			global SWIDTH
			regsub "^SWIDTH *: *" $line {} SWIDTH
			continue
		}
		if [regexp "^STIPPLE *: *" $line] {
			global STIPPLE
			regsub "^STIPPLE *: *" $line {} STIPPLE
			continue
		}
		if [regexp "^RING *: *" $line] {
			global RING
			regsub "^RING *: *" $line {} RING
			continue
		}
		if [regexp "^NOTIFY *: *" $line] {
			global NOTIFY
			regsub "^NOTIFY *: *" $line {} NOTIFY
			continue
		}
		if [regexp "^login *: *" $line] {
			global logins
			regsub "^login *: *" $line {} line
			regsub " .*" $line {} name
			regsub "\[^ \]* *" $line {} pwd
			set logins($name) $pwd
			continue
		}
		if [regexp "^LOGIN *: *" $line] {
			global LOGIN
			regsub "^LOGIN *: *" $line {} LOGIN
			continue
		}
		if [regexp "^MENU *: *" $line] {
			global MENU
			regsub "^MENU *: *" $line {} MENU
			continue
		}
		if [regexp "^ALL *: *" $line] {
			global ALL
			regsub "^ALL *: *" $line {} ALL
			continue
		}
		if [regexp "^SSHOST *: *" $line] {
			global SSHOST
			regsub "^SSHOST *: *" $line {} SSHOST
			continue
		}
		if [regexp "^SSHPORT *: *" $line] {
			global SSHPORT
			regsub "^SSHPORT *: *" $line {} SSHPORT
			continue
		}
		if [regexp "^trigger *\"\[^\"\]*\" *\[^\n\]" $line] {
			global triggers
			set dep 1
			set trig $line
			set rep $line
			regsub "^trigger \"" $trig {} trig
			regsub "\".*" $trig {} trig
			regsub "^trigger \".*\" *" $rep {} rep
			regsub -all \\\n $rep \n rep
			set triggers($trig) {}
			continue
		}
		if [regexp "^TRIGGER *\"\[^\"\]*\" *\[^\n\]" $line] {
			global triggers
			set trig $line
			set rep $line
			regsub "^TRIGGER \"" $trig {} trig
			regsub "\".*" $trig {} trig
			regsub "^TRIGGER \"\[^\"\]*\" *" $rep {} rep
			regsub -all ";" $rep \n rep
			set triggers($trig) $rep
			continue
		}
		if [regexp "^USEALPHA *: *" $line] {
			global USEALPHA
			regsub "^USEALPHA *: *" $line {} USEALPHA
			continue
		}
		if [regexp "^FILTER *: *" $line] {
			global FILTER
			regsub "^FILTER *: *" $line {} FILTER
			continue
		}
		if [regexp "^FSIZE *: *" $line] {
			global FSIZE
			regsub "^FSIZE *: *" $line {} FSIZE
			continue
		}
		if [regexp "^CKV *: *" $line] {
			global CKV
			regsub "^CKV *: *" $line {} CKV
			continue
		}
		if [regexp "^HTTPPROXY *: *" $line] {
			global HTTPPROXY
			regsub "^HTTPPROXY *: *" $line {} HTTPPROXY
			continue
		}
		if [regexp "^HTTPPORT *: *" $line] {
			global HTTPPORT
			regsub "^HTTPPORT *: *" $line {} HTTPPORT
			continue
		}
		if [regexp "^TABLIMIT *: *" $line] {
			global TABLIMIT
			regsub "^TABLIMIT *: *" $line {} TABLIMIT
			continue
		}
		if [regexp "^AUDIO *: *" $line] {
			global AUDIO
			regsub "^AUDIO *: *" $line {} AUDIO
			continue
		}
		if [regexp "^SOCKS *: *" $line] {
			global SOCKS
			regsub "^SOCKS *: *" $line {} SOCKS
			continue
		}
		if [regexp "^IPWARN *: *" $line] {
			global IPWARN
			regsub "^IPWARN *: *" $line {} IPWARN
			continue
		}
		if [regexp "^IP *: *" $line] {
			global IP
			regsub "^IP *: *" $line {} IP
			continue
		}
		if [regexp "^SOUNDSTUB" $line] {
			regexp "\\\((.*)\\\) *: *(.*)" $line junk name value
			set SOUNDSTUB($name) $value
			continue
		}
		if [regexp "^FILTERSIZE" $line] {
			global FILTERSIZE
			regsub "^FILTERSIZE *: *" $line {} FILTERSIZE
			continue
		}
		if [regexp "^SAVESESSIONSTATE" $line] {
			global SAVESESSIONSTATE
			regsub "SAVESESSIONSTATE *: *" $line {} SAVESESSIONSTATE
			continue
		}
		if [regexp "LOGOUTONSAVE" $line] {
			global LOGOUTONSAVE
			regsub "LOGOUTONSAVE *: *" $line {} LOGOUTONSAVE
			continue
		}
		if [regexp "CKQUIT" $line] {
			global CKQUIT
			regsub "CKQUIT *: *" $line {} CKQUIT
			continue
		}
		if [regexp "CHESSLOG" $line] {
			global CHESSLOG
			regsub "CHESSLOG *: *" $line {} CHESSLOG
			continue
		}
		if [regexp "NOSERVER" $line] {
			global NOSERVER
			set NOSERVER 1
			continue
		}
		if [regexp "CASETAB" $line] {
			global CASETAB
			regsub "CASETAB *: *" $line {} CASETAB
			continue
		}
		foreach of [array names PREFS] {
			if [regexp "^$of *: *" $line] {
				regsub "^$of *: *" $line {} PREFS($of)
				continue
			}
		} 
	}
	close $file
	if {$dep == 1} {
		tk_dialog .error "Deprecated Triggers" "Your preference file contains triggers specified using a deprecated system. These have been cast to new trigger entries with no response." error 0 Okay
	}
}
}
namespace eval Passwd {
proc change {} {
	global tprime
	if [string compare [.pass.mid.new1 get] [.pass.bot.con get]] {
		tk_dialog .error Error "New password entries do not match" error 0 Oops
		return
	}
	catch {puts $tprime "password [.pass.top.old get] [.pass.mid.new1 get]"}
	destroy .pass
}
proc window {} {
	destroy .pass
	toplevel .pass
	wm title .pass "Change Password"
	frame .pass.top
	frame .pass.mid
	frame .pass.bot
	frame .pass.but
	label .pass.top.ld -anchor w -text "Old Password"
	entry .pass.top.old -show *
	label .pass.mid.ew1 -anchor w -text "New Password"
	entry .pass.mid.new1 -show *
	label .pass.bot.on -anchor w -text "Confirm Password"
	entry .pass.bot.con -show *
	button .pass.but.change -text Change -command Passwd::change
	button .pass.but.can -text Cancel -command {destroy .pass}
	pack .pass.top.ld -side left -fill x -expand true
	pack .pass.top.old -side left
	pack .pass.top -side top -fill x
	pack .pass.mid.ew1 -side left -fill x -expand true
	pack .pass.mid.new1 -side left
	pack .pass.mid -side top -fill x
	pack .pass.bot.on -side left -fill x -expand true
	pack .pass.bot.con -side left
	pack .pass.bot -side top -fill x
	pack .pass.but.can -side right
	pack .pass.but.change -side right
	pack .pass.but -side top -fill x
	center .pass
	focus .pass.top.old
	bind .pass <Escape> {destroy .pass}
	bind .pass.top.old <Return> {focus [tk_focusNext %W]}
	bind .pass.mid.new1 <Return> {focus [tk_focusNext %W]}
	bind .pass.bot.con <Return> Passwd::change
}
}
proc NoteSend {wid} {
	global tprime
	if [catch { puts $tprime \n }] { tk_dialog .nomail Error "You can not send a note without being connected" error 0 "Oh Yeah..."; return }
	if {[string length [$wid.top.toent get]] == 0} {
		tk_dialog .error Error "Would you like to specify who this should be mailed to?" error 0 "Yes"
		return
	}
	if {[string length [$wid.bot.subent get]] == 0} {
		tk_dialog .error Error "You must specify a subject" error 0 "Ooops"
		return
	}
	puts $tprime "note edit"
	puts $tprime ".wipe"
	set message [$wid.text.text get 0.0 end]
	regsub -all "\n\n" $message "\n  \n" message
	puts $tprime $message
	puts $tprime ".end"
	puts -nonewline $tprime "note to "
	puts $tprime [$wid.top.toent get]
	puts -nonewline $tprime "note subject "
	puts $tprime [$wid.bot.subent get]
	puts $tprime "note post"
	destroy $wid
}
proc pine {} {
	global winc
	incr winc
	toplevel .$winc
	wm title .$winc "Note Editor"
	frame .$winc.top
	frame .$winc.bot
	label .$winc.top.to -text "Note to:" -anchor w -width 8
	entry .$winc.top.toent
	pack .$winc.top.to -side left
	label .$winc.bot.sub -text "Subject:" -anchor w -width 8
	entry .$winc.bot.subent
	pack .$winc.bot.sub -side left
	pack .$winc.bot.subent -side left -fill x -expand true
	pack .$winc.top -side top -fill x
	pack .$winc.top.toent -side left -fill x -expand true
	pack .$winc.bot -side top -fill x -expand true
	ScrolledTextWidget .$winc.text -width 60 -height 20 -wrap word
	pack .$winc.text -side top -fill both -expand true
	frame .$winc.buts
	button .$winc.buts.send -text Send -command "NoteSend .$winc"
	button .$winc.buts.cancel -text Cancel -command "destroy .$winc"
	pack .$winc.buts.cancel -side right
	pack .$winc.buts.send -side right
	pack .$winc.buts -side top -fill x
	wm resizable .$winc 0 0
	bind .$winc <Escape> "destroy .$winc"
	bind .$winc <Control-Key-x> "NoteSend .$winc"
	focus .$winc.top.toent
}
proc TabGrep {} {
	global CASETAB
	global history
	global histind
	global TABLIMIT
	set x [expr $histind -1]
	set its 0
	set cstring [.promptline.mainent get]
	set len [string length $cstring]
	set cstring [makereg $cstring]
	if {$CASETAB} {set flag "--"} {set flag "-nocase"}
	for {} {[regexp $flag ^$cstring $history($x)] != 1} {incr its} {
		incr x -1
		if {($its == $TABLIMIT) || ($x == -1)} {
			return
		}
	}
	.promptline.mainent delete 0 end
	.promptline.mainent insert 0 $history($x)
}
proc SendMove {x} {
	global tprime
	catch {puts $tprime "c15 bf[expr $x / 51]"}
}
proc InitCfour {} {
	global cfmap
	global CFBLANK
	global CFBG
	set stepx 0
	set stepy 0
	toplevel .cfourwin -takefocus 0
	canvas .cfourwin.board -width 350 -height 350 -background $CFBG -takefocus 0
	frame .cfourwin.m
	label .cfourwin.m.message -text "Connect Four" -anchor w -takefocus 0
	pack .cfourwin.board
	pack .cfourwin.m.message -side right -fill x -expand true
	pack .cfourwin.m -side top -fill x -expand true
	for {set a 0} {$a <= 6} {incr a} {
		for {set b 0; set stepy 0} {$b <= 6} {incr b} {
			set cfmap($a,$b) [.cfourwin.board create oval $stepx $stepy [expr $stepx + 50] [expr $stepy +50] -fill $CFBLANK -outline $CFBG -width 3]
			incr stepy +50
		}
		incr stepx +50
	}
	bind .cfourwin.board <ButtonRelease> {SendMove %x}
	.cfourwin.board config -cursor target
	wm resizable .cfourwin 0 0
	wm title .cfourwin "Connect Four"
	MakeRelay .cfourwin
	bind .cfourwin <Escape> {break}
	bind .cfourwin <Key-F1> {faq C4}
}
proc SendChal {} {
	global tprime
	if [catch {set sel [.plist.listing.list get [.plist.listing.list curselection]]}] {
		tk_dialog .error "Error" "You really should select a player before you try to challenge anyone" error 0 Ooops
		return
	}
	destroy .plist
	catch {puts -nonewline $tprime "c15 bb"}
	catch {puts $tprime $sel}
}
proc init_session {} {
	global tprime
	global VERSION
	global tcl_platform
	puts $tprime "c15 aTkTurf $VERSION ($tcl_platform(os) $tcl_platform(osVersion) ($tcl_platform(machine)))"
	puts $tprime "c15 d"
	puts $tprime "c15 e"
	global histind
	set histind 0
	set FIRST 0
	set ::TRIGOFF 0
	::Menu::activate .menubar.turf
	::Menu::activate .menubar.games
	.menubar.win entryconfigure "Turf Colour Editor" -state normal
}
proc cfhandle {command} {
	global CP
	global DOT
	global CFRED
	global CFOUT
	global CFYELLOW
	global CFBG
	global RING
	global STIPPLE
	global FIRST
	if {$FIRST == 1} {Event::call LOGIN; set FIRST 0}
	regsub "\x1f" $command {} command
	catch {wintalk .scan.text.text $command {}}
	if {[regexp "^bf" $command] == 1} {
		global cfmap
		regsub "^bf" $command {} command
		set x [string index $command 0]
		set y [string index $command 1]
		set fc [string index $command 2]
		set y [expr 6 - $y]
		catch {.cfourwin.board itemconfig $cfmap($DOT(x),$DOT(y)) -stipple "" -outline $CFBG}
		set DOT(x) $x
		set DOT(y) $y
		if {$fc == 1} {
			if {$RING == 1} {
				catch {.cfourwin.board itemconfig $cfmap($x,$y) -fill $CFRED -outline $CFOUT}
			} {
				catch {.cfourwin.board itemconfig $cfmap($x,$y) -fill $CFRED}
			}
			if {$STIPPLE == 1} {
				catch {.cfourwin.board itemconfig $cfmap($x,$y) -stipple gray50}
			}
		} {
			if {$fc == 2} {
				if {$RING == 1} {
					catch {.cfourwin.board itemconfig $cfmap($x,$y) -fill $CFYELLOW -outline $CFOUT}
				} {
					catch {.cfourwin.board itemconfig $cfmap($x,$y) -fill $CFYELLOW}
				}
				if {$STIPPLE == 1} {
					catch {.cfourwin.board itemconfig $cfmap($x,$y) -stipple gray50}
				}
			}
		}
		eventsound CFMOVE
		return
	}
	if {[regexp "^bc" $command] == 1} {
		destroy .cfourwin
		InitCfour
		return
	}
	if {[regexp "^bg" $command] == 1} {
		regsub "^bg" $command {} command
		catch {.cfourwin.m.message config -text $command}
		return
	}
	if {[regexp "^ba" $command] == 1} {
		destroy .plist
		toplevel .plist
		wm title .plist "C4 Player Listing"
		ScrolledListWidget .plist.listing -selectmode single 
		focus .plist.listing.list
		bind .plist.listing.list <Double-1> SendChal
		bind .plist.listing.list <Return> SendChal
		pack .plist.listing -side top -fill both -expand true
		frame .plist.holder
		button .plist.holder.ok -text "Challenge" -command SendChal
		button .plist.holder.cancel -text Cancel -command {destroy .plist}
		pack .plist.holder.cancel -side right
		pack .plist.holder.ok -side right
		pack .plist.holder -side bottom -fill x
		bind .plist <Escape> {destroy .plist}
		center .plist
		return
	}
	if {[regexp "^bb" $command] == 1} {
		regsub "^bb" $command {} command
		regsub "\n" $command {} command
		catch {.plist.listing.list insert end $command}
		return
	}
	if {[regexp "^bd" $command] == 1} {
		if {$CP == 1} {return}
		regsub "^bd" $command {} command
		regsub "\n" $command {} command
		destroy .chal
		global tprime
		toplevel .chal
		wm title .chal "Connect 4 challenge from $command"
		label .chal.from -text "Connect 4 challenge from $command"
		frame .chal.buts
		button .chal.buts.ok -text Accept -command "ChalAcc $command"
		button .chal.buts.no -text Deny -command "destroy .chal; puts $tprime \"c15 c$command C4.denied\""
		pack .chal.from -side top
		pack .chal.buts -side top -fill x
		pack .chal.buts.ok -side left
		pack .chal.buts.no -side left
		bind .chal <Escape> {destroy .chal}
		MakeRelay .chal
		center .chal
		eventsound CHAL
		return
	}
	if {[regexp "^bh" $command] == 1} {	
		regsub "^bh" $command {} command
		set x1 [string index $command 0]
		set y1 [string index $command 1]
		set x2 [string index $command 2]
		set y2 [string index $command 3]
		set y1 [expr 6 - $y1]
		set y2 [expr 6 - $y2]
		set x1 [expr $x1 * 50 + 25]
		set x2 [expr $x2 * 50 + 25]
		set y1 [expr $y1 * 50 + 25]
		set y2 [expr $y2 * 50 + 25]
		.cfourwin.board create line $x1 $y1 $x2 $y2 -capstyle round
		bind .cfourwin <Button> {destroy .cfourwin}
		return
	}
	EPhandler $command
}
proc ChalAcc {name} {
	global tprime
	destroy .chal
	catch { puts -nonewline $tprime "c15 bc"}
	catch { puts $tprime $name }
}
proc EntScroll {direction} {
	global sind
	global history
	global histind
	if {$sind == $histind} {
		set history($sind) [.promptline.mainent get]
	}
	.promptline.mainent delete 0 end
	if {$direction == 1} {
		incr sind -1
		if [catch {.promptline.mainent insert 0 $history($sind)}] {
			set sind 0
			catch {.promptline.mainent insert 0 $history($sind)}
		}
		return
	}
	if {$direction == 0} {
		incr sind
		if [catch {.promptline.mainent insert 0 $history($sind)}] {
				set sind $histind
			catch {.promptline.mainent insert 0 $history($sind)}
		}
		return
	}
}
proc makereg {badstring} {
	regsub -all "\\\\" $badstring \\\\\\ badstring
	regsub -all "\\\|" $badstring \\\| badstring
	regsub -all "\\\[" $badstring \\\[ badstring
	regsub -all "\\\]" $badstring \\\] badstring
	regsub -all "\\\(" $badstring \\\( badstring
	regsub -all "\\\)" $badstring \\\) badstring
	regsub -all "\\\$" $badstring \\\$ badstring
	regsub -all "\\\^" $badstring \\\^ badstring
	regsub -all "\\\*" $badstring \\\* badstring
	regsub -all "\\\+" $badstring \\\+ badstring
	regsub -all "\\\?" $badstring \\\? badstring
	return $badstring
}
proc wintalk {wid tex flags} {
	if {[lindex [$wid yview] 1] == 1} {set s 1} {set s 0}
	$wid config -state normal
	$wid insert end $tex $flags
	$wid config -state disabled
	if {$s == 1} {$wid see end}
	if {($::DONOTIFY == 1) && ([string length $tex] > 1)} {eventsound NEWTEXT;NotifyUser}
	catch {puts -nonewline $::FILE $tex}
}
proc TTC {win} {
	global tcl_platform
	if {$tcl_platform(platform) == "windows"} {
		$win tag config sel -background $::SELECT
	}
	$win tag config blue -foreground $::BLUE
	$win tag config red -foreground $::RED
	$win tag config magenta -foreground $::MAGENTA
	$win tag config green -foreground $::GREEN
	$win tag config yellow -foreground $::YELLOW
	$win tag config cyan -foreground $::CYAN
	$win tag config white -foreground $::WHITE
	$win tag config 30 -foreground $::BLACK
	$win tag config 34 -foreground $::BLUE
	$win tag config 31 -foreground $::RED
	$win tag config 35 -foreground $::MAGENTA
	$win tag config 32 -foreground $::GREEN
	$win tag config 33 -foreground $::YELLOW
	$win tag config 36 -foreground $::CYAN
	$win tag config 37 -foreground $::WHITE
	$win tag config black -foreground $::BLACK
}
proc ScrolledTextWidget {frame args}  {
	global tcl_platform
	global BLACK
	global RED
	global YELLOW
	global GREEN
	global MAGENTA
	global CYAN
	global WHITE
	global BLUE
	global SWIDTH
	global SELECT
	global FONT
	global tcl_platform
	frame $frame
	eval {text $frame.text -yscrollcommand "$frame.yscroll set"} $args
	scrollbar $frame.yscroll -orient vertical -command "$frame.text yview" -takefocus 0 -width $SWIDTH
	grid $frame.text $frame.yscroll -sticky news
	grid rowconfigure $frame 0 -weight 1
	grid columnconfigure $frame 0 -weight 1
	if {$tcl_platform(platform) == "windows"} {
		$frame.text tag config sel -background $SELECT
	}
	$frame.text tag config bold -font "$FONT bold"
	$frame.text tag config blue -foreground $BLUE
	$frame.text tag config red -foreground $RED
	$frame.text tag config magenta -foreground $MAGENTA
	$frame.text tag config green -foreground $GREEN
	$frame.text tag config yellow -foreground $YELLOW
	$frame.text tag config cyan -foreground $CYAN
	$frame.text tag config white -foreground $WHITE
	$frame.text tag config black -foreground $BLACK
	$frame.text tag config 30 -foreground $BLACK
	$frame.text tag config 34 -foreground $BLUE
	$frame.text tag config 31 -foreground $RED
	$frame.text tag config 35 -foreground $MAGENTA
	$frame.text tag config 32 -foreground $GREEN
	$frame.text tag config 33 -foreground $YELLOW
	$frame.text tag config 36 -foreground $CYAN
	$frame.text tag config 37 -foreground $WHITE
	bind $frame.text <Control-Key-c> {Copy}
	if {$tcl_platform(platform) != "windows"} {
		bind $frame.text <Control-Key-v> {Paste %W; break}
	}
	bind $frame.text <Next> {%W yview scroll 1 pages}
	bind $frame.text <Prior> {%W yview scroll -1 pages}
	return $frame.text
}
proc LogOut {} {
	global tprime
	global CNECT
	catch {.promptline.prompt config -text "Quitting"}
	eventsound DISCONNECT
	if [catch {puts $tprime "quit"}] {set CNECT 0; ConnectDie}
	after 7000 {catch {ConnectDie}}
}
proc GrabListing {} {
	global tprime
	global CP
	set CP 0
	catch {puts $tprime "c15 ba"}
}
proc MainInterFace {} {
	global BG
	global TURFLOGO
	global BLACK
	global tcl_platform
	global VERSION
	global MENU
	global FILTER
	global BROWSER
	global FILTERSIZE
	wm title . "TkTurf $VERSION"
	wm protocol . WM_DELETE_WINDOW {quit}
	if {$MENU == 1} {
		. config -menu .menubar
	}
	menu .menubar -tearoff 0
	menu .menubar.connection
	menu .menubar.edit
	menu .menubar.games
	menu .menubar.turf
	menu .menubar.opts
	menu .menubar.win
	menu .menubar.help
	menu .menubar.help.amuse
	.menubar add cascade -label Connection -underline 0 -menu .menubar.connection
	.menubar.connection add command -label Connect -underline 0 -command GetSock -state disabled
	.menubar.connection add command -label Disconnect -underline 0 -command LogOut
	.menubar.connection add separator
	.menubar.connection add command -label "Statistics" -underline 0 -command StatusWin
	.menubar.connection add command -label "Log Dump" -underline 0 -command LDump
	.menubar.connection add command -label "Lock (Ctrl-L)" -underline 5 -command {LT 1}
	.menubar.connection add separator
	.menubar.connection add command -label "Quit (Ctrl-Q)" -underline 0 -command {catch {close $FILE}; LogOut; set QUIT 1; if {$CNECT == 0} {exit}}
	.menubar add cascade -label Edit -underline 0 -menu .menubar.edit
	.menubar.edit add command -label "Copy (Ctrl-c)" -command {Copy}
	.menubar.edit add command -label "Paste (Ctrl-v)" -command {Paste .promptline.mainent}
	.menubar.edit add command -label "Find (Ctrl-f)" -command Find::window
	.menubar.edit add command -label "Find Again (Ctrl-g)" -command Find::search
	.menubar.edit add separator
	.menubar.edit add command -label "Alias Editor" -command Alias::window
	.menubar.edit add command -label "Autologin Editor" -command DLW
	.menubar.edit add command -label "Trigger Editor" -command TrigWin
	.menubar add cascade -label Amusements -underline 0 -menu .menubar.games
	.menubar.games add command -label "Connect Four" -underline 8 -command "GrabListing" -state disabled
	.menubar.games add command -label "Chess" -underline 0 -command "ChessFindPlayers" -state disabled
	.menubar.games add command -label Reversi -command {RListP} -state disabled
	.menubar.games add command -label Battleship -command BattleFindPlayers -state disabled
	.menubar add cascade -label Turf -underline 0 -menu .menubar.turf
	.menubar.turf add command -label "Note edit" -underline 0 -command pine -state disabled
	.menubar.turf add command -label "Change Password" -underline 7 -command Passwd::window -state disabled
	.menubar.turf add command -label "Room Editor"	-underline 0 -command REW -state disabled
	.menubar.turf add command -label "Description Editor" -underline 0 -command DEW -state disabled
	.menubar add cascade -label Options -underline 0 -menu .menubar.opts
	.menubar.opts add check -label "Triggers Off" -variable TRIGOFF
	.menubar.opts add check -label "Ignore Games" -variable CP
	.menubar.opts add check -label "Filter Flashing" -variable FILTER
	.menubar.opts add check -label "New Text Notify" -variable NOTIFY
	.menubar.opts add command -label "(Un)Hide Entry (Ctrl-h)" -command swaphide
	.menubar add cascade -label Window -underline 0 -menu .menubar.win
	.menubar.win add command -label "Preferences" -underline 0 -command Preferences::window
	.menubar.win add command -label "Turf Colour Editor" -command Colour::window -state disabled
	.menubar.win add command -label "Colour Configurator" -underline 0 -command CCW
	.menubar.win add command -label "Amusements Colours" -command GCCW
	.menubar.win add command -label "Clear Window" -underline 6 -command ClearWindows
	.menubar.win add separator
	.menubar.win add command -label "Sync Version" -command ConfirmVersion
	.menubar.win add separator
	menu .menubar.help.f
	.menubar.help add command -label "About TkTurf" -command AboutTkTurf
	.menubar.help add command -label Changelog -command {faq CHANGELOG}
	menu .menubar.help.v
	.menubar.help add cascade -menu .menubar.help.v -label "Display"
	.menubar.help.v add command -label "Message Filtering" -command {faq FLT}
	.menubar.help add cascade -label Amusements -menu .menubar.help.amuse
	.menubar.help.amuse add command -label "Connect Four" -command {faq C4}
	.menubar.help.amuse add command -label Chess -command {faq CHELP}
	.menubar.help.amuse add command -label Reversi -command {faq REVERH}
	.menubar.help.amuse add command -label Battleship -command {faq BSHELP}
	menu .menubar.help.a
	.menubar.help add cascade -menu .menubar.help.a -label "Advanced"
	.menubar.help.a add command -label "Command Stringing" -command {faq MCS}
	.menubar.help.v add command -label Prompts -command {faq PRMPTS}
	.menubar.help.v add command -label "Boss Key" -command {faq BOSSKEY}
	.menubar.help.a add command -label Aliases -command {faq ALS}
	.menubar.help.a add command -label "Triggers" -command {faq TRI}
	.menubar.help.a add command -label "Output Piping" -command {faq CMDPIPE}
	menu .menubar.help.plugins
	.menubar.help add cascade -label Plugins -menu .menubar.help.plugins
	.menubar.help.plugins add command -label "Installed Plugins" -command PluginInfo
	.menubar.help.plugins add command -label "Plugin Help" -command {faq PLGS}
	menu .menubar.help.misc
	.menubar.help add cascade -menu .menubar.help.misc -label "Misc"
	.menubar.help add command -label Errata -command {faq ERR}
	.menubar add cascade -label Help -underline 0 -menu .menubar.help
	.menubar.help.misc add command -label Logging -command {faq LOGGER}
	frame .promptline
	entry .promptline.mainent -takefocus 1
	label .promptline.prompt -text "" -takefocus 0 -anchor w -pady 0 -padx 0
	frame .promptline.tray
	pack .promptline.tray -side right
	pack .promptline.mainent -side right -fill x -expand true
	pack .promptline.prompt -side right
	pack .promptline -side bottom -fill x
	bind .promptline.mainent <Return> {STDre .promptline.mainent}
	ScrolledTextWidget .filter -width 80 -height $FILTERSIZE -wrap word -state normal -relief flat -cursor "" -background $BG -foreground $BLACK
	.filter.text config -state disabled
	if {$FILTER == 1} {pack .filter -side bottom -fill both}
	ScrolledTextWidget .twid -width 80 -height 25 -wrap word -state normal -relief flat -cursor "" -background $BG -foreground $BLACK
	pack .twid -side bottom -fill both -expand true
	catch {.twid.text image create 0.0 -image $TURFLOGO}
	bind . <Up> {EntScroll 1}
	bind . <Down> {EntScroll 0}
	if [string compare $tcl_platform(platform) "unix"] {
		bind . <FocusIn> {catch {focus -force .promptline.mainent}}
		bind .twid.text <Key> {break}
		bind .twid.text <Button> {.twid.text config -state normal}
		bind .twid.text <ButtonRelease> {.twid.text config -state disabled; catch {focus -force .promptline.mainent}}
	}
	bind all <Control-Key-p> {EntScroll 1}
	bind all <Control-Key-n> {EntScroll 0}
	bind all <Control-Key-u> {.promptline.mainent delete 0 end}
	bind all <Control-Key-q> {quit}
	bind all <Control-Key-d> {ctrld %W}
	bind all <Control-Key-l> {LT 1}
	bind all <Control-Key-s> {LT 0}
	bind all <Control-Key-c> {Copy; break}
	bind . <Control-Key-f> {Find::window}
	bind . <Control-Key-g> {Find::search}
	bind all <Meta-Key-p> {EntScroll 1}
	bind all <Meta-Key-n> {EntScroll 0}
	bind all <Meta-Key-u> {.promptline.mainent delete 0 end}
	bind all <Meta-Key-q> {quit}
	bind all <Meta-Key-l> {LT 1}
	bind all <Meta-Key-c> {Copy}
	bind . <Meta-Key-f> {Find::window}
	bind . <Meta-Key-g> {Find::search}
	bind .promptline.mainent <Tab> {catch {TabGrep}; break}
	.twid.text config -state disabled
	wm protocol . KWM_SAVE_YOURSELF {System::saveSessionState}
	wm protocol . WM_SAVE_YOURSELF {System::saveSessionState}
	bind .promptline.mainent <Shift-Return> {.promptline.mainent insert insert "\n\r"; break}
	bind .promptline.mainent <Meta-Return> {CommandHandle [.promptline.mainent get]}
	bind .promptline.mainent <Control-Return> {CommandHandle [.promptline.mainent get]}
	bind . <FocusIn> {SetDoNotify VisibilityUnobscured}
	bind . <FocusOut> {SetDoNotify Setiton!}
	bind . <Next> {.twid.text yview scroll 1 pages}
	bind . <Prior> {.twid.text yview scroll -1 pages}
	bind . <Shift-Next> {.filter.text yview scroll 1 pages; break}
	bind . <Shift-Prior> {.filter.text yview scroll -1 pages; break}
	bind .promptline.mainent <Meta-Left> {.promptline.mainent icursor 0}
	bind .promptline.mainent <Meta-Right> {.promptline.mainent icursor end}
	bind . <Button-3> {tk_popup .menubar [winfo pointerx .] [winfo pointery .]; focus -force .menubar}
	bind . <Control-Button> {tk_popup .menubar [winfo pointerx .] [winfo pointery .]; focus -force .menubar}
	bind .promptline.mainent <Button-2> {break}
	bind . <Button-2> {Paste .promptline.mainent; break}
	bind .promptline.mainent <ButtonRelease-2> {Paste .promptline.mainent;break}
	bind all <Control-Key-h> {swaphide;break}
	bind all <Control-Key-z> ::Boss::here
	bind all <FocusIn> {SetDoNotify VisibilityUnobscured}
	bind all <FocusOut> {SetDoNotify Setiton!}
	bind .promptline.mainent <End> {.twid.text see end}
	bind .twid.text <Visibility> {set VIS %s; SetDoNotify VisibilityUnobscured}
	bind . <Unmap> {set VIS -1; SetDoNotify on}
	if {$BROWSER} {center .} {wm geometry . 650x350+0+0}
	if {$tcl_platform(platform) == "windows"} {
		focus -force .promptline.mainent
	}
	focus -force .promptline.mainent
}
proc GetSock {} {
	global tprime
	global ptog
	global PROXY
	global PROXPORT
	global LOGIN
	global SSHOST
	global SSHPORT
	global STAT
	global SOCKS
	global RX
	global TX
	set RX 0
	set TX 0
	notify "Connecting. This may take a moment."
	set ptog 0
	.promptline.mainent config -show {}
	if [catch {socket $SSHOST $SSHPORT} tprime] {
		if {([string length $PROXY] > 0) && ([string length $SSHOST] > 0)} {
			notify "Falling back to PROXY"
			after 1000
		}
		set proxinit "c turf.org 4000\n"
		if $SOCKS {
			set proxinit [binary format "ccScccca*c" 4 1 4000 206 165 33 252 sockspray 0]
		}
		if [catch {socket $PROXY $PROXPORT} tprime] {
			if {[string length $PROXY] > 0} {
				notify "Falling back to DIRECT"
				after 1000
			}
			set proxinit ""
			if [catch {socket turf.org 4000} tprime] {
				destroy .ad
				eventsound CNECTERR
				ConnectErrorWin
				catch {
				.menubar.connection entryconfigure Connect -state normal
				.menubar.connection entryconfigure Disconnect -state disabled}
				return
			}
		}
		puts -nonewline $tprime "$proxinit"
		flush $tprime
	}
	eventsound CONNECT
	set STAT Connected
	fconfigure $tprime -buffersize 1 -buffering none -blocking 0 -translation binary
	fileevent $tprime readable ReadMain
	.menubar.connection entryconfigure Connect -state disabled
	.menubar.connection entryconfigure Disconnect -state normal
	puts $tprime "ClientConnect\n\377\375\031" nonewline
	global CNECT
	set CNECT 1
	if {$LOGIN == 1} {AutoLoginWin}
	ClearWindows
	.twid.text see end
}
proc ConnectDie {} {
	global tprime
	global STAT
	global QUIT
	global VERSION
	global sind
	global histind
	global history
	global NAME
	set histind -6
	set sind 0
	catch {unset history}
	.history.panel.list delete 0 end
	.promptline.prompt config -text ""
	catch {close $tprime}
	set STAT Disconnected
	.menubar.connection entryconfigure Connect -state normal
	.menubar.connection entryconfigure Disconnect -state disabled
	.menubar.win entryconfigure "Turf Colour Editor" -state disabled
	global FIRST
	set FIRST 1
	wm title . "TkTurf $VERSION"
	set NAME ""
	Menu::deactivate .menubar.turf
	Menu::deactivate .menubar.games
	Event::call DISCONNECT
	if {$QUIT == 1} {exit}
}
proc ReadMain {} {
	global triggers
	global tprime
	global rbuf
	global appbuf
	global tflags
	global ptog
	global WINDOW
	global FILTER
	global trigbuf
	global READING
	if {$READING} {return}
	set READING 1
	if [eof $tprime] {
		global TURFLOGO
		.twid.text config -state normal
		catch {.twid.text image create end -image $TURFLOGO}
		.twid.text see end
		.twid.text config -state disabled
		.promptline.prompt config -text "Disconnected"
		ConnectDie
		global CNECT
		set CNECT 0
		set READING 0
		return
	}
	set toline [read $tprime]
	set ::RX [expr $::RX + [string length $toline]]
	append appbuf "$toline"
	regsub -all "\n" $appbuf {} appbuf
	regsub -all "\r" $appbuf \n appbuf
	regexp ".*()*(Press RETURN to continue:)*(\[Please type c, r, b, h, q, or RETURN\]:)*(\n)*(\377)*" $appbuf tem1
	append rbuf $tem1
	set hd [regsub -all "\x01" $rbuf {} rbuf]
	if {$hd == 1} {
		if {$ptog == 0} {
			.promptline.mainent config -show *
			set ptog 1
		} { .promptline.mainent config -show {}
			set ptog 0
		}
	}
	regsub ".*(By what name do you wish to be known\?)*(Press RETURN to continue:)*(\[Please type c, r, b, h, q, or RETURN\]:)*(\n)*(\377)*" $appbuf {} appbuf
	regsub ".*\n" $rbuf {} prompt
	regsub -all "" $prompt {} prompt
	if [regsub {.*} $prompt {} prompt] {
		regsub -all "\\\\n" $prompt "\n" promptpro
		regsub -all "." $promptpro {} promptpro
		if {$promptpro != ""} {.promptline.prompt config -text $promptpro}
	}
	regsub -all "\[^\n\]*(|)" $rbuf  rbuf
	regsub -all "\n\[^\n\]*(|)" $rbuf \n rbuf
	regsub -all "\[^\n\]*(|)" $rbuf {} rbuf
	if [regsub -all "\a" $rbuf {} rbuf] audiobell
	regsub -all -- "." $rbuf {} rbuf
	regsub "<!-\b\b\b\x19" $rbuf {} rbuf
	for {set c [regexp "\[\x1f\]" $rbuf]} {$c} {set c [regexp "\[\x1f\]" $rbuf]} {
		set cfcom {}
		regexp "\[\x1f\]\[^\n\]*\n*" $rbuf cfcom
		regsub "\[\x1f\]\[^\n\]*\n*" $rbuf {} rbuf
		catch {cfhandle $cfcom}
	}
	regsub -all "\x1f" $rbuf {} rbuf
	if {[regexp ".*\n" $rbuf trigbuf] == 1 && $::TRIGOFF == 0} {
		foreach string [split $trigbuf \n] {
			regsub -all "\[\x1b\]\[^m\]*m" $string {} string
			foreach of [array names triggers] {
				if [regexp -- $of $string match 1 2 3 4 5 6 7 8 9] {
					catch {eval $triggers($of)}
				}
			}
		}
	}
	for {set g [string first \x1b $rbuf]} {$g != -1} {set g [string first \x1b $rbuf]} {
		if {$g > 0} {
			set tempout [string range $rbuf 0 [expr $g -1]]
			wintalk $WINDOW $tempout $tflags
			set rbuf [string trimleft $rbuf $tempout]
			if {$WINDOW == ".filter.text"} {regsub \n $rbuf {} rbuf; wintalk $WINDOW \n $tflags}
			continue
		}
		if {$g == 0} {
			if {[string first m $rbuf] < 1} {break}
			regsub "\x1b" $rbuf {} rbuf
			set tempout [string first m $rbuf]
			set tempout [string range $rbuf 0 $tempout]
			set tem1pout [makereg $tempout]
			regsub -- $tem1pout $rbuf {} rbuf
			if {[regexp \\\[1 $tempout] == 1} {
				lappend tflags "bold"
			}
			if {[regexp \\\[5 $tempout] == 1} {
				if {$FILTER == 1} {set WINDOW .filter.text}
			}
			if {[regexp \\\[0 $tempout] == 1} {
				set tflags {}
				set WINDOW .twid.text
			}
			if {[regexp \\\[m $tempout] == 1} {
				set tflags {}
				set WINDOW .twid.text
			}
			regexp "\\\[\[0-9\];(\[0-9\]\[0-9\])m" $tempout match good
			catch {append tflags " $good"}
			set good {}
		}
	}
	set READING 0
	if {$g != -1} {return}
	if [regexp "(.*\n)" $rbuf temp1 temp] {
		regsub ".*\n" $rbuf {} rbuf
		wintalk $WINDOW $temp $tflags
	}
}
proc STDre {widg} {
	global tprime
	global history
	global histind
	global sind
	global TX
	global MULTI
	set oline [$widg get]
	$widg delete 0 end
	if {([regexp "^ *$" $oline ] != 1) && ($histind != -6)} {
		set history($histind) $oline
		incr histind
		set sind $histind
		.history.panel.list insert end $oline
		.history.panel.list see end
	}
	if ![string length $oline] {puts $tprime {}; return}
	set oline [split $oline "\n\r"]
	foreach of $oline {
		foreach al $::Aliases::names {
			set lkey [makereg $al]
			if {[regexp "^${lkey}( |$)" $of] == 1} {
				regsub "^$lkey" $of {} of
				if [catch {eval ::Aliases::$al $of}] {
					global errorInfo
					tk_dialog .error "Alias Execution Error" "$errorInfo" error 0 Okay
				}
				set of {}
			}
		}
		if [regexp "^ *finger" $of] {
			regsub "^ *finger *" $of {} of
			finger $of
			continue
		}
		if [regexp "^ *multi" $of] {
			regsub "^ *multi" $of {} MULTI
			if [string length $MULTI] {
				wintalk .twid.text "Entering multi mode.\nType ! to exit multi.\n" {}
			} {
				wintalk .twid.text "Multi what?\n" {}
			}
			append MULTI " "
			continue
		}
		if [regexp "^ *!" $of] {
			if [string length $MULTI] {
				set MULTI {}
				wintalk .twid.text "Exiting multi mode.\n" {}
				continue
			}
		}
		set TX [expr $TX + [string length $of] +2]
		catch {puts $tprime "$MULTI$of"}
	}
}
catch {System::filesetup}
Preferences::setdefaults
Plugins::load
Preferences::load
eventsound START
if {$LOG == 1} {
	if {$tcl_platform(platform) == "unix"} {
		set fname [file join $env(HOME) ".tkturf/logs/[exec date]"]
		regsub -all " " $fname _ fname
		catch {set FILE [open $fname w]}
	}
	if {$tcl_platform(platform) == "windows"} {
		catch {open /tkturf/turflog a} FILE
	}
	if {$tcl_platform(platform) == "macintosh"} {
		catch {open ::tkturf:turflog a} FILE
	}
	catch {unset fname}
}
notify "Loading KDE Colors"
catch {KDE::LoadColors}
notify "Loading theme"
catch {option readfile [file join $BASEDIR "theme"]}
catch {option readfile /tkturf/theme}
catch {option readfile ~/.tkturf/theme}
if {$CKV == 0} {
	notify "Version Check OFF"
	after 750
} {catch {ConfirmVersion}}
notify "Main Interface"
MainInterFace
toplevel .boss
wm overrideredirect .boss 1
wm geometry .boss 3x3+0+0
button .boss.bg -command ::Boss::gone
pack .boss.bg
.boss config -cursor hand2
wm withdraw .boss
notify "Loading Help Texts"
set CHANGELOG {Changelog:
	
3.017
	Fixed bug in the Spool package which caused instant dequeuing and
		socket flooding
	Adjusted Spool package spooling speed
	Allowed variable args to Spool::enqueue
	Replaced "opponent" with the name of the opposing player for all places
		in all games
	Adjusted Spool dequeuing speed
	Added help on the autologging system to Help->Misc
	Improvements to tk_dialog function
	Fixed minor bug in alias setup scripting
	Revised the anonyingly asymmetrical Chess images
	Minor changes to font usage
3.015
	Fixed legacy bugs in many front-ends
3.014
	Prevented trigger repetition should a trigger need a wait call
	Improved efficiency of many functions
3.013
	Added option to suspend trigger execution
	Fixed bug to allow editing of Reversi colors after playing it
3.012
	Added Event based system to Plugin API for easier session management in
		plugins (Biff users should upgrade to Biff 2.7)
	Added notification of errors occuring during alias and trigger script
		execution
	Added F1 binding on all game windows to display the game help text
	Fixed en-passant bug in Chess
	Completed pawn special case rules in Chess
	Added proper logging of kills for en passant kills
	Adjusted the tolerance on logout time from 5 to 7 seconds
3.0
	Completely re-wrote the alias system.  Aliases are now completely
		scripted to allow arguments and more flexable actions
	Misc associated changes
	Added indication of which piece was killed to the chess move log window
	Fixed the bug causing chess not to work in 2.902
	Autologs are now in a more readable format (QuickStat users must
		upgrade to QuickStat 1.2 or logging will not work at all)
	Most help texts re-written and expanded
2.902
	Fixed bug causing early quit in Reversi
	Chess log box no longer takes focus
	Changed "yield" to "resign"
2.901
	Fixed bug snapping the destroy to grid in Battleship
	Added an option to ignore case when using tab completion
	Fixed control-h binding for hiding text
	Improved Return binding on buttons
	Improved Battleship with new spooling system
	Added message spooling system to TkTurf API
2.9
	Added colconfig front end
	Improved game challenge handshaking
	Improved quitting when link is down
	Improved session management
	Improved window centering
	Wrapped bug in Tk file dialog libs
	Fixed bug in find
2.84
	Substantially revised Preferences Window
	Sped up preferences applying significantly
	Streamlined alias-add interface
	Streamlined password-change interface
	Fixed minor alias bug
	Fixed API setting application bug
	Fixed ButtonNotebook widget packing problem
	Improved new version download counter
	Fixed Chess graphics bug
	Minor change to failed connection code
2.8361
	Boss-key restore window changes the cursor when the mouse is over it
	Increased code organization
	Added arrow/page key scrolling to help windows
	Extended Chess and Reversi help to include game introductions
	Chesslog shown by default now
	Added chesslog preference to applied preferences
	Minor Chess change
2.836
	Added chess move log option
	Made text window find default to find from bottom rather than top
	Re-arranged the preferences window a bit
	Minor preferences window fixes
	Autologin editor now correctly replaces edited and changed names
	Aliases now work with command stringing
	Slight adjustment to directory management
	Fixed extremely minor plugin loading bug
	Re-arranged Window menu
2.8353
	Fixed command stringing with ! (repeat) character bug (thanks to Zartid)
2.8352
	Ignore Games now ignores only new challenges
	Better cursor support in themed environments
2.8351
	Really fixed the font-load bug this time
2.835
	Fixed connection-refused finger bug
	Fixed null-site finger query bug
	Fixed font-preference loading bug
	Many tab-focus changes added
	Improved text search functions
	Windows dialogs now center
2.831
	Fixed minor reversi bug
	Added NOSERVER option (rcfile-only option)
2.83
	Fixed logging bug / other misc bugs
	Fixed font bugs / enhanced font configurability
	Fixed bug in revised new message code
2.822
	Improved new message notification (no notification if you can see
		the whole window, or if the window has focus)
2.821
	Improved UNIX autologging (logs to ~/.tkturf/logs/<datestamp>)
	Minor inter-connection fix
	Fixed small memory leaks
	Fixed some issues with the bosskey and dialogs
	Added optional Quit confirm dialog (damned roommate hitting keys...)
2.82
	Fixed crash bug in Session Management
2.811
	New Boss Key implementation (faster & more complete)
	Fixed Reversi typo
	Added ctrl-u binding to all entry widgets
	Fixed Control-g key collisions... oops
2.81
	Added Session Save preferences
	Fixed history scroller bug
2.8
	Fixed big windows and UNIX glitch
	Fixed Turf logo glitch relating to fonts
	Better macintosh support
	Added hidden entry text
	Better inter-session handling
}
set LOGGER {Logging:
	
TkTurf autologging automatically logs any text displayed in any window's text
area.  Logs in UNIX are stored in ~/.tkturf/logs/ by timestamp.  Logs under
Windows and MacOS are stored in /tkturf/turflog, as an append-based log.
}
set FLT {Message Filtering:
	
TkTurf allows you to filter certain types of information to a smaller, special
window.  To activate this feature go to the preferences window and activate
message filtering.  You may alter the use of this feature quickly, but not
permanently by using the Options menu and the Filter Flashing check box.
	
Next you have to select what sorts of messages you wish to filter to this
special window.  This is done by using the colconfig command on Turf. First
off you must have colour turned on (config +colour).  Then set the message
types you wish to have filtered to flashing <anycolor>, example:
	
	colconfig 7 flashing blue
	
This would set your personal tells to be filtered to the special window, which
might be useful if you happen to be running through rooms or in combat, to
ensure that you do not miss out on anything.
	
Key Bindings:
	Shift-PGUP : up one page
	Shift-PGDN : down one page
}
set C4 {Connect Four:
	
The object of connect four is to stack pieces so that you get for of your
pieces in a row (diagonal, horizontal, or vertical) before your opponent
does.  Click in any column to place your piece.}
set CHELP {Chess:
	
To move a chess piece click on it, and then click on the destination you would
like the piece to arrive at. The background behind a selected piece will
change colors to set it apart.
	
To castle in chess, select the king piece and click on the space right next to
the king's rook.
	
Game Help:
	
	Pawns: move one space forward (optionally two on the first move only).
		Attack on forward diagonals.  Pawns who reach the far row
		become queens.
	
	Rooks/Castles: move/attack any number of spaces vertically or
		horizontally.
	
	Knights: move/attack in L-patterns, one up/down, two right/left; or one
		right/left and two up/down.
	
	Bishops: move/attack any number of diagonal spaces.
	
	King: move/attack one in any direction.  Unmoved kings may castle to an
		unmoved rook.
	
	Queen: move/attack any number of spaces in any direction
}
set REVERH {Reversi:
	
The object of reversi is to have more of the pieces on the board be yours at
the end than the number than belongs to your opponent. To move you must "jump"
over one or more of your opponents pieces. You can not jump across blanks.
	
Strategy Help:
	
Since the object of the game is to end with more pieces than your opponent has
it is important to capture those spaces which can not be easily re-taken. 
Such spaces include the edges, and the corners.  It is important to carefully
consider what is to be gained before giving up a single corner.  This is
especially important if that corner can serve as a jumping point to the next
corner over.
	
The are two most common general strategies are: never giving up any edges, and
strategically giving up edges.  The first strategy is more likely to provide a
novice with luck, since it is fairly easy to take edges with brute force.  The
second strategy relies on the skill in setting up the other player in such a
manner that they are forced later in the game to surrender the whole board. 
This is the strategy of masters, and is quite difficult for novices.}
set BSHELP {Battleship:
	
To place pieces in Battleship use the left mouse button and drag them to the
desired area. Pieces will automatically snap to fit the grid.  To flip a piece
from vertical to horizontal or vice-versa, use the right mouse button, or
ctrl-click with the left mouse button on the piece you wish to flip.}
set TRI {Triggers v2.0
	
The triggers dialog gives you a listing of all existing triggers and the
option to create a new trigger, change an existing one, or delete the
highlighted trigger.  Note that editing an existing trigger and changing the
search string will create a clone of the trigger with the new search (if you
want to get rid of the old one you must delete it).  This is so that similar
triggers may be cloned easily.
	
TkTurf uses Perl and TCL/TK style regular expressions with nine substring match
buffers.  Here is a brief (and comprehensible) explanation of what you can do
with triggers and what the basics of regular expressions are.
Regular expression syntax defines the following special characters:
	
	][$^?+*()|\.
	
If you wish to use any of those as a literal symbol, you must "escape it" by
doing this "\?" which would mean a real question mark, or "\." which would
mean a real period.  If you want a real "\", you have to put "\\".
	
These special symbols let you do neat things with triggers, here is a summary
of what each special symbol means:
	
[] can be used to delimit a set of characters, for example [a-z] would match
any lower-case letter, and [a-z0-9] would match any lower case letter or
number. To use these they must be escaped UNLESS they are in parenthesis (i.e.
\[^ \] unless it is ([^ ])
	
^ can be combined with [] to say anything which does NOT match the pattern, for
example [^0-9] would match anything which was NOT a number, and [^ ] would
match anything which is not a space, and so on. It can also be used to bind a
trigger to the start of a line, for example "^You disappear" would match "You
disappear into the void." but not "Fastjack says 'You disappear.'"
	
$ can be used to bind text to the end of a line, such as "You disappear into
the void\.$" which would match "You disappear into the void." but not
"Fastjack says 'You disappear into the void.'"
	
? means zero or one of the previous character, for example, g? would mean zero
or one letter g's
	
* means zero or more of the previous character, y* would mean zero or any other
number of y's.  This is most useful with something such as [^ ]* which would
mean all characters which were not spaces (i.e. any one word)
	
() can be used to delimit a sub pattern, sub patterns will be saved into
buffers named 1-9, in the order in which the () sets appear.  For example
"([^ ]) throws a snowball at you\." would mean save whatever word is at the
start of that sentence and put it in buffer 1.  More on this later.
	
| can be used inside of () to say or, so (you|me) would match "you" or "me". 
You may have as many of these as you like inside a () set.
	
\ indicates an escape character, such as \[\], or any other escaped symbol such
as a literal  $ would be \$
	
Okay, now what can you do with all this garbage?  Here are some handy examples,
the trigger is on top, the reply action on the bottom:
	
	([^ ]*) throws a snowball at you\.
	send "snowball $1"
	
This trigger means *save the first word in the line* in buffer one, the reply
uses the saved word in buffer one to snowball the original thrower.  The
buffers can be used in this manner, by putting $1 or $2, $3, etc wherever you
want the information from any buffer.
	
You could also filter bombs...
	([^ ]*) gives you (a|an) (armed grenade|bomb|stick of dynamite)
	send "drop $3"
	send "glare $1"
	
This would scan for people giving you an armed grenade, or a bomb, or a stick
of dynamite and automatically drop it, and glare at the giver, by using buffers
1 and 3, as they are named from left to right.}
set ERR {TkTurf Errata:
	All:
		Having config +blank on will cause some client based features
			to feed blank lines into the window. This can not be
			fixed, as it relates to how Turf handles blanks and the
			client protocol.
	
	Windows:
		When highlighting something to copy the highlighting does not
			stay. You can still copy, however.}
set PRMPTS {To use multi-line prompts:
	
TkTurf goes over Turf's head to give you multi-line prompts to use this
feature just add a "\n" into your prompt configure command.  For example, this
would give you a two line prompt with your hit points on one row, and the room
name you are currently in in another:
	
	prompt %h/%H\n%R
	
This would be a three line showing hp and room on third line:
		
	prompt %h/%H\n\n%R
	
Regrettably, it is impossible for TkTurf to use the multi-line prompts which
Turf provides.  Using them will result in part of the prompt appearing in the
main text window.}
set ALS {Aliases:
	
Aliases are a way of shortening commands, such as "c 'cure light' who" which
are not exactly easy to type quickly during combat, or combining multiple
commands into one, such as making an alias named "junk" which will drop an
item and then sacrifice it.
	
Aliases in TkTurf are fully scripted in TCL, using the TkTurf API to help.
Help with scripting issues is available from the alias editor window.
	
As an example of creating an alias with an argument, such as a "junk" command
(a command to drop and sacrifice an item), you would enter the alias name as
"junk", and then, in the command body, you would type 'send "drop $1"' on the
first line, and then 'send "sac $1"' on the second.  To call this alias you
would just type "junk boot" and the alias would handle the rest.  Arguments in
aliases are named $1-$9, respective of their positions.  So, in an alias typed
as rescue sneezy sleepy dopey, $1 would be sneezy, $2 would be sleepy, and $3
would be dopey.
	
A note about aliases, if you don't want the alias to be triggered put a
space in the entry before the command, i.e. I have an alias "curse" and
there is an emote curse... curse as an alias casts a curse spell, but I
am talking and want to use the social, so i type " curse mtf" into the
entry to curse at Mtf.}
set CMDPIPE {Command Piping:
	
Enter "exec <command to execute>" and hold down meta (unix only) or control
(windows and UNIX) and hit return (while HOLDING control or meta).
	
Since command output is not generally in Turf command format it is useful to
use the Turf multi feature to do something constructive with this output. For
example, to chat a list of UNIX processes running:
		
	multi chat <Return>
	exec ps ax <Control-Return>*
		
*Note - an immortal will promptly warn you if you echo your entire process
list to chat...}
set MCS {To send multiple commands at once:
	
Let's say you want to go to Mtf's position, steal his gold, and go home before
he starts to toast you.  You could try to do it by typing the commands
normally, or, with tkturf you can type the following:
	
	goto mtf<press shift-return>steal coins from mtf<press
	shift-return>home<press return>*
	
When you finally press return without holding shift it will send all three
commands at once, and Turf will execute them instantly rather than having to
wait for you to type each one.
	
*Note: Mtf does not like having his gold stolen, especially sums of over 40
Million...}
set PLGS {Plugins:
	
The TkTurf plugin system allows anyone to distribute code patches which are
not part of the "official" distribution.  To use a plugin simply download it
and place it in C:\tkturf\plugins\ in Windows, or in a folder called
tkturf/plugins right inside the hard drive icon on a Mac, or in UNIX place
them in ~/.tkturf/plugins/.
	
TkTurf also allows system-wide plugins to be placed in the plugins directory,
which should be a subdirectory of whatever directory TkTurf is stored in (i.e.
/usr/local/tkturf/plugins)}
set DBG {Debugging Help:
	
It is often helpful in debugging for Fastjack to be able to execute commands
in your running copy of TkTurf. Most likely Fastjack will just want to see an
internal variable, but the command could be anything.  The first time each
session that Fastjack wants to use this feature it will query you with three
choices: accept, refuse, and warn. Accept means that you will always accept
debugging commands, refuse means you are refusing the request, and warn means
that each time Fastjack sends a debug command you will be shown the command
and asked if you would like to allow that specific command in that specific
instance.
	
At any time you may change the permission for debugging by using the
Connection->Statistics menu option.
	
The debugging feature is only available to Fastjack.
}
set BOSSKEY {The Boss/Librarian Key:
	
The boss key (ctrl-z) is a key which will make all of the TkTurf windows
disappear entirely.  To restore TkTurf click on the upper leftmost corner of
the screen (you might notice a 2x2 pixel box there, which is the target of
your click).  When the mouse is over the target the cursor should change to a
hand.  This will restore all the windows just as they were.
	
This feature may not work on some systems.  2.811+ features a newer
implementation.  Bosskey is now faster on hide and restore, hides all
non-iconified windows, and should work on all systems/window managers.} 
set SOUND {TkTurf Sounds:
	
TkTurf does not possess an inate ability to play sounds, and must therefore
depend on external command-line based programs to play sounds. The sound
preference specifies this player.  If you are using Windows, a suitable
command line player may be found at http://www.turf.org/tkturf/sound.exe.
Thanks to Ali for creating this program.
	
To set the sound player, go to Window->Preferences and select the Sound
button, then click in the blank box, which will pop up a file dialog for you
to select the appropriate file with.
	
Sounds are not available on Macintosh.}
set TCODE {TkTurf Action Scripting:
	
TkTurf uses TCL scripting for aliases and triggers, which allows tremendous
power and flexability, but does make it less easy to use. However, it is still
easy enough to use for simple actions.
	
To add text to send to Turf use the send command in quotes, like so:
	send "say Hello"
	
This would send "say Hello" to Turf.  Certain symbols must be preceeded by a
backslash, or they will not come out right (like this: \$), because these
symbols have special significance in the TCL language. Here is the list:
${}[]"';\
	
To add a sound to play, merely click the "Insert Sound" button. This will give
you a file dialog, which you simply select the sound to play with.
	
Advanced Use:
	
TkTurf allows any valid TCL statements, and provides nine possible
preconfigured variables ($1-$9) with text saved from the action (the parts of
the triggers in parenthesis, saved in order: see triggers help; or, in the case
of aliases, text provided after the alias as an argument).

Triggers also provide the variable $match, for the whole match, and aliases
provide $args for all the whole list of arguments.
	
The TkTurf API includes two function calls for ease of use, send {} and
playsound {}, which send text to Turf and play a sound, respectively.}
Plugins::install
wm deiconify .
Menu::deactivate .menubar.turf
Menu::deactivate .menubar.games
notify "Loading Aliases"
catch {source ~/.tkturf/aliases}
catch {source ::tkturf:aliases}
catch {source /tkturf/aliases}
Alias::makelist
Event::on LOGIN init_session
GetServerSock
GetSock
destroy .ad
trace variable FILTER w filterflick
#EOF
